/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


//Declaration de ma bibliotheque
#include "NDLSocket.h"

#ifdef _WIN32
    ioctlsocketDLLProc                  ioctlsocketNDL;
    gethostbynameDLLProc                gethostbynameNDL;
    gethostbyaddrDLLProc                gethostbyaddrNDL;
    htonsDLLProc                        htonsNDL;
	htonlDLLProc						htonlNDL;
    inet_ntoaDLLProc                    inet_ntoaNDL;
    inet_addrDLLProc                    inet_addrNDL;
    getpeernameDLLProc                  getpeernameNDL;
    setsockoptDLLProc                   setsockoptNDL;
    acceptDLLProc                       acceptNDL;
    bindDLLProc                         bindNDL;
    closesocketDLLProc                  closesocketNDL;
    connectDLLProc                      connectNDL;
    getsocknameDLLProc                  getsocknameNDL;
    listenDLLProc                       listenNDL;
    socketDLLProc                       socketNDL;
    recvDLLProc                         recvNDL;
    sendDLLProc                         sendNDL;
	selectDLLProc						selectNDL;
	getnameinfoDLLProc					getnameinfoNDL;

    WSAStartupDLLProc                   WSAStartupNDL;
    WSACleanupDLLProc                   WSACleanupNDL;
    WSACreateEventDLLProc               WSACreateEventNDL;
    WSAEventSelectDLLProc               WSAEventSelectNDL;
    WSAWaitForMultipleEventsDLLProc     WSAWaitForMultipleEventsNDL;
    WSACloseEventDLLProc                WSACloseEventNDL;
    WSAGetLastErrorDLLProc              WSAGetLastErrorNDL;

    HMODULE                             hLibraryWS32NDL = NULL;
        

long NDLOpen    ( void )
{
    WSADATA WSAData;
    long    i,j;

    //Librairie deja ouverte ?
    if (hLibraryWS32NDL!=NULL) return -2;

    //Chargement de la librairie
    hLibraryWS32NDL = LoadLibraryA ( "ws2_32.dll" );
    if (hLibraryWS32NDL==NULL) return -1;

    ioctlsocketNDL              = (ioctlsocketDLLProc)              GetProcAddress ( hLibraryWS32NDL, "ioctlsocket" );
    gethostbynameNDL            = (gethostbynameDLLProc)            GetProcAddress ( hLibraryWS32NDL, "gethostbyname" );
    gethostbyaddrNDL            = (gethostbyaddrDLLProc)            GetProcAddress ( hLibraryWS32NDL, "gethostbyaddr" );
    htonsNDL                    = (htonsDLLProc)                    GetProcAddress ( hLibraryWS32NDL, "htons" );
	htonlNDL					= (htonlDLLProc)					GetProcAddress ( hLibraryWS32NDL, "htonl" );
    inet_ntoaNDL                = (inet_ntoaDLLProc)                GetProcAddress ( hLibraryWS32NDL, "inet_ntoa" );
    inet_addrNDL                = (inet_addrDLLProc)                GetProcAddress ( hLibraryWS32NDL, "inet_addr" );
    getpeernameNDL              = (getpeernameDLLProc)              GetProcAddress ( hLibraryWS32NDL, "getpeername" );
    setsockoptNDL               = (setsockoptDLLProc)               GetProcAddress ( hLibraryWS32NDL, "setsockopt" );
    acceptNDL                   = (acceptDLLProc)                   GetProcAddress ( hLibraryWS32NDL, "accept" );
    bindNDL                     = (bindDLLProc)                     GetProcAddress ( hLibraryWS32NDL, "bind" );
    closesocketNDL              = (closesocketDLLProc)              GetProcAddress ( hLibraryWS32NDL, "closesocket" );
    connectNDL                  = (connectDLLProc)                  GetProcAddress ( hLibraryWS32NDL, "connect" );
    getsocknameNDL              = (getsocknameDLLProc)              GetProcAddress ( hLibraryWS32NDL, "getsockname" );
    listenNDL                   = (listenDLLProc)                   GetProcAddress ( hLibraryWS32NDL, "listen" );
    socketNDL                   = (socketDLLProc)                   GetProcAddress ( hLibraryWS32NDL, "socket" );
    recvNDL                     = (recvDLLProc)                     GetProcAddress ( hLibraryWS32NDL, "recv" );
    sendNDL                     = (sendDLLProc)                     GetProcAddress ( hLibraryWS32NDL, "send" );
	selectNDL					= (selectDLLProc)					GetProcAddress ( hLibraryWS32NDL, "select");

    WSAStartupNDL               = (WSAStartupDLLProc)               GetProcAddress ( hLibraryWS32NDL, "WSAStartup" );
    WSACleanupNDL               = (WSACleanupDLLProc)               GetProcAddress ( hLibraryWS32NDL, "WSACleanup" );
    WSACreateEventNDL           = (WSACreateEventDLLProc)           GetProcAddress ( hLibraryWS32NDL, "WSACreateEvent" );
    WSAEventSelectNDL           = (WSAEventSelectDLLProc)           GetProcAddress ( hLibraryWS32NDL, "WSAEventSelect" );
    WSAWaitForMultipleEventsNDL = (WSAWaitForMultipleEventsDLLProc) GetProcAddress ( hLibraryWS32NDL, "WSAWaitForMultipleEvents" );
    WSACloseEventNDL            = (WSACloseEventDLLProc)            GetProcAddress ( hLibraryWS32NDL, "WSACloseEvent" );
    WSAGetLastErrorNDL          = (WSAGetLastErrorDLLProc)          GetProcAddress ( hLibraryWS32NDL, "WSAGetLastError" );

    //Nombres alatoires
    srand( (unsigned)time( NULL ) );

    //On initialise la WINSOCKET
    i = MAKEWORD ( 2, 0 );  //Reconnaitre la version

    //Permet de demarrer les sockets windows avec notre Programme
    j = WSAStartupNDL ( ( unsigned short )i, &WSAData );

    return j;

}


long NDLClose   ( void )
{
    long    j;

    //Teste si la librairie a deja ete ouverte...
    if (hLibraryWS32NDL==NULL) return -1;

    //On ferme la WINSOCKET
    j = WSACleanupNDL();

    FreeLibrary ( hLibraryWS32NDL );
    hLibraryWS32NDL = NULL;

    return j;
}
#else
long NDLOpen    ( void )
{
    return 0;
}

long NDLClose   ( void )
{
    return 0;
}
#endif

