/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


//Declaration de ma bibliotheque
#include "NDLSocket.h"        

            

    //Les erreurs
    // -1 : Pas de donnees en attente
    // -2 : Erreurs dans les donnees recues
    long NDLReceiveData ( NETWORKDATALINK * pNDLClient, unsigned char *pIdTrame, unsigned char ** pBuffer, unsigned long * pBufferLength )
    {
        NETWORKDATALINK_HEADER  NDL_Header;
        unsigned char           *p;
        unsigned long           NeedsDataLength;
                 long           DataReceivedLength;

        //Taille de l'entete devant etre recu
        NeedsDataLength = sizeof ( NETWORKDATALINK_HEADER );

        //Pointeur sur le premier octet de l'entete
        p = (unsigned char *)&NDL_Header;

        //Reception de l'entete *********************************************************************************
        do {                         
            //Reception de donnees...
            DataReceivedLength = _NDLReceiveData ( pNDLClient->Socket, p, NeedsDataLength );

            //Cas 1 - On recoit rien, et on a rien recu pour l'instant
            if ((DataReceivedLength==0)&&(p==(unsigned char *)&NDL_Header))
                return -1;

            //Cas 3 et 4 - On recoit, mais on avait rien recu / on a deja recu
            if (DataReceivedLength!=0)
            {
                p               += DataReceivedLength;
                NeedsDataLength -= DataReceivedLength;
            }

        } while (NeedsDataLength>0);
        pNDLClient->RXBytes += sizeof ( NETWORKDATALINK_HEADER );

        //Reception des donnees *********************************************************************************
        NeedsDataLength     = NDL_Header.DataLength + NDL_Header.ZeroPaddingLength;

        //NDLWaitForReceiveData ( pNDLClient );

        if (NeedsDataLength>0)
        {
            *pBuffer            = (unsigned char *)KERNEL_ALLOC ( NeedsDataLength );
            *pBufferLength      = NDL_Header.DataLength;
            p                   = *pBuffer;
            do {                         
                //Reception de donnees...
                DataReceivedLength = _NDLReceiveData ( pNDLClient->Socket, p, NeedsDataLength );
        
                //On recoit quelque chose, on modifie les variables
                if (DataReceivedLength!=0)
                {
                    p                   += DataReceivedLength;
                    NeedsDataLength     -= DataReceivedLength;
                    pNDLClient->RXBytes += DataReceivedLength;
                }

            } while (NeedsDataLength>0);

            if (NDL_Header.DataLength==0)
            {
                KERNEL_FREE ( *pBuffer );
                *pBuffer = NULL;
            }
            else
                *pBuffer = (unsigned char *)KERNEL_REALLOC ( *pBuffer, NDL_Header.DataLength );


        }
        else
        {
            *pBuffer = NULL;
            *pBufferLength = 0;
        }

        //Stocke l'idtrame
        *pIdTrame = NDL_Header.IdTrame;

        return 0;
    }


    /*
    long NDLWaitForReceiveData2 ( NETWORKDATALINK * pNDLClient )
    {
        WSAEVENT    Event;
        DWORD       Back;
        long        Retour;
        long AvailableDataLength;
    
        //Lecture de la quantite de donnees dans la file d'attente d'entree
        AvailableDataLength = 0;
        do {
            Retour = ioctlsocket ( pNDLClient->Socket, FIONREAD, ( unsigned long *) &AvailableDataLength );
            if (Retour==SOCKET_ERROR) Sleep ( 1 );
        } while ((Retour==SOCKET_ERROR)||(AvailableDataLength==0));

        return 0;
    }
    */



    long NDLWaitForReceiveData ( NETWORKDATALINK * pNDLClient )
    {
        long        Retour;
#ifdef _WIN32
        WSAEVENT    Event;
        DWORD       Back;
        long        lCount;
        long        lWait;
#else

#endif

        Retour = 0;

#ifdef _WIN32
        //Creation d'un evenement
        Event = WSACreateEventNDL ( );

        //Initialisation de l'evenement
        WSAEventSelectNDL ( pNDLClient->Socket, Event, FD_READ );

        //Scrutation pour la reception
        Back = WSAWaitForMultipleEventsNDL ( 1, &Event, FALSE, 10, FALSE ); 
        if (Back==WSA_WAIT_TIMEOUT)
        {
            lWait = 0;
            lCount = 0;
            do {
                Sleep ( lWait );
                Back = WSAWaitForMultipleEventsNDL ( 1, &Event, FALSE, 0, FALSE ); 
                
                lWait = (lWait+1)+(lWait>>1);
                if (lWait>25) lWait = 25;
                
                lCount++;
                
                if ((Back==WSA_WAIT_TIMEOUT)&&(lCount>200))
                    Back = WSA_WAIT_FAILED;
                    
            } while (Back==WSA_WAIT_TIMEOUT);
        }

        switch (Back)
        {
            case WSA_WAIT_FAILED:
            default:
                Retour = -1;
                break;

            case WSA_WAIT_EVENT_0:
                Retour = 0;
                break;
        }

        //Fermeture de l'evenement
        WSAEventSelectNDL ( pNDLClient->Socket, Event, 0 );
        WSACloseEventNDL ( Event );
#else

#endif
        return Retour;
    }

