/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


//Declaration de ma bibliotheque
#include "NDLSocket.h" 

    #define MB(x) MessageBox(GetFocus(), x,"Debug",MB_OK)

    #define MX(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : 0x%08x", x);          \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  } 
    
    #define MI(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %d", x);              \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }
    #define ML(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %ld", x);             \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }


    #define _NDLSendData_MAXSIZE    2048

    long NDLSendData_WithBuffer ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame,
                       unsigned char * pBuffer, unsigned long BufferLength );

    long NDLSendData_Empty ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame );


    long NDLSendData ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame,
                       unsigned char * pBuffer, unsigned long BufferLength )
    {

        if ((pBuffer)&&(BufferLength))
            return NDLSendData_WithBuffer ( pNDLClient, IdTrame, pBuffer, BufferLength );
        else
            return NDLSendData_Empty ( pNDLClient, IdTrame );
    }



    long NDLSendData_Empty ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame )
    {
        NETWORKDATALINK_HEADER NDL_Header;
        unsigned char InternalBuffer[4096];
        unsigned long SizeInternal;
        //unsigned long OffsetInBuffer;
        //unsigned long TailleCopie;
        unsigned long TotalLength;

        //unsigned long SizeFirst;
        //unsigned long SizeNext;

        //_mDES_DebugTextA ( "NDLSendData.cpp : 1" );

        //Remplissage de l'entete
        memset ( &NDL_Header, 0, sizeof(NETWORKDATALINK_HEADER) );
        NDL_Header.IdTrame              = IdTrame;
        NDL_Header.DataLength           = 0;
        NDL_Header.ZeroPaddingLength    = 0;

        //_mDES_DebugTextA ( "NDLSendData.cpp : 2" );

        //On copie l'entete dans le tampon d'envoi interne
        memcpy ( InternalBuffer, &NDL_Header, sizeof ( NETWORKDATALINK_HEADER ) );
        SizeInternal = sizeof ( NETWORKDATALINK_HEADER );

        //_mDES_DebugTextA ( "NDLSendData.cpp : 3" );

        //Taille totale a envoyer
        TotalLength = SizeInternal;

        NDL_Header.ZeroPaddingLength = (unsigned short)((pNDLClient->MinimalFrameSize) - TotalLength);
        TotalLength += NDL_Header.ZeroPaddingLength;

        //On re-copie l'entete dans le tampon d'envoi interne
        memcpy ( InternalBuffer, &NDL_Header, sizeof ( NETWORKDATALINK_HEADER ) );

        //_mDES_DebugTextA ( "NDLSendData.cpp : 4" );

        //On envoi les donnees
        _NDLSendData ( pNDLClient->Socket, InternalBuffer, (pNDLClient->MinimalFrameSize) );
        pNDLClient->TXBytes += (pNDLClient->MinimalFrameSize);

        //_mDES_DebugTextA ( "NDLSendData.cpp : 5" );



        return 0;
    }




    long NDLSendData_WithBuffer ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame,
                       unsigned char * pBuffer, unsigned long BufferLength )

    {
        NETWORKDATALINK_HEADER NDL_Header;
        unsigned char InternalBuffer[4096];
        unsigned long SizeInternal;
        unsigned long OffsetInBuffer;
        //unsigned long TailleCopie;
        unsigned long TotalLength;

        unsigned long SizeFirst;
        unsigned long SizeNext;

        //Remplissage de l'entete
        memset ( &NDL_Header, 0, sizeof(NETWORKDATALINK_HEADER) );
        NDL_Header.IdTrame              = IdTrame;
        NDL_Header.DataLength           = BufferLength;
        NDL_Header.ZeroPaddingLength    = 0;

        //On copie l'entete dans le tampon d'envoi interne
        memcpy ( InternalBuffer, &NDL_Header, sizeof ( NETWORKDATALINK_HEADER ) );
        SizeInternal = sizeof ( NETWORKDATALINK_HEADER );

        //Taille totale a envoyer
        TotalLength = SizeInternal + BufferLength;

        //Devons-nous faire le ZeroPadding ?
        if (TotalLength<=((unsigned)pNDLClient->MinimalFrameSize))
        {
            NDL_Header.ZeroPaddingLength = (unsigned short)((pNDLClient->MinimalFrameSize) - TotalLength);
            TotalLength += NDL_Header.ZeroPaddingLength;

            //On re-copie l'entete dans le tampon d'envoi interne
            memcpy ( InternalBuffer, &NDL_Header, sizeof ( NETWORKDATALINK_HEADER ) );

            //Le buffer
            if (BufferLength)
            {
                if (pBuffer)
                    memcpy ( &InternalBuffer[SizeInternal], pBuffer, BufferLength );
                else
                    memset ( &InternalBuffer[SizeInternal], 0, BufferLength );
            }

            //On envoi les donnees
            _NDLSendData ( pNDLClient->Socket, InternalBuffer, (pNDLClient->MinimalFrameSize) );
            pNDLClient->TXBytes += (pNDLClient->MinimalFrameSize);
        }
        else
        {   
            //Generation du premier paquet : Cas ou il y a qu'un seul paquet de plus grande taille
            if ((TotalLength>((unsigned)pNDLClient->MinimalFrameSize))&&(TotalLength<=((unsigned)pNDLClient->MinimalFrameSize)*2))
            {
                if (BufferLength)
                {
                    if (pBuffer)
                        memcpy ( &InternalBuffer[SizeInternal], pBuffer, BufferLength );
                    else
                        memset ( &InternalBuffer[SizeInternal], 0, BufferLength );
                }
                SizeFirst = BufferLength + SizeInternal;
                SizeNext  = 0;
            }
            else
            {
                if (pBuffer) memcpy ( &InternalBuffer[SizeInternal], pBuffer, (pNDLClient->MinimalFrameSize)-SizeInternal );
                SizeFirst = pNDLClient->MinimalFrameSize;
                SizeNext = BufferLength - ((pNDLClient->MinimalFrameSize)-SizeInternal);
                OffsetInBuffer = ((pNDLClient->MinimalFrameSize)-SizeInternal);
            }

            //Envoi du premier paquet
            _NDLSendData ( pNDLClient->Socket, InternalBuffer, SizeFirst );

            //Envoi du second paquet
            if ((SizeNext)&&(pBuffer))
                _NDLSendData ( pNDLClient->Socket, &pBuffer[OffsetInBuffer], SizeNext );

            pNDLClient->TXBytes += SizeFirst + SizeNext;
            /*
            OffsetInBuffer = 0;
            do {
                //On tente de copier des eventuelles donnees
                TailleCopie = _NDLSendData_MAXSIZE - SizeInternal; //Espace disponible
                if (TailleCopie>BufferLength) TailleCopie = BufferLength;
                if (TailleCopie)
                {
                    memcpy ( &InternalBuffer[SizeInternal], &pBuffer[OffsetInBuffer], TailleCopie );
                    SizeInternal    += TailleCopie;
                    BufferLength    -= TailleCopie;
                    OffsetInBuffer  += TailleCopie;
                }

                _NDLSendData ( pNDLClient->Socket, InternalBuffer, SizeInternal );
                pNDLClient->TXBytes += SizeInternal;
                TotalLength         -= SizeInternal;
                SizeInternal = 0;

            } while ( TotalLength );
            */
        }


        /*

        //Devons-nous envoyer des donnees ?
        if (( pBuffer != NULL ) && ( BufferLength > 0 ))
        {                                                             
            OffsetInBuffer = 0;
            do {
                //Copie du tampon d'entree dans le tampon interne
                TailleCopie = _NDLSendData_MAXSIZE - SizeInternal;
                if (BufferLength<TailleCopie) TailleCopie = BufferLength;
                memcpy ( &InternalBuffer[SizeInternal], &pBuffer[OffsetInBuffer], TailleCopie );
                SizeInternal += TailleCopie;

                //Emission
                _NDLSendData ( pNDLClient->Socket, InternalBuffer, SizeInternal );

                //Met a jour les variables
                SizeInternal        = 0;
                OffsetInBuffer      += TailleCopie;
                BufferLength        -= TailleCopie;
                pNDLClient->TXBytes += TailleCopie;
            } while (BufferLength);
        }
        else
        {
            //ZeroPadding !
            if (SizeInternal<pNDLClient->MinimalFrameSize)
            {
                NDL_Header.ZeroPaddingLength = pNDLClient->MinimalFrameSize - SizeInternal;
                SizeInternal += NDL_Header.ZeroPaddingLength;
            }
            
            _NDLSendData ( pNDLClient->Socket, InternalBuffer, SizeInternal );
            pNDLClient->TXBytes += SizeInternal;
        }
        */
        return 0;
    }


    long NDLSendData_Old ( NETWORKDATALINK * pNDLClient, unsigned char IdTrame,
                       unsigned char * pBuffer, unsigned long BufferLength )

    {
        NETWORKDATALINK_HEADER NDL_Header;


        //Remplissage de l'entete
        NDL_Header.IdTrame      = IdTrame;
        NDL_Header.DataLength   = BufferLength;

        //Emission de l'entete
        _NDLSendData ( pNDLClient->Socket, ( unsigned char * ) &NDL_Header, sizeof ( NETWORKDATALINK_HEADER ));
        pNDLClient->TXBytes += sizeof ( NETWORKDATALINK_HEADER );

        //Emission des donnees
        if (( pBuffer != NULL ) && ( BufferLength > 0 ))
        {
            _NDLSendData ( pNDLClient->Socket, pBuffer, BufferLength );
            pNDLClient->TXBytes += BufferLength;
        }

        return 0;
    }

