/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/

//Declaration de ma bibliotheque
#include "NDLSocket.h"        

long _NDLReceiveData ( SOCKET Socket, unsigned char * pBufferData, long MaxDataToReceive )
{
    long AvailableDataLength;
    long NeedsDataLength;
    long ReceivedDataLength;
    
    //Lecture de la quantite de donnees dans la file d'attente d'entree
    AvailableDataLength = 4096;
    if ( ioctlsocketNDL ( Socket, FIONREAD, ( unsigned long *) &AvailableDataLength ) == SOCKET_ERROR )
    {
        //Sleep ( 10 );
        return 0; //-7;
    }

    //Longueur des donnees disponibles
    if ( AvailableDataLength != 0 )
    {
        //Determine la quantite de donnees (en octets) a recevoir
        if ( AvailableDataLength > MaxDataToReceive )   NeedsDataLength = MaxDataToReceive;
        else                                            NeedsDataLength = AvailableDataLength;

        //Reception des donnees
        ReceivedDataLength = recvNDL ( Socket, ( char * ) pBufferData, NeedsDataLength, 0 );

        //Erreur de reception
        if ( ReceivedDataLength != SOCKET_ERROR ) return ReceivedDataLength;
    }

    //Sleep ( 1 );
    return 0;
}
