/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#ifdef _WIN32
/*
    Pour Windows uniquement (Visual C++ 2008)
    On supprime tous les warnings en utilisant les fonctions CRT non securisees.
*/
#define _CRT_SECURE_NO_WARNINGS
#endif
    
    /*
    
    #include <windowsx.h>
    #include <winuser.h>
    #include <tchar.h>
    #include <stdio.h>
    #include <string.h>
    #include <conio.h>
    #include <direct.h>
    #include <stdlib.h>
    #include <commctrl.h>
    #include <fcntl.h>
    #include <io.h>
    #include <time.h>
    #include <math.h>
    #include <commdlg.h>
    #include <malloc.h>
    #include <winbase.h>
    */

    #ifdef _WIN32
        #include <windows.h>
        #include <io.h>
    #else
        #include <sys/socket.h>
        #include <netinet/in.h>
        #include <unistd.h>
        #include <sys/param.h>

    #ifndef TD_SOCKET
        typedef int SOCKET;
        #define TD_SOCKET
    #endif

    #ifndef TD_BOOL
        typedef long BOOL;
        #define TD_BOOL
    #endif
        
        #define INVALID_SOCKET     -1
        #define SOCKET_ERROR       -1
        
        #ifndef FALSE
        #define FALSE   (0)
        #endif
        
        #ifndef TRUE
        #define TRUE    (1)
        #endif
        
        #ifndef MAX_COMPUTERNAME_LENGTH
        #define MAX_COMPUTERNAME_LENGTH 31
        #endif
        
    #endif
    #include <malloc.h>
    #include <stdio.h>
    #include <string.h>
    #include "types.h"
    #include "RDBServerClientInterface.h"

    #ifndef _NDLSOCKETDEFINES
        #include "NDLSocketDefines.h"
        #define _NDLSOCKETDEFINES
    #endif

    
    /*
    #ifdef _mDES
        void    *   mDES_MemoryAllocA                    ( unsigned long lByteSize );
        void    *   mDES_MemoryReallocA                  ( void *p, unsigned long lByteSize );
        void        mDES_MemoryFreeA                     ( void *p );

        #define KERNEL_ALLOC(n)         mDES_MemoryAllocA(n)
        #define KERNEL_REALLOC(p,n)     mDES_MemoryReallocA(p,n)
        #define KERNEL_FREE(p)          mDES_MemoryFreeA(p)
    #else
        #define KERNEL_ALLOC(n)         malloc(n)
        #define KERNEL_REALLOC(p,n)     realloc(p,n)
        #define KERNEL_FREE(p)          free(p)
    #endif
    */
    
    //void * Z_Alloc ( unsigned long ulByteSize );
    //void Z_Free ( void * p );

    #define KERNEL_ALLOC(n)         Z_Alloc(n)
    #define KERNEL_REALLOC(p,n)     Z_Realloc(p,n)
    #define KERNEL_FREE(p)          Z_Free(p)

    void * Z_Alloc ( unsigned long ulByteSize );
    void Z_Free ( void *p );
    void * Z_Realloc ( void * p, unsigned long ulByteSize );

    /*
        Les droits

            Supervisor
                READ / WRITE / MODIFY / KILL / MAKE

            Read (un utilisateur peut lire et creer tout ce qu'il veut...)
                READ / MAKE


    */

    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions MemoryStream...
        Stockage et Lecture de donnees dans une zone memoire avec auto-allocation.

    */
    #ifndef __TRDBMemoryStream
        typedef struct {
            unsigned char * pBuffer;
            unsigned long BufferLength;
            unsigned long OffsetRead;
        } _TRDBMemoryStream;
        #define __TRDBMemoryStream
    #endif

    void            _RDBMemoryStreamOpen               ( _TRDBMemoryStream * pMS, unsigned char * pIfExistSourceBuffer );
    void            _RDBMemoryStreamClose              ( _TRDBMemoryStream * pMS );
    void            _RDBMemoryStreamAdd_UCHAR          ( _TRDBMemoryStream * pMS, unsigned char  Data );
    void            _RDBMemoryStreamAdd_USHORT         ( _TRDBMemoryStream * pMS, unsigned short Data );
    void            _RDBMemoryStreamAdd_ULONG          ( _TRDBMemoryStream * pMS, unsigned long  Data );
    void            _RDBMemoryStreamAdd_STRING         ( _TRDBMemoryStream * pMS, char * psz );
    void            _RDBMemoryStreamAdd_RAW            ( _TRDBMemoryStream * pMS, unsigned char * pData, unsigned long DataLength );
    unsigned char   _RDBMemoryStreamGet_UCHAR2         ( _TRDBMemoryStream * pMS );
    void            _RDBMemoryStreamGet_UCHAR          ( _TRDBMemoryStream * pMS, unsigned char  * pData );
    unsigned short  _RDBMemoryStreamGet_USHORT2        ( _TRDBMemoryStream * pMS );
    void            _RDBMemoryStreamGet_USHORT         ( _TRDBMemoryStream * pMS, unsigned short * pData );
    unsigned long   _RDBMemoryStreamGet_ULONG2         ( _TRDBMemoryStream * pMS );
    void            _RDBMemoryStreamGet_ULONG          ( _TRDBMemoryStream * pMS, unsigned long  * pData );
    void            _RDBMemoryStreamGet_STRING         ( _TRDBMemoryStream * pMS, char * pszOut );
    void            _RDBMemoryStreamGet_RAW            ( _TRDBMemoryStream * pMS, unsigned char ** pData, unsigned long *pDataLength );


    /*
        *********************************************************************************************************************

            Declaration de types de la base de donnees

        *********************************************************************************************************************
    */
    #define SRDB_HEADER_ID 0xFFA4B7F4
    #ifndef _SRDB_HEADER
        typedef struct {
            unsigned long   size;                       //Taille de l'entete
            unsigned long   ID;                         //SRDB_HEADER_ID
            unsigned long   Version;                    //1 (le 22 mai 2003)
            unsigned char   Compression;                //0 = off
            unsigned char   Defragged;                  //Indique si la base a ete defragmentee recemment
            char            szRDBName[64];
        } SRDB_HEADER;
        #define _SRDB_HEADER
    #endif

    #ifndef _SRDB
        typedef struct {
            SRDB_HEADER     Header;
            unsigned long   SupervisorOwnerID;          //Indique notre identifiant superviseur pour le mode exclusif (fourni par le serveur) sinon 0xFFFFFFFF

            unsigned char   szNetwork_ServerName[1024]; //Nom du serveur
            unsigned long   Network_PortNumer;          //Num�ro du port

            unsigned long   EntryDataBaseLength;
            unsigned char * pEntryDataBase;
        
            unsigned long   DataBaseLength;
            unsigned char * pDataBase;
        } SRDB;
        #define _SRDB
    #endif


    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions RDBEntry...
        Gestion de la base d'entree.

    */

    #ifndef _TRDB_ENTRY
        typedef struct {
            unsigned char   Identifiant;                //Identifiant (RDB_ID_xxxxxx)
            unsigned char   UseLastFullPathName;        //Indique qu'il faut recherche le precedent chemin complet pour avoir le chemin complet
                                                        //0 = Il s'agit bien d'un chemin complet
                                                        //1 = Chercher avant !
            unsigned long   FLAGS_ReadsCount;           //Indique le nombre de postes en cours de lecture (on ne peut donc pas ecrire)
            unsigned long   FLAGS_Supervisor;           //Indique l'identifiant du poste ayant tous les droits sinon 0xFFFFFFFF
            unsigned long   OffsetContent;              //Si OxFFFFFFFF, il s'agit simplement du point d'entree ou d'un repertoire
            char            FullPathName[2048];
        } TRDB_ENTRY;
        #define _TRDB_ENTRY
    #endif

    #define     ENTRYFLAG_EMPTY                 0xFFFFFFFF

    //Renvoi la position de l'entree recherchee
    #define     SEARCHMODE_STARTENTRY           0x01
    //Renvoi la position se situant juste apres l'entree recherchee
    #define     SEARCHMODE_AFTERENTRY           0x02
    //Pour les repertoires uniquement : Renvoi la position precedent l'entree de repertoire suivante
    #define     SEARCHMODE_BEFORENEXTENTRY      0x03
    //Pour les repertoires uniquement : Renvoi la position de l'entree du repertoire suivante
    #define     SEARCHMODE_TONEXTENTRY          0x04
    //Recherche d'un repertoire
    #define     SEARCHMODE_DIRECTORY            0x10
    //Recherche d'une donnee
    #define     SEARCHMODE_DATA                 0x20
    //Recherche en mode etendu (pour RDBDirectoryContentListEx)
    #define     SEARCHMODE_EXTENDED             0x40

    //Recupere une entree et/ou sa taille selon l'offset choisi
    long        RDBEntry_GetData        ( SRDB ** pRDB, unsigned long OffsetGet, TRDB_ENTRY * pRDBEntry, unsigned long * pSize );
    //Insertion d'une entree dans la base d'entrees
    long        RDBEntry_InsertData     ( SRDB ** pRDB, unsigned long OffsetSet, TRDB_ENTRY * pRDBEntry );
    //Creation d'un flux de donnees a partir d'une entree. On peut recuperer sa taille et/ou son adresse
    long        RDBEntry_MakeData       ( TRDB_ENTRY * pRDBEntry, unsigned long * pSize, unsigned char ** pStream );
    //Recherche d'un dossier/repertoire puissante
    long        RDBEntry_SearchName     ( SRDB ** pRDB, char * pszDirectoryName, char * pszSearchName, unsigned char SearchMode, unsigned long * pOffsetFound );
    //Suppression d'une entree
    long        RDBEntry_KillData       ( SRDB ** pRDB, unsigned long OffsetKill );

    //Fixer les flags d'une entree
    long        RDBEntry_SetFlag ( SRDB ** pRDB, unsigned long Offset, unsigned long FlagSupervisor, unsigned long FlagReadsCount );

    long        RDBEntry_KillSupervisor ( SRDB ** pRDB, unsigned long OwnerID );

    long        RDBEntry_KillAllFlags ( SRDB ** pRDB );

    long        RDBEntry_SetEntryOffsetContent ( SRDB ** pRDB, unsigned long Offset, unsigned long NewOffsetContent );

    //Compte le nombre de flags supervisor positionnes
    long        RDBEntry_QuerySupervisorFlags ( SRDB ** pRDB, long * plNbSupervisorSets );

    //Compte le nombre de flags readcount positionnes
    long        RDBEntry_QueryReadCountFlags ( SRDB ** pRDB, long * plNbReadCount );

    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions RDBData...
        Gestion de la base des donnees.

    */

    #ifndef _TRDB_DATA
        typedef struct {
            unsigned char       DataType;                   //Identifiant (RDB_ID_xxxxxx)
            unsigned long       CountOfElements;            //Nombre d'elements
            unsigned long       SizeOfOneElement;           //Nombre d'octets par element
            unsigned char       *pData;                     //Adresse des donnees
        } TRDB_DATA;
        #define _TRDB_DATA
    #endif

    //Insertion d'une entree dans la base d'entrees
    long RDBBase_InsertData ( SRDB ** pRDB, unsigned long OffsetSet, TRDB_DATA * pRDBData );

    //Recupere une entree et/ou sa taille selon l'offset choisi
    long RDBBase_GetData ( SRDB ** pRDB, unsigned long OffsetGet, TRDB_DATA * pRDBData, unsigned long * pSize );

    //Recupere l'offset des donnees
    long RDBBase_GetDataOffset ( SRDB ** pRDB, unsigned long OffsetGet, unsigned long * pDataOffset );

    //Creation d'un flux de donnees a partir d'une entree. On peut recuperer sa taille et/ou son adresse
    long RDBBase_MakeData ( TRDB_DATA * pRDBData, unsigned long * pSize, unsigned char ** pStream );

    long RDBBase_DefragData ( SRDB ** pRDB, unsigned long OffsetKilledData, unsigned long LengthKilledData );








    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions RDBDirectory...
        Gestion de la base des donnees.

    */

    #ifndef _SRDB_LIST
        typedef struct {
            char            szName[2048];               //Nom de l'entree trouvee
            unsigned char   Identifiant;                //Type d'entree (Repertoire, Fichier, Donnee... RDB_ID_xxxxx )
        } SRDB_LIST;
        #define _SRDB_LIST
    #endif

    #ifndef _SRDB_LISTEX
        typedef struct {
            char            szName[2048];               //Nom de l'entree trouvee
            unsigned char   Identifiant;                //Type d'entree (Repertoire, Fichier, Donnee... RDB_ID_xxxxx )
            unsigned long   lCountOfElements;           //Nombre d'elements
            unsigned long   lSizeOfOneElement;          //Nombre d'octets par element
            unsigned long   lTotalSize;                 //Taille totale en octet
        } SRDB_LISTEX;
        #define _SRDB_LISTEX
    #endif

    long                RDBMakeDirectory                ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName );
    long                RDBKillDirectory                ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName );
    long                RDBDirectoryContentList         ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LIST ** pList, unsigned long * pNbList );
    long                RDBDirectoryContentListEx       ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LISTEX ** pListEx, unsigned long * pNbList );




    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions RDBFile...
        Gestion des fichiers.

    */

    long                RDBMakeFile             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char * pFileData, unsigned long FileLength );
    long                RDBKillFile             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName );
    long                RDBReadFile             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char ** pFileData, unsigned long *pFileLength );

    /*
        ################################################################################################################
        ################################################################################################################
        ################################################################################################################

        Les fonctions RDBData...
        Gestion des fichiers.

    */
    long                RDBMakeData             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, 
                                                  unsigned char * pData, unsigned long SizeOfOneElement, unsigned long CountOfElements );
    long                RDBMakeDataEx           ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, 
                                                  unsigned char * pData, unsigned long SizeOfOneElement, unsigned long CountOfElements, long lIdentifiant );

    long                RDBKillData             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName );
    long                RDBReadData             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName,
                                                  unsigned char ** pData, unsigned long *pSizeOfOneElement, unsigned long *pCountOfElements );
    long                RDBWriteData            ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, unsigned char * pData, unsigned long SizeInBytes );

    long                RDBMakeData_long        ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, long Data );
    long                RDBReadData_long        ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName );
    long                RDBWriteData_long       ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, long Data );

    long                RDBWriteData_String     ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, char * pszData );
    long                RDBMakeData_String      ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, char * pszData );
    long                RDBReadData_String      ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, char ** pszData );

    long                RDBSupervisorSet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode );
    long                RDBSupervisorGet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBReadsCountSet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode );
    long                RDBReadsCountGet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );

    long                RDBDefragData           ( SRDB ** pRDB, unsigned long OffsetKill, unsigned long LengthKill );





    




    #define     RDB_ID_ROOT                 0x00

    #define     RDB_ID_DIRECTORY            0x10
    #define     RDB_ID_FILE                 0x11
    #define     RDB_ID_JUMPER               0x12
    #define     RDB_ID_DATA                 0x13

    #define     RDB_ID_UCHAR                0x20
    #define     RDB_ID_USHORT               0x21
    #define     RDB_ID_ULONG                0x22
    #define     RDB_ID_UWIDE                0x23
    #define     RDB_ID_CHAR                 0x30
    #define     RDB_ID_SHORT                0x31
    #define     RDB_ID_LONG                 0x32
    #define     RDB_ID_WIDE                 0x33
    #define     RDB_ID_FLOAT                0x40
    #define     RDB_ID_DOUBLE               0x41
    #define     RDB_ID_STRING               0x50


    #define     RDB_ACCESS_CLIENT_CONNECT           0x08
    #define     RDB_ACCESS_CLIENT_CONNECTEX         0x0B
    #define     RDB_ACCESS_CLIENT_DECONNECT         0x0A
    #define     RDB_ACCESS_CLIENT_TransmitID        0x07
    #define     RDB_ACCESS_CLIENT_TransmitName      0x06
    #define     RDB_ACCESS_CLIENT_WATCHDOG          0x09
    #define     RDB_ACCESS_CLIENT_GETVERSION        0x0C
    #define     RDB_ACCESS_SERVER_ACQ_BACK_MASK     0x80

    #define     RDB_ACCESS_CLIENT_INTERFACE_GETKEY                      0x60
    #define     RDB_ACCESS_CLIENT_INTERFACE_GETAUTH                     0x61
    #define     RDB_ACCESS_CLIENT_INTERFACE_SENDADMINMESSAGE            0x62
    #define     RDB_ACCESS_CLIENT_INTERFACE_SECURECMD                   0x63
    #define     RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP1    0x64
    #define     RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP2    0x65

    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_NONE          0x0000
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_A      0x0001
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_B      0x0002
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_C      0x0004
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_D      0x0008
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_A         0x0010
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_B         0x0020
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_C         0x0040
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_D         0x0080

    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_GetStats            0x0001
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_KillSession         0x0002
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBGetFileList      0x0003
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBLoadFile         0x0004
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBSaveFile         0x0005
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_GetVersion          0x0006
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_SetAdminPassword    0x0007
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserPassword     0x0008
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserFlag         0x0009
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserDescription  0x000A
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_GetUserInfo         0x000B
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_KillUser            0x000C
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBLoadFilePacket   0x000D
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBSaveFilePacket   0x000E
    #define     RDB_ACCESS_CLIENT_INTERFACE_SAM_SoftUpdate          0x0010

    long        RDBAccess_ClientSendAdminMessage ( 
                    unsigned long ulParamA, unsigned long ulParamB, 
                    char * pszParamText, 
                    unsigned char * pData, unsigned long lDataLen, 
                    unsigned char ** pDataOut, long * plLengthOut );

    long        RDBAccess_ClientSendAdminMessage_AB (
                    unsigned long ulParamA, unsigned long ulParamB, 
                    char * pszParamText_A, char * pszParamText_B, 
                    unsigned char * pData_A, unsigned long lDataLen_A,
                    unsigned char * pData_B, unsigned long lDataLen_B,
                    unsigned char ** pDataOut, long * plLengthOut );
    
    long            RDBAccess_ClientGetKey ( long lPasswordIndex, unsigned long dwInterfaceID, unsigned char ** pbFKey256, unsigned long * plLength );
    long            RDBAccess_ClientGetAuth ( unsigned char * pbAKey );
    
    long            RDBAccess_ClientResetAdminPassword_Step1 ( unsigned char * pbSHA512_a );
    long            RDBAccess_ClientResetAdminPassword_Step2 ( unsigned char * pbSHA512_a );
    
    long            RDBAccess_ClientGetUserInfo ( long lUserIndex, long * plFlag, char * pszDescription );
    long            RDBAccess_ClientSetUserFlag ( long lUserIndex, long lFlag );
    long            RDBAccess_ClientSetUserDescription ( long lUserIndex, char * pszDescription );
    long            RDBAccess_ClientSetUserPassword ( long lUserIndex, unsigned char * pbPasswordSHA512 );
    long            RDBAccess_ClientKillUser ( long lUserIndex );
    
    long            RDBAccess_ClientSetAdminPassword ( unsigned char * pbPasswordOldSHA512, unsigned char * pbPasswordNewSHA512 );
    
    long            RDBAccess_ClientSendSoftUpdate ( 
                        char * pszFileName, unsigned char * pFileData, unsigned long dwFileSize, 
                        char * pszScriptFileName, char * pszScriptData, long * plUpdateErrorStatus );

    #ifndef __JOCARESO_SERVER_INFO__
    #define __JOCARESO_SERVER_INFO__
    typedef struct {
        char szDaemonName[256];
        char szDaemonType[256];
        
        unsigned long dwProtocolRelease;
        unsigned char bVersionGen;
        unsigned char bVersionMajor;
        unsigned char bVersionMinor;
        
        unsigned char bFileOSLetter;
        
        unsigned char bRunModeState;    //0 = Run as a service/daemon 1 = Run as an application
        
        char szDaemonTextInfo[256];
        
        char szPathCurrent[1024];
        char szPathHome[1024];
        char szPathInstall[1024];
        char szExecRunApp[1024];
        
        char szServerIP[256];
        char szServerHostName[256];
        char szServerComputerName[256];
    
    } JOCARESO_SERVER_INFO;    
    #endif
    
    long RDBAccess_ClientGetServerInfo ( JOCARESO_SERVER_INFO * pInfo );
    
    //long            RDBAccess_ClientGetAuth ( unsigned long dwInterfaceID, unsigned char ** pbKey, unsigned long * plLength );

    /*
        Organisation en memoire

            ENTRYLIST
                -> Directory
                -> Adresse des DIRECTORY, FILE et DATA
            
            DATA
                -> TRDB_DIRECTORY
                -> TRDB_FILE
                -> TRDB_DATA
                -> TRDB_JUMPER

        
            Pour eviter de deplacer a chaque fois des zones, on utilise des jumpers. Lors de la suppression de donnees, ils viennent
            en remplacement, le temps que les donnees soient defragmentees.
    */

    /*
        Liste des identifiants

            0x00        Entree ROOT initiale dans la base de donnees
            
            0x10        Repertoire
            0x11        Fichier
            0x12        Jumper

            0x20        Donnees     unsigned char                            8 bits
            0x21        Donnees     unsigned short                          16 bits
            0x22        Donnees     unsigned long                           32 bits
            0x23        Donnees     unsigned wide / unsigned __int64        64 bits

            0x30        Donnees     char                                     8 bits
            0x31        Donnees     short                                   16 bits
            0x32        Donnees     long                                    32 bits
            0x33        Donnees     wide / __int64                          64 bits

            0x40        Donnees     float                                   32 bits
            0x41        Donnees     double                                  64 bits

    */

    #define         _TRDBACCESS_CLIENT          0x01
    #define         _TRDBACCESS_LOCAL           0x00

    extern          unsigned long _RDBAccessServerMode;

    #define         ID_RDBAccessNetwork_Accept                  0x10
    #define         ID_RDBAccessNetwork_Refuse                  0x11

    long            RDBAccess_ClientSendComputerName ( void );

    //*************************************************************************************
    #define         ID_RDBAccessNetwork_MakeDirectory           0x10
    #define         ID_RDBAccessNetwork_KillDirectory           0x11
    #define         ID_RDBAccessNetwork_DirectoryContentList    0x12
    #define         ID_RDBAccessNetwork_DirectoryContentListEx  0x13

    long            RDBAccess_ClientMakeDirectory               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName );
    long            RDBAccess_ClientKillDirectory               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName );
    long            RDBAccess_ClientDirectoryContentList        ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LIST ** pList, unsigned long * pNbList );
    long            RDBAccess_ClientDirectoryContentListEx      ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LISTEX ** pListEx, unsigned long * pNbList );

    //*************************************************************************************
    #define         ID_RDBAccessNetwork_MakeFile                0x18
    #define         ID_RDBAccessNetwork_KillFile                0x19
    #define         ID_RDBAccessNetwork_ReadFile                0x1A

    long            RDBAccess_ClientMakeFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char * pFileData, unsigned long FileLength );
    long            RDBAccess_ClientKillFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName );
    long            RDBAccess_ClientReadFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char ** pFileData, unsigned long *pFileLength );

    //*************************************************************************************
    #define         ID_RDBAccessNetwork_MakeData                0x20
    #define         ID_RDBAccessNetwork_KillData                0x21
    #define         ID_RDBAccessNetwork_ReadData                0x22
    #define         ID_RDBAccessNetwork_WriteData               0x23

    long            RDBAccess_ClientMakeData                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, 
                                                                  unsigned char * pData, unsigned long SizeOfOneElement, unsigned long CountOfElements );
    long            RDBAccess_ClientKillData                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName );

    long            RDBAccess_ClientReadData                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName,
                                                                  unsigned char ** pData, unsigned long *pSizeOfOneElement, unsigned long *pCountOfElements );
    long            RDBAccess_ClientWriteData                   ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, 
                                                                  unsigned char * pData, unsigned long SizeInBytes );


    #define         ID_RDBAccessNetwork_SupervisorSet           0x30
    #define         ID_RDBAccessNetwork_SupervisorGet           0x31
    #define         ID_RDBAccessNetwork_ReadsCountSet           0x32
    #define         ID_RDBAccessNetwork_ReadsCountGet           0x33

    long            RDBAccess_ClientSupervisorSet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode );
    long            RDBAccess_ClientSupervisorGet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long            RDBAccess_ClientReadsCountSet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode );
    long            RDBAccess_ClientReadsCountGet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );



    long            _RDBSetJumper                   ( SRDB ** pRDB, unsigned long Offset, unsigned long Size );
    long            _RDBEntryAdd                    ( SRDB ** pRDB, TRDB_ENTRY *pRDBEntry, unsigned long OffsetInsert );
    long            _RDBEntrySet                    ( SRDB ** pRDB, TRDB_ENTRY *pRDBEntry, unsigned long Offset );
    long            _RDBEntryGet                    ( SRDB ** pRDB, TRDB_ENTRY *pRDBEntry, unsigned long OffsetStart );
    
    unsigned long   _RDBFindEntryRootOffset         ( SRDB ** pRDB, char * pszRootDirectoryName );
    unsigned long   _RDBFindAfterEntryRootOffset    ( SRDB ** pRDB, char * pszRootDirectoryName );
    unsigned long   _RDBFindEntryRootToDataOffset   ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName );
    long            _RDBGetDataSize                 ( SRDB ** pRDB, unsigned long Offset );
    long            _RDBGetDataSizeID               ( unsigned char Identifiant );
    long                _RDBGetDataBuffer               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, unsigned char Identifiant, unsigned char *pBuffer, unsigned long *pSizeOfOneElement, unsigned long *pCountOfElements );
    long                _RDBSetDataBuffer               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, unsigned char Identifiant, unsigned char *pBuffer, unsigned long SizeInBytes );
    long                _RDBFlagIsSupervisorProtected   ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                _RDBFlagIsRead                  ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );

    void                _RDBSetError                    ( long ErrorCode );
    
    
    //********************************************************************************************************************************************
    //********************************************************************************************************************************************
    long                RDBCreate               ( SRDB ** pRDB, char * pszBaseName );
    long                RDBDelete               ( SRDB ** pRDB );
    long                RDBSave                 ( SRDB ** pRDB );
    long                RDBLoad                 ( SRDB ** pRDB, char * pszBaseName );
    long                RDBFindFileList         ( SRDB_HEADER ** pEntryData, long * plEntryCount );
    long                RDBLoadAsRaw            ( char * pszBaseName, unsigned char ** pData, long * plDataLen );
    long                RDBSaveFromRaw          ( char * pszBaseName, unsigned char * pData, long lDataLen );
    
    long                RDBLoadAsRawPacket      ( char * pszBaseName, long * plFileLen, long lBlockByteOffset, long lBlockSizeMax, unsigned char * pBlockData, long * plBlockDataLen );
    long                RDBSaveFromRawPacket    ( char * pszBaseName, long lBlockByteOffset, unsigned char * pBlockData, long lBlockDataLen );




    //********************************************************************************************************************************************
    //********************************************************************************************************************************************
    //Gestion des drapeaux/droits d'acces
    long                RDBFlagSupervisorCapture        ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagSupervisorRelease        ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagIncrRead                 ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagDecrRead                 ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagIsSupervisorProtected    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagIsRead                   ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName );
    long                RDBFlagWhileBlock               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, long (* RDBFlagGet) ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName ) );

    
    
    



    long                RDBAccess_OpenLocal             ( void );
    long                RDBAccess_CloseLocal            ( void );


    //Les fonctions client d'acces a la base de donnees
    long                RDBAccess_OpenClient            ( char * pszServerName, long Port, long NagleOverRideLength, char * pszPassword, long lTryAdminMode, long lEnableCompatibilityMode );
    long                RDBAccess_CloseClient           ( void );
    long                RDBAccess_Client_ConnectToServer    ( char * pszServerName, long Port, long NagleOverRideLength, char * pszPassword, long lTryAdminMode, long lEnableCompatibilityMode );
    long                RDBAccess_Client_DeConnectToServer  ( void );
    long                RDBAccess_Client_GetCurrentCompatibilityMode ( void );

    long                RDBAccess_ClientCreate          ( SRDB ** pRDB, char * pszBaseName );
    long                RDBAccess_ClientDelete          ( SRDB ** pRDB );
    long                RDBAccess_ClientSave            ( SRDB ** pRDB );
    long                RDBAccess_ClientLoad            ( SRDB ** pRDB, char * pszBaseName );

    long                RDBAccess_ClientEnterAuthLink ( char * pszUserPassword, long lServerSidePasswordIndex );
    

    //Gestion des erreurs
    long                RDBGetLastError                 ( void );
    /*

        Fonctions de lecture de donnees/fichiers/entrees/repertoires
            Lectures multiples possibles sur le serveur a condition que la fonction exclusive n'est pas active.
        
        Fonctions d'ecriture de donnees/fichiers
            Ecriture simple possible : mise en place de la fonction exclusive.

        Fonctions de suppression de donnees/fichiers/entrees/repertoire
            Destruction simple possible : mise en place de la fonction exclusive.

        Fonctions de creation de donnees/fichiers
            Creation simple possible : mise en place de la fonction exclusive.


            

    */
    
    
    //********************************************************************************************************************************************
    //********************************************************************************************************************************************
    //Routine de gestion des messages pour le serveur
    long                ServerMessage                   ( NETWORKDATALINK * pNDLClient, SCISTATE * psciState, SRDB ** pRDBBase, unsigned long NbMaxBases, unsigned long * pElapsedTime );
    long                ServerMessageManage             ( NETWORKDATALINK * pNDLClient, SCISTATE * psciState, SRDB ** pRDBBase, unsigned long NbMaxBases, unsigned long * pElapsedTime,
                                                          unsigned char IdTrame, unsigned char *pInData, unsigned long InLength, DWORD dwTimeStart );
    void                ServerKillSession ( NETWORKDATALINK * pNDLClient, SRDB ** pRDBBase, unsigned long NbMaxBases );


