/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


    #include "RDB.h"
    #include "RDBAccess.h"
    #include "sha2.h"

    #if !defined(_RDBSERVER) && !defined(_mDES) && !defined(_WGINSTALL)
        #ifndef OSI_SOURCE_INCLUDE
            #define OSI_SOURCE_INCLUDE
            //#include "OSIndependent.cpp"
            //#include "OSIndependent_Thread.cpp"
            //#include "OSIndependent_CriticalSection.cpp"
            //#include "OSIndependent_Tick.cpp"
            //#include "OSIndependent_Sleep.cpp"
            //#include "OSIndependent_ScreenSaver.cpp"
        #endif
    #endif


    #define     _TRDBACCESS_CLIENT          0x01
    #define     _TRDBACCESS_LOCAL           0x00

    unsigned long               _RDBAccessServerMode                = _TRDBACCESS_LOCAL;
    unsigned long               _RDBAccessServerCompatibilityMode   = 0;


    CRITICALSECTION        CriticalSection_RDBAccess;
    THREAD                 Thread_RDBAccess;
    SCREENSAVER            ScreenSaver;
    extern  SCISTATE       _sciStateClient;

    long                        __RDBAccess_WatchdogThread ( void * pProcData );


    long    RDBAccess_OpenLocal ( void )
    {
        _RDBAccessServerMode = _TRDBACCESS_LOCAL;
        return 0;
    }

    long    RDBAccess_CloseLocal ( void )
    {
        return 0;
    }

    long    RDBAccess_OpenClient ( char * pszServerName, long Port, long NagleOverRideLength, char * pszPassword, long lTryAdmin, long lEnableCompatibilityMode )
    {
        long lReturn;
        _RDBAccessServerMode = _TRDBACCESS_CLIENT;

        CriticalSectionCreate ( &CriticalSection_RDBAccess );

        lReturn = RDBAccess_Client_ConnectToServer ( 
            pszServerName, 
            Port, 
            NagleOverRideLength, 
            pszPassword,
            lTryAdmin,
            lEnableCompatibilityMode );

        if (!lReturn)
        {
            ThreadCreate ( 
                &Thread_RDBAccess, 
                __RDBAccess_WatchdogThread, 
                0, 
                NULL );

            ScreenSaverManagerOpen ( &ScreenSaver );
            ScreenSaverManagerSet ( &ScreenSaver, 0, 0 );
        }

        return lReturn;
    }

    long    RDBAccess_OpenClientSimple ( char * pszServerName, long Port, long NagleOverRideLength, char * pszPassword, long lTryAdmin, long lEnableCompatibilityMode )
    {
        long lReturn;
        _RDBAccessServerMode = _TRDBACCESS_CLIENT;

        CriticalSectionCreate ( &CriticalSection_RDBAccess );

        lReturn = RDBAccess_Client_ConnectToServer ( 
            pszServerName, 
            Port, 
            NagleOverRideLength, 
            NULL,
            1,
            0 );

        if (!lReturn)
        {
            ThreadCreate ( 
                &Thread_RDBAccess, 
                __RDBAccess_WatchdogThread, 
                0, 
                NULL );
            
            ScreenSaverManagerOpen ( &ScreenSaver );
            ScreenSaverManagerSet ( &ScreenSaver, 0, 0 );
        }

        return lReturn;
    }


    long    RDBAccess_CloseClient ( void )
    {
        ThreadDelete ( &Thread_RDBAccess, 2000 );
        CriticalSectionDelete ( &CriticalSection_RDBAccess );
        ScreenSaverManagerClose ( &ScreenSaver );
        return RDBAccess_Client_DeConnectToServer ( );
    }

    #ifdef _mDES
    void _mDES_DebugTextA ( char * pszText );
    #endif

    long __RDBAccess_WatchdogThread ( void * pProcData )
    {
        do {
            RDBAccess_UnsecureClientDialogToServer ( RDB_ACCESS_CLIENT_WATCHDOG, NULL, 0, NULL, NULL );
            
            //Attente de 10 secondes            
            SleepSet ( 1500 );

            /*
            sprintf ( szTmp, "RDBAccess.cpp : TSC 0x%08x", GetTickCount() );

            #ifdef _mDES
            _mDES_DebugTextA ( szTmp );
            #endif
            */
            /*
            RDBAccess_WrapCDTS ( RDB_ACCESS_CLIENT_WATCHDOG,    //ID de communication
                                             NULL, 0,
                                             NULL, NULL );
            */                                 
            

        } while (ThreadDoWhileAndWaitExit(pProcData));

        return 0;
    }



    long RDBAccess_ClientEnterAuthLink ( char * pszUserPassword, long lServerSidePasswordIndex )
    {
        long            lRetourRDBAccess;
        //unsigned char   *pbFKey;
        //unsigned long   ulSizeFKey;
        unsigned char   bPasswordSHA512[64];
        
        unsigned char   *pbBKey;
        unsigned long   ulSizeBKey;
    
        DWORD dwInterfaceID;
        
        ServerClientInterface_Init ( &(_sciStateClient.sciLink) );
        
        //Generation de la clef du mot de passe PKey
        //ServerClientInterface_MakePKey ( &(_sciStateClient.sciLink), pszUserPassword );
        
        //Generation d'un ID pour l'interface et IKey
        ServerClientInterface_UpdateSeed ( &(_sciStateClient.sciLink), TickGetCount2() );
        ServerClientInterface_UpdateSeed ( &(_sciStateClient.sciLink), *((unsigned long *)pszUserPassword) );
        ServerClientInterface_GetRand ( &(_sciStateClient.sciLink), &dwInterfaceID );
        
        /*
        
        pbFKey = NULL;
        ulSizeFKey = 0;
        lRetourRDBAccess = RDBAccess_ClientGetKey (
            lServerSidePasswordIndex, 
            dwInterfaceID,
            &pbFKey,
            &ulSizeFKey );

        //FKey invalide
        if (ulSizeFKey!=256)
        {
            KERNEL_FREE ( pbFKey );
            ulSizeFKey = 0;
        }

        //La commande est inconnue ou une erreur est survenue
        if ((lRetourRDBAccess)||(!ulSizeFKey))
        {
            dwInterfaceID = 0;
            //strcpy ( GlobalData.szLastError, "Le serveur ne repond pas a la demande d'authentification (GetFKey)" );
            RDBAccess_CloseClient ( );
            return -3;
        }
        */
        
        /*
        ** Generation de la valeur aleatoire (FKey)
        */
        ServerClientInterface_MakeFKey ( &(_sciStateClient.sciLink) );

        /*
        ** Generation de la clef du mot de passe (PKey)
        */
        if (pszUserPassword) sha512 ( pszUserPassword, (unsigned long)strlen(pszUserPassword), bPasswordSHA512 );
        else memset ( bPasswordSHA512, 0, 64 );
        ServerClientInterface_MakePKey ( &(_sciStateClient.sciLink), bPasswordSHA512 );
        memset ( bPasswordSHA512, 0, 64 );
    
        /*
        ** Generation de AKey = ( FKey ^ PKey )
        */
        ServerClientInterface_MakeAKey ( &(_sciStateClient.sciLink) );

        //On demande la clef...        
        pbBKey = NULL;
        ulSizeBKey = 0;
        lRetourRDBAccess = RDBAccess_ClientGetKey (
            lServerSidePasswordIndex,                         //Mot de passe admin
            dwInterfaceID,
            &pbBKey,
            &ulSizeBKey );
        
        //BKey invalide
        if (ulSizeBKey!=256)
        {
            KERNEL_FREE ( pbBKey );
            ulSizeBKey = 0;
        }

        //La commande est inconnue ou une erreur est survenue
        if ((lRetourRDBAccess)||(!ulSizeBKey))
        {
            dwInterfaceID = 0;
            RDBAccess_CloseClient ( );
            return -3;
        }
        
        /*
        ** On a recu la BKey, on va creer la GKey
        */
        ServerClientInterface_MakeGKey ( &(_sciStateClient.sciLink), pbBKey );
        
        /*
        ** On peut maintenant creer la TxRxKey
        */
        ServerClientInterface_MakeTxRxKey ( &(_sciStateClient.sciLink) );
        
        //On demande l'authentification
        lRetourRDBAccess = RDBAccess_ClientGetAuth ( 
            ServerClientInterface_GetAKey ( &(_sciStateClient.sciLink) ) );
        
        //Authentification impossible : Mot de passe invalide
        if (lRetourRDBAccess)
        {
            dwInterfaceID = 0;
            RDBAccess_CloseClient ( );
            return -4;
        }
        
        //Test de la trame crypte
        //lRetourRDBAccess = RDBAccess_ClientSendAdminMessage ( 0, 0, NULL, NULL, 0, NULL, NULL );
        lRetourRDBAccess = RDBAccess_SecureClientDialogToServer ( 0, NULL, 0, NULL, NULL );
        if (lRetourRDBAccess)
        {
            dwInterfaceID = 0;
            RDBAccess_CloseClient ( );
            return -4;
        }
        
        /*
        

        //Generation de IKey
        ServerClientInterface_MakeIKey ( &(_sciStateClient.sciLink), dwInterfaceID );    
        ServerClientInterface_UpdateSeed ( &(_sciStateClient.sciLink), TickGetCount2() );
        ServerClientInterface_GetRand ( &(_sciStateClient.sciLink), &dwInterfaceID );

        //Recuperation de FKey
        ServerClientInterface_SetFKey ( &(_sciStateClient.sciLink), pbFKey );
        KERNEL_FREE ( pbFKey );

        //Generation de AKey
        ServerClientInterface_MakeAKey ( &(_sciStateClient.sciLink) );

        lRetourRDBAccess = RDBAccess_ClientGetAuth ( 
            ServerClientInterface_GetAKey ( &(_sciStateClient.sciLink) ) );

        //Authentification impossible : Mot de passe invalide
        if (lRetourRDBAccess)
        {
            dwInterfaceID = 0;
            //strcpy ( GlobalData.szLastError, "Authentification impossible : Mot de passe invalide (Wrong AKey)" );
            RDBAccess_CloseClient ( );
            return -4;
        }

        ServerClientInterface_MakeTxRxKey ( &(_sciStateClient.sciLink) );

        //Test de la trame crypte (cela fonctionne en mode admin et en mode user !)
        //lRetourRDBAccess = RDBAccess_ClientSendAdminMessage ( 0, 0, NULL, NULL, 0, NULL, NULL );
        lRetourRDBAccess = RDBAccess_SecureClientDialogToServer ( 0, NULL, 0, NULL, NULL );
        if (lRetourRDBAccess)
        {
            dwInterfaceID = 0;
            //strcpy ( GlobalData.szLastError, "Erreur de cryptage : La transmission de donnees cryptees a echoue" );
            RDBAccess_CloseClient ( );
            return -5;
        }
        
        //La connection est active !
        ServerClientInterface_SetStateIdentifiant ( 
            &(_sciStateClient.sciLink),
            1,
            dwInterfaceID );
            
        //strcpy ( GlobalData.szAddressServer, pszAddress );
        //GlobalData.lPortServer      = lPort;
        //GlobalData.lConnectInUse    = 1;
        
        */
        
        return 0;
    }
