/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


    #include "RDB.h"
    #include "RDBAccess.h"
    #include "RDBServerClientInterface.h"
    #include "sha2.h"
    
    

    extern  NETWORKDATALINK     _NDLClient;
    extern  SCISTATE            _sciStateClient;
    extern  long                _RDBAccessServerCompatibilityMode;

    #define MB(x) MessageBox(GetFocus(), x,"Debug",MB_OK)

    #define MX(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : 0x%08x", x);          \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  } 
    
    #define MI(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %d", x);              \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }
    #define ML(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %ld", x);             \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }
                  
    //#define RDBAccess_ClientDialogToServer      RDBAccess_UnsecureClientDialogToServer                  
    //#define RDBAccess_WrapCDTS      RDBAccess_SecureClientDialogToServer

    //void _mDES_DebugTextA ( char * pszText );
    
    
    long    RDBAccess_WrapCDTS ( unsigned char InID, unsigned char * pInBuffer, unsigned long InLength,
                                 unsigned char ** pOutBuffer, unsigned long * pOutLength )
    {
        if (!_RDBAccessServerCompatibilityMode)
            return RDBAccess_SecureClientDialogToServer ( InID, pInBuffer, InLength, pOutBuffer, pOutLength );
        else
            return RDBAccess_UnsecureClientDialogToServer ( InID, pInBuffer, InLength, pOutBuffer, pOutLength );
    
    }                                                 

    /*
      ################################################################################################################
      ################################################################################################################
      ################################################################################################################
    */
    long    RDBAccess_UnsecureClientDialogToServer ( unsigned char InID, unsigned char * pInBuffer, unsigned long InLength,
                                                     unsigned char ** pOutBuffer, unsigned long * pOutLength )
    {
        long            lRetour;
        unsigned long   ReceiveLength;
        unsigned char   ReceiveID;
        unsigned char   *pReceiveBuffer=NULL;

        //_mDES_DebugTextA ( "RDBAccessClientDialog.cpp : 0" );

        //Section critique
        CriticalSectionEnter ( &CriticalSection_RDBAccess );

        //_mDES_DebugTextA ( "RDBAccessClientDialog.cpp : 1" );

        //Emission du flux
        NDLSendData ( &_NDLClient, InID, pInBuffer, InLength );

        //_mDES_DebugTextA ( "RDBAccessClientDialog.cpp : 2" );

        //C'est une trame Watchdog ? pas de retour !
        if (InID==RDB_ACCESS_CLIENT_WATCHDOG)
        {
            lRetour = 0;
        }
        else
        {
            //Avons-nous des donnees en attente
            lRetour = NDLWaitForReceiveData ( &_NDLClient );
            //lRetour = 0;
            //SleepSet ( 200 );          
            if (!lRetour)
            {

                //Reception des donnees
                lRetour = NDLReceiveData ( &_NDLClient, &ReceiveID, &pReceiveBuffer, &ReceiveLength );
                if (!lRetour)
                {
                    //Le serveur nous renvoit-il une acception des donnees
                    if (ReceiveID==ID_RDBAccessNetwork_Accept)
                    {
                        if (pOutBuffer)             *pOutBuffer = pReceiveBuffer;
                        else if (pReceiveBuffer)    KERNEL_FREE ( pReceiveBuffer );
                        if (pOutLength)             *pOutLength = ReceiveLength;
                        lRetour = 0;
                    }
                    else
                    {
                        if (pReceiveBuffer)    KERNEL_FREE ( pReceiveBuffer );
                        lRetour = 1;
                    }

                }            
            }
        }

        //_mDES_DebugTextA ( "RDBAccessClientDialog.cpp : 3" );
        
        CriticalSectionLeave ( &(CriticalSection_RDBAccess) );

        return lRetour;
    }

    long    RDBAccess_ClientSendComputerName ( void )
    {
        _TRDBMemoryStream  MS;
        char *          lpBuffer;
        DWORD           nSize;
        long            Retour;



#ifdef _WIN32
        nSize = MAX_COMPUTERNAME_LENGTH+1;
        lpBuffer = (char *)Z_Alloc ( nSize );
        Retour = GetComputerNameA ( lpBuffer, &nSize );
#else
        nSize = MAXHOSTNAMELEN;
        lpBuffer = (char *)Z_Alloc ( nSize );
        Retour = gethostname ( lpBuffer, nSize );
        Retour = (Retour!=-1)?(1):(0);
#endif
        if (Retour)
        {
            //Creation du flux
            _RDBMemoryStreamOpen ( &MS, NULL );
            _RDBMemoryStreamAdd_STRING ( &MS, lpBuffer );
        
            //Communication Client/Serveur
            Retour = RDBAccess_WrapCDTS ( RDB_ACCESS_CLIENT_TransmitName,    //ID de communication
                                                      MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                      NULL, NULL );                         //Tampon de donnees de retour
            //Fermeture du flux
            _RDBMemoryStreamClose ( &MS );

        }
        Z_Free ( lpBuffer );



        return 0;
    }
    

    //################################################################################################################
    long    RDBAccess_ClientMakeDirectory ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDirectoryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_MakeDirectory,    //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long    RDBAccess_ClientKillDirectory ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDirectoryName )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDirectoryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_KillDirectory,    //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long RDBAccess_ClientDirectoryContentList ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LIST ** pList, unsigned long * pNbList )
    {
        _TRDBMemoryStream  MS;
        _TRDBMemoryStream  MSBack;
        long            Retour;
        unsigned long   Index;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_DirectoryContentList,     //ID de communication
                                                  MS.pBuffer, MS.BufferLength,                  //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );       //Tampon de donnees de retour
        //Fermeture du flux d'emission
        _RDBMemoryStreamClose ( &MS );
        

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des entrees retournees
                _RDBMemoryStreamGet_ULONG ( &MSBack, pNbList );
                *pList      = (SRDB_LIST *)KERNEL_ALLOC ( sizeof(SRDB_LIST) * (*pNbList) );
                Index       = 0;
                for (Index = 0; Index < *pNbList; Index++ )
                {                
                    _RDBMemoryStreamGet_STRING ( &MSBack, (*pList)[Index].szName );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &(*pList)[Index].Identifiant );
                }

                _RDBMemoryStreamClose ( &MSBack );
            }
            else
            {
                //Aucune entree n'a ete trouvee
                *pList      = NULL;
                *pNbList    = 0;
            }
        }

        

        return Retour;
    }

    //################################################################################################################
    long RDBAccess_ClientDirectoryContentListEx ( SRDB ** pRDB, char * pszRootDirectoryName, SRDB_LISTEX ** pListEx, unsigned long * pNbList )
    {
        _TRDBMemoryStream   MS;
        _TRDBMemoryStream   MSBack;
        long                Retour;
        unsigned long       Index;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_DirectoryContentListEx,     //ID de communication
                                                  MS.pBuffer, MS.BufferLength,                  //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );       //Tampon de donnees de retour
        //Fermeture du flux d'emission
        _RDBMemoryStreamClose ( &MS );
        

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des entrees retournees
                _RDBMemoryStreamGet_ULONG ( &MSBack, pNbList );
                *pListEx      = (SRDB_LISTEX *)KERNEL_ALLOC ( sizeof(SRDB_LISTEX) * (*pNbList) );
                Index       = 0;
                for (Index = 0; Index < *pNbList; Index++ )
                {                
                    _RDBMemoryStreamGet_STRING ( &MSBack, (*pListEx)[Index].szName );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &(*pListEx)[Index].Identifiant );
                    _RDBMemoryStreamGet_ULONG ( &MSBack, &(*pListEx)[Index].lCountOfElements );
                    _RDBMemoryStreamGet_ULONG ( &MSBack, &(*pListEx)[Index].lSizeOfOneElement );
                    _RDBMemoryStreamGet_ULONG ( &MSBack, &(*pListEx)[Index].lTotalSize );
                }

                _RDBMemoryStreamClose ( &MSBack );
            }
            else
            {
                //Aucune entree n'a ete trouvee
                *pListEx    = NULL;
                *pNbList    = 0;
            }
        }

        

        return Retour;
    }

    
    
    

    //################################################################################################################
    long            RDBAccess_ClientMakeFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char * pFileData, unsigned long FileLength )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszFileName );
        _RDBMemoryStreamAdd_RAW    ( &MS, pFileData, FileLength );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_MakeFile,         //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }


    //################################################################################################################
    long            RDBAccess_ClientKillFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszFileName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_KillFile,         //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long            RDBAccess_ClientReadFile                    ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char ** pFileData, unsigned long *pFileLength )
    {
        _TRDBMemoryStream  MS;
        _TRDBMemoryStream  MSBack;
        long            Retour;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszFileName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_ReadFile,             //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_RAW ( &MSBack, pFileData, pFileLength );
                _RDBMemoryStreamClose ( &MSBack );
            }
            else
            {
                //Aucune donnee n'a ete retournee
                *pFileData      = NULL;
                *pFileLength    = 0;
            }
        }

        return Retour;
    }


    //################################################################################################################
    long RDBAccess_ClientMakeData ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, 
                                    unsigned char * pData, unsigned long SizeOfOneElement, unsigned long CountOfElements )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDataName );
        _RDBMemoryStreamAdd_ULONG  ( &MS, SizeOfOneElement );
        _RDBMemoryStreamAdd_RAW    ( &MS, pData, SizeOfOneElement * CountOfElements );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_MakeData,         //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long RDBAccess_ClientKillData             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDataName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_KillData,         //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long RDBAccess_ClientReadData             ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName,
                                                unsigned char ** pData, unsigned long *pSizeOfOneElement, unsigned long *pCountOfElements )
    {
        _TRDBMemoryStream  MS;
        _TRDBMemoryStream  MSBack;
        long            Retour;
        unsigned long   SizeOf;
        unsigned long   Size;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDataName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_ReadData,             //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_ULONG ( &MSBack, &SizeOf );
                _RDBMemoryStreamGet_RAW ( &MSBack, pData, &Size );
                _RDBMemoryStreamClose ( &MSBack );
                if (pSizeOfOneElement) *pSizeOfOneElement  = SizeOf;
                if (pCountOfElements)  *pCountOfElements   = Size / SizeOf;
            }
            else
            {
                //Aucune donnee n'a ete retournee
                *pData              = NULL;
                if (pSizeOfOneElement) *pSizeOfOneElement  = 0;
                if (pCountOfElements)  *pCountOfElements   = 0;
            }
        }

        return Retour;
    }

    //################################################################################################################
    long RDBAccess_ClientWriteData            ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszDataName, unsigned char * pData, unsigned long SizeInBytes )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszDataName );
        _RDBMemoryStreamAdd_RAW    ( &MS, pData, SizeInBytes );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_WriteData,        //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    //################################################################################################################
    long            RDBAccess_ClientSupervisorSet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszEntryName );
        _RDBMemoryStreamAdd_UCHAR  ( &MS, Mode );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_SupervisorSet,    //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    long            RDBAccess_ClientSupervisorGet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        _TRDBMemoryStream  MS;
        _TRDBMemoryStream  MSBack;
        long            Retour;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszEntryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_SupervisorGet,        //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                Retour = _RDBMemoryStreamGet_UCHAR2 ( &MSBack );
                _RDBMemoryStreamClose ( &MSBack );
            }
            else Retour = -1;
        }

        return Retour;
    }

    long            RDBAccess_ClientReadsCountSet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszEntryName );
        _RDBMemoryStreamAdd_UCHAR  ( &MS, Mode );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_ReadsCountSet,    //ID de communication
                                                  MS.pBuffer, MS.BufferLength,          //Tampon de donnees d'envoi
                                                  NULL, NULL );                         //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    long            RDBAccess_ClientReadsCountGet               ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName ) 
    {
        _TRDBMemoryStream  MS;
        _TRDBMemoryStream  MSBack;
        long            Retour;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_STRING ( &MS, (*pRDB)->Header.szRDBName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszRootDirectoryName );
        _RDBMemoryStreamAdd_STRING ( &MS, pszEntryName );

        //Communication Client/Serveur
        Retour = RDBAccess_WrapCDTS ( ID_RDBAccessNetwork_ReadsCountGet,        //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                Retour = _RDBMemoryStreamGet_UCHAR2 ( &MSBack );
                _RDBMemoryStreamClose ( &MSBack );
            }
            else Retour = -1;
        }

        return Retour;
    }

    //################################################################################################################
    //Password index = -1  n (-1 = admin)
    long RDBAccess_ClientGetKey ( long lPasswordIndex, unsigned long dwInterfaceID, unsigned char ** pbFKey256, unsigned long * plLength )
    {
        _TRDBMemoryStream   MS;
        _TRDBMemoryStream   MSBack;
        unsigned long       Size;
        long                Retour;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_ULONG  ( &MS, dwInterfaceID );
        _RDBMemoryStreamAdd_ULONG  ( &MS, lPasswordIndex );

        //Communication Client/Serveur
        Retour = RDBAccess_UnsecureClientDialogToServer ( RDB_ACCESS_CLIENT_INTERFACE_GETKEY,       //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_RAW ( &MSBack, pbFKey256, &Size );
                _RDBMemoryStreamClose ( &MSBack );
                if (plLength) *plLength  = Size;
            }
            else
            {
                //Aucune donnee n'a ete retournee
                *pbFKey256   = NULL;
                *plLength    = 0;
            }
        }

        return Retour;
    }

    long RDBAccess_ClientGetAuth ( unsigned char * pbAKey )
    {
        _TRDBMemoryStream  MS;
        long            Retour;

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_RAW ( &MS, pbAKey, 256 );

        //Communication Client/Serveur
        Retour = RDBAccess_UnsecureClientDialogToServer ( RDB_ACCESS_CLIENT_INTERFACE_GETAUTH,       //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  NULL, NULL );  //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );

        return Retour;
    }

    long RDBAccess_ClientResetAdminPassword_Step1 ( unsigned char * pbSHA512_a )
    {
        _TRDBMemoryStream   MSBack;
        long                Retour;
        unsigned long       ulSize;
        unsigned char       *pData;
        
        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Communication Client/Serveur
        Retour = RDBAccess_UnsecureClientDialogToServer ( 
            RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP1,       //ID de communication
            NULL,
            (unsigned long)NULL,              //Tampon de donnees d'envoi
            &(MSBack.pBuffer),
            &MSBack.BufferLength );  //Tampon de donnees de retour

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if (MSBack.BufferLength>0)
            {
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_RAW ( &MSBack, &pData, &ulSize );
                _RDBMemoryStreamClose ( &MSBack );
                
                if (ulSize!=64)
                    Retour = -1;
                else
                    memcpy ( pbSHA512_a, pData, 64 );
                    
                KERNEL_FREE ( pData );
            }
            else
            {
                //Aucune donnee n'a ete retournee
                Retour = -1;
            }
        }

        return Retour;
    }

    long RDBAccess_ClientResetAdminPassword_Step2 ( unsigned char * pbSHA512_a )
    {
        _TRDBMemoryStream   MS;
        long                Retour;
        long                i;
        //unsigned long       ulSize;
        //unsigned char       *pData;
        unsigned char       bSHA512_bprime[64];
        
        memcpy ( bSHA512_bprime, pbSHA512_a, 64 );
        for (i=0;i<9000;i++)
        {
            sha512 ( bSHA512_bprime, 64, bSHA512_bprime );
        }
        
        
        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );
        _RDBMemoryStreamAdd_RAW ( &MS, bSHA512_bprime, 64 );

        //Communication Client/Serveur
        Retour = RDBAccess_UnsecureClientDialogToServer ( RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP2,       //ID de communication
                                                  MS.pBuffer, MS.BufferLength,              //Tampon de donnees d'envoi
                                                  NULL, NULL );  //Tampon de donnees de retour

        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );


        return Retour;
    }
    
    long RDBAccess_ClientGetUserInfo ( long lUserIndex, long * plFlag, char * pszDescription )
    {
        _TRDBMemoryStream   MSBack;
        long                lRetour;
        //unsigned long       ulSize;
        //unsigned char       *pData;
        
        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_GetUserInfo | ((unsigned long)(lUserIndex&0xFFFF)<<16),
            0,
            NULL,
            NULL,
            (unsigned long)NULL,
            &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
            
        //S'il n'y a pas eu d'erreur
        if (!lRetour)
        {
            if (MSBack.BufferLength>0)
            {
                
                //                            _RDBMemoryStreamAdd_ULONG ( &MS, ConfigDataEx.TableUserPassword[dwIndexPassword].lFlag );
                //                            _RDBMemoryStreamAdd_STRING ( &MS, ConfigDataEx.TableUserPassword[dwIndexPassword].szDescription );
            
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_ULONG ( &MSBack, plFlag );
                _RDBMemoryStreamGet_STRING ( &MSBack, pszDescription );
                
                //_RDBMemoryStreamGet_RAW ( &MSBack, &pData, &ulSize );
                _RDBMemoryStreamClose ( &MSBack );
                
                //KERNEL_FREE ( pData );
            }
            else
            {
                //Aucune donnee n'a ete retournee
                lRetour = -1;
            }
        }

        return lRetour;
    }

    long RDBAccess_ClientSetUserDescription ( long lUserIndex, char * pszDescription )
    {
        long                lRetour;
        
        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserDescription | ((unsigned long)(lUserIndex&0xFFFF)<<16),
            0,
            pszDescription,
            NULL,
            (unsigned long)NULL,
            NULL, 
            NULL );
            
        return lRetour;
    }

    long RDBAccess_ClientSetUserFlag ( long lUserIndex, long lFlag )
    {
        long                lRetour;
        
        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserFlag | ((unsigned long)(lUserIndex&0xFFFF)<<16),
            (unsigned long)lFlag,
            NULL,
            NULL,
            (unsigned long)NULL,
            NULL, 
            NULL );
            
        return lRetour;
    }

    long RDBAccess_ClientSetUserPassword ( long lUserIndex, unsigned char * pbPasswordSHA512 )
    {
        long                lRetour;
        
        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserPassword | ((unsigned long)(lUserIndex&0xFFFF)<<16),
            0,
            NULL,
            pbPasswordSHA512,
            64,
            NULL, 
            NULL );
            
        return lRetour;
    }

    long RDBAccess_ClientSetAdminPassword ( unsigned char * pbPasswordOldSHA512, unsigned char * pbPasswordNewSHA512 )
    {
        long                lRetour;
        unsigned char       bStream[128];
        
        memcpy ( bStream, pbPasswordOldSHA512, 64 );
        memcpy ( bStream+64, pbPasswordNewSHA512, 64 );
        
        
        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_SetAdminPassword,
            0,
            NULL,
            bStream,
            128,
            NULL, 
            NULL );
            
        return lRetour;
    }
    
    long RDBAccess_ClientKillUser ( long lUserIndex )
    {
        long                lRetour;
        
        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_KillUser | ((unsigned long)(lUserIndex&0xFFFF)<<16),
            0,
            NULL,
            NULL,
            (unsigned long)NULL,
            NULL, 
            NULL );
            
        return lRetour;
    }

    
    long RDBAccess_ClientGetServerInfo ( JOCARESO_SERVER_INFO * pInfo )
    {
        _TRDBMemoryStream   MSBack;
        long                lRetour;
        //unsigned long       ulSize;
        //unsigned char       *pData;
        
        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_GetVersion,
            0,
            NULL,
            NULL,
            (unsigned long)NULL,
            &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour
            
        //S'il n'y a pas eu d'erreur
        if (!lRetour)
        {
            if (MSBack.BufferLength>0)
            {
                if (pInfo)
                {
                    memset ( pInfo, 0, sizeof(JOCARESO_SERVER_INFO) );
                    
                    //Recuperation des donnees retournees
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szDaemonName );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szDaemonType );
                    
                    _RDBMemoryStreamGet_ULONG ( &MSBack, &pInfo->dwProtocolRelease );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &pInfo->bVersionGen );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &pInfo->bVersionMajor );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &pInfo->bVersionMinor );
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &pInfo->bFileOSLetter );
                    
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szDaemonTextInfo );
                    
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szPathCurrent );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szPathHome );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szPathInstall );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szExecRunApp );
                    
                    _RDBMemoryStreamGet_UCHAR ( &MSBack, &pInfo->bRunModeState );
                    
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szServerComputerName );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szServerHostName );
                    _RDBMemoryStreamGet_STRING ( &MSBack, pInfo->szServerIP );
                
                }
                _RDBMemoryStreamClose ( &MSBack );
            }
            else
            {
                //Aucune donnee n'a ete retournee
                lRetour = -1;
            }
        }

        return lRetour;
    }
    
    long RDBAccess_ClientSendSoftUpdate ( 
        char * pszFileName, unsigned char * pFileData, unsigned long dwFileSize, 
        char * pszScriptFileName, char * pszScriptData, long * plUpdateErrorStatus )
    {
        long                lRetour;
        _TRDBMemoryStream   MSBack;

        //Initialisation du flux de retour
        _RDBMemoryStreamOpen ( &MSBack, NULL );

        //Communication Client/Serveur
        lRetour = RDBAccess_ClientSendAdminMessage_AB ( 
            RDB_ACCESS_CLIENT_INTERFACE_SAM_SoftUpdate,
            0,
            pszFileName,
            pszScriptFileName,
            pFileData,
            dwFileSize,
            pszScriptData,
            (unsigned long)strlen(pszScriptData)+1,
            &MSBack.pBuffer, &MSBack.BufferLength );  //Tampon de donnees de retour

        //S'il n'y a pas eu d'erreur
        if (!lRetour)
        {
            if (MSBack.BufferLength>0)
            {
                _RDBMemoryStreamGet_ULONG ( &MSBack, (unsigned long *)plUpdateErrorStatus );
                _RDBMemoryStreamClose ( &MSBack );
            }
            else
            {
                //Aucune donnee n'a ete retournee
                lRetour = -1;
            }
        }
            
        return lRetour;
    }
    

    long RDBAccess_ClientSendAdminMessage ( unsigned long ulParamA, unsigned long ulParamB, char * pszParamText, unsigned char * pData, unsigned long lDataLen, unsigned char ** pDataOut, long * plLengthOut )
    {
        return RDBAccess_ClientSendAdminMessage_AB (
            ulParamA, ulParamB,
            pszParamText,
            NULL,
            pData, lDataLen,
            NULL, (unsigned long)NULL,
            pDataOut, plLengthOut );
    }

    long RDBAccess_ClientSendAdminMessage_AB (
        unsigned long ulParamA, unsigned long ulParamB, 
        char * pszParamText_A, char * pszParamText_B, 
        unsigned char * pData_A, unsigned long lDataLen_A,
        unsigned char * pData_B, unsigned long lDataLen_B,
        unsigned char ** pDataOut, long * plLengthOut )
    {
        _TRDBMemoryStream   MS;
        //_TRDBMemoryStream   MSBack;
        long                Retour;
        unsigned char       *pTxBuffer;
        long                lTxSize;
        unsigned char       *pRxBuffer;
        long                lRxSize;
        DWORD               dwFlags;

        //Initialisation du flux de retour
        //_RDBMemoryStreamOpen ( &MSBack, NULL );

        //Creation du flux
        _RDBMemoryStreamOpen ( &MS, NULL );

        _RDBMemoryStreamAdd_ULONG  ( &MS, ulParamA );
        _RDBMemoryStreamAdd_ULONG  ( &MS, ulParamB );

        dwFlags = RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_NONE;
        if (pszParamText_A) dwFlags |= RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_A;
        if (pszParamText_B) dwFlags |= RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_B;
        if ((pData_A)&&(lDataLen_A)) dwFlags |= RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_A;
        if ((pData_B)&&(lDataLen_B)) dwFlags |= RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_B;

        _RDBMemoryStreamAdd_ULONG  ( &MS, dwFlags );

        if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_A)
            _RDBMemoryStreamAdd_STRING ( &MS, pszParamText_A );

        if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_B)
            _RDBMemoryStreamAdd_STRING ( &MS, pszParamText_B );

        if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_A)
            _RDBMemoryStreamAdd_RAW ( &MS, pData_A, lDataLen_A );

        if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_B)
            _RDBMemoryStreamAdd_RAW ( &MS, pData_B, lDataLen_B );

        ServerClientInterface_Encrypt ( 
            &_sciStateClient.sciLink,
            MS.pBuffer,
            MS.BufferLength,
            &pTxBuffer,
            &lTxSize );

        //Communication Client/Serveur
        Retour = RDBAccess_UnsecureClientDialogToServer ( RDB_ACCESS_CLIENT_INTERFACE_SENDADMINMESSAGE,     //ID de communication
                                                  pTxBuffer, lTxSize,                               //Tampon de donnees d'envoi
                                                  &pRxBuffer, (unsigned long *)&lRxSize );          //Tampon de donnees de retour
                                                  //&MSBack.pBuffer, &MSBack.BufferLength );          //Tampon de donnees de retour
        //Fermeture du flux
        _RDBMemoryStreamClose ( &MS );
        KERNEL_FREE ( pTxBuffer );

        //S'il n'y a pas eu d'erreur
        if (!Retour)
        {
            if ((pDataOut)&&(plLengthOut))
            {
                if (lRxSize>0)
                {
                    //Decryptage
                    if (ServerClientInterface_Decrypt ( 
                        &_sciStateClient.sciLink,
                        pRxBuffer,
                        lRxSize,
                        pDataOut,
                        plLengthOut ))
                    {
                        return -1;
                    }
                }
                else
                {
                    *plLengthOut    = 0;
                    *pDataOut       = NULL;
                }
            }
            /*
            if (MSBack.BufferLength>0)
            {
                
                //Recuperation des donnees retournees
                _RDBMemoryStreamGet_RAW ( &MSBack, pbFKey256, &Size );
                _RDBMemoryStreamClose ( &MSBack );
                if (plLength) *plLength  = Size;
            }
            else
            {
                //Aucune donnee n'a ete retournee
                *pbFKey256   = NULL;
                *plLength    = 0;
            }*/
        }

        return Retour;
    }

long    RDBAccess_SecureClientDialogToServer ( unsigned char InID, unsigned char * pInBuffer, unsigned long InLength,
                                               unsigned char ** pOutBuffer, unsigned long * pOutLength )
{
    _TRDBMemoryStream   msSecureStream;
    unsigned char       *pTxBuffer;
    unsigned char       *pRxBuffer;
    long                lTxSize;
    long                lRxSize;
    long                lRetour;
    
    //Initialisation du stream
    _RDBMemoryStreamOpen ( &msSecureStream, NULL );
    
    //ID de la trame
    _RDBMemoryStreamAdd_ULONG  ( &msSecureStream, InID );
    
    //Les donnees
    _RDBMemoryStreamAdd_RAW ( &msSecureStream, pInBuffer, InLength );

    //Cryptage
    ServerClientInterface_Encrypt ( 
        &_sciStateClient.sciLink,
        msSecureStream.pBuffer,
        msSecureStream.BufferLength,
        &pTxBuffer,
        &lTxSize );

    //Communication Client/Serveur
    lRetour = RDBAccess_UnsecureClientDialogToServer ( 
        RDB_ACCESS_CLIENT_INTERFACE_SECURECMD,          //ID de communication
        pTxBuffer, lTxSize,                             //Tampon de donnees d'envoi
        &pRxBuffer, (unsigned long *)&lRxSize );        //Tampon de donnees de retour

    //Fermeture du flux
    _RDBMemoryStreamClose ( &msSecureStream );
    KERNEL_FREE ( pTxBuffer );
    
    //S'il n'y a pas eu d'erreur
    if (!lRetour)
    {
        if ((pOutBuffer)&&(pOutLength))
        {
            if (lRxSize>0)
            {
                //Decryptage
                ServerClientInterface_Decrypt ( 
                    &_sciStateClient.sciLink,
                    pRxBuffer,
                    lRxSize,
                    pOutBuffer,
                    pOutLength );
            }
            else
            {
                *pOutLength = 0;
                *pOutBuffer = NULL;
            }
        }
    }

    return lRetour;
}                                               
    
    

