/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


    #include "RDB.h"

    #define MB(x) MessageBox(GetFocus(), x,"Debug",MB_OK)

    #define MX(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : 0x%08x", x);          \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  } 
    
    #define MI(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %d", x);              \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }
    #define ML(x) { char szTmpAMoi[50];                                     \
                        wsprintf (szTmpAMoi,"Valeur : %ld", x);             \
                        MessageBox(GetFocus(), szTmpAMoi,"Debug",MB_OK);    \
                  }


    long    RDBMakeFile       ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char * pFileData, unsigned long FileLength )
    {
        unsigned long   OffsetEntry; 
        unsigned long   Size;
        TRDB_ENTRY      RDBEntry;
        long            Retour;
        TRDB_DATA       RDBData;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientMakeFile ( pRDB, pszRootDirectoryName, pszFileName, pFileData, FileLength );

        //Recherche si le fichier n'existe pas deja
        OffsetEntry = 0;
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, pszFileName, SEARCHMODE_DATA|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour== 0) return -2;
        if (Retour==-3) return -3;

        //Lecture des donnees du repertoire racine
        OffsetEntry = 0;
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, NULL, SEARCHMODE_DIRECTORY|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour!=0) return -4;
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, &Size );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;

        //Creation de l'entree du fichier
        RDBEntry.FLAGS_ReadsCount       = 0;
        RDBEntry.FLAGS_Supervisor       = 0xFFFFFFFF;
        RDBEntry.Identifiant            = RDB_ID_FILE;
        RDBEntry.OffsetContent          = (*pRDB)->DataBaseLength;
        RDBEntry.UseLastFullPathName    = 1;
        sprintf ( RDBEntry.FullPathName, "%s", pszFileName );

        //Insertion de l'entree
        Retour = RDBEntry_InsertData ( pRDB, OffsetEntry+Size, &RDBEntry );
        if (Retour!=0) return -5;

        //Creation des donnees du fichier
        RDBData.DataType                = RDB_ID_FILE;
        RDBData.CountOfElements         = 1;
        RDBData.SizeOfOneElement        = FileLength;
        RDBData.pData                   = pFileData;

        //Insertion des donnees
        return RDBBase_InsertData ( pRDB, (*pRDB)->DataBaseLength, &RDBData );
    }


    long    RDBKillFile         ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName )
    {
        unsigned long   OffsetEntry; 
        unsigned long   Size;
        TRDB_ENTRY      RDBEntry;
        long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientKillFile ( pRDB, pszRootDirectoryName, pszFileName );

        //Lecture des donnees du repertoire racine
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, NULL, SEARCHMODE_DIRECTORY|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour!=0) return -4;
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, &Size );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur et Read Off
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;
        if (RDBEntry.FLAGS_ReadsCount>0) return -4;

        //Recherche si le fichier existe bien
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, pszFileName, SEARCHMODE_DATA|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour!=0) return -2;

        //Lecture des donnees du fichier
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, &Size );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur et Read Off
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;
        if (RDBEntry.FLAGS_ReadsCount>0) return -4;

        //Suppression de l'entree
        Retour = RDBEntry_KillData ( pRDB, OffsetEntry );
        if (Retour!=0) return -2;

        //Changement du type de donnee stockee par un jumper (operation plus ou moins licite) @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        (*pRDB)->pDataBase[RDBEntry.OffsetContent+4] = RDB_ID_JUMPER;

        //Je prefere cette operation
        RDBBase_GetData ( pRDB, RDBEntry.OffsetContent, NULL, &Size );
        RDBBase_DefragData ( pRDB, RDBEntry.OffsetContent, Size );
        return 0;
    }

    long    RDBReadFile         ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char ** pFileData, unsigned long *pFileLength )
    {
        unsigned long   OffsetEntry; 
        unsigned long   Size;
        TRDB_DATA       RDBData;
        TRDB_ENTRY      RDBEntry;
        long            Retour;

        //Teste si le pointeur est bon ?
        if ((pRDB==NULL)||(pFileData==NULL)||(pFileLength==NULL))
            return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientReadFile ( pRDB, pszRootDirectoryName, pszFileName, pFileData, pFileLength );

        //Lecture des donnees du repertoire racine
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, NULL, SEARCHMODE_DIRECTORY|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour!=0) return -4;
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, &Size );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;

        //Recherche si le fichier existe bien
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, pszFileName, SEARCHMODE_DATA|SEARCHMODE_STARTENTRY, &OffsetEntry );
        if (Retour!=0) return -2;

        //Lecture des donnees du fichier
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, &Size );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;

        //Lecture des donnees
        Retour = RDBBase_GetData ( pRDB, RDBEntry.OffsetContent, &RDBData, NULL );
        if (Retour!=0) return -2;

        //Recuperation des donnees
        *pFileData      = RDBData.pData;
        if ((RDBData.CountOfElements==0)&&(RDBData.SizeOfOneElement>0)) RDBData.CountOfElements = 1;
        *pFileLength    = RDBData.CountOfElements * RDBData.SizeOfOneElement;

        return 0;

    }
    
    long    RDBWriteFile         ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszFileName, unsigned char ** pFileData, unsigned long *pFileLength )
    {
    
        return 0;
    }
