/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


    #include "RDB.h"


    long RDBFlagFindEntry ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, unsigned long * pOffsetEntry )
    {
        long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Recherche un dossier...
        Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, pszEntryName, SEARCHMODE_DIRECTORY|SEARCHMODE_STARTENTRY, pOffsetEntry );

        //On n'a pas trouve de dossier, c'est peut-etre une donnee
        if (Retour!=0)
            Retour = RDBEntry_SearchName ( pRDB, pszRootDirectoryName, pszEntryName, SEARCHMODE_DATA|SEARCHMODE_STARTENTRY, pOffsetEntry );

        if (Retour!=0) return -2;

        return 0;
    }

    long  RDBSupervisorSet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode )
    {
        //unsigned long   OffsetEntry;
        //TRDB_ENTRY      RDBEntry;
        //long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientSupervisorSet ( pRDB, pszRootDirectoryName, pszEntryName, Mode );
            
        return 0;
                    
        /*
        //Recherche l'entree...
        Retour = RDBFlagFindEntry ( pRDB, pszRootDirectoryName, pszEntryName, &OffsetEntry );
        if (Retour!=0) return -2;

        //Recuperation des informations
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, NULL );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur        
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;
        if (RDBEntry.FLAGS_ReadsCount>0) return -4;

        //On fixe le mode superviseur
        if (Mode)   RDBEntry.FLAGS_Supervisor = (*pRDB)->SupervisorOwnerID;
        else        RDBEntry.FLAGS_Supervisor = 0xFFFFFFFF;

        return RDBEntry_SetFlag ( pRDB, OffsetEntry, RDBEntry.FLAGS_Supervisor, RDBEntry.FLAGS_ReadsCount );
        */
    }


    long  RDBSupervisorGet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        //unsigned long   OffsetEntry;
        //TRDB_ENTRY      RDBEntry;
        //long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientSupervisorGet ( pRDB, pszRootDirectoryName, pszEntryName );
            
        return 0;
        /*

        //Recherche l'entree...
        Retour = RDBFlagFindEntry ( pRDB, pszRootDirectoryName, pszEntryName, &OffsetEntry );
        if (Retour!=0) return -2;

        //Recuperation des informations
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, NULL );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur
        if (RDBEntry.FLAGS_ReadsCount>0) return -4;
        if (RDBEntry.FLAGS_Supervisor==0xFFFFFFFF) return 0;
        else                                       return 1;
        */
    }

    long  RDBReadsCountSet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode )
    {
        //unsigned long   OffsetEntry;
        //TRDB_ENTRY      RDBEntry;
        //long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientReadsCountSet ( pRDB, pszRootDirectoryName, pszEntryName, Mode );
            
        return 0;
        /*
        //Recherche l'entree...
        Retour = RDBFlagFindEntry ( pRDB, pszRootDirectoryName, pszEntryName, &OffsetEntry );
        if (Retour!=0) return -2;

        //Recuperation des informations
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, NULL );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur        
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;

        //On fixe le mode readscount
        if (Mode)   RDBEntry.FLAGS_ReadsCount++;
        else        RDBEntry.FLAGS_ReadsCount--;

        if (RDBEntry.FLAGS_ReadsCount==0xFFFFFFFF) RDBEntry.FLAGS_ReadsCount = 0;
        return RDBEntry_SetFlag ( pRDB, OffsetEntry, RDBEntry.FLAGS_Supervisor, RDBEntry.FLAGS_ReadsCount );
        */
    }

    long  RDBReadsCountGet ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        //unsigned long   OffsetEntry;
        //TRDB_ENTRY      RDBEntry;
        //long            Retour;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        //Est-on en mode client ******************************************************************************************
        if (_RDBAccessServerMode == _TRDBACCESS_CLIENT)
            return RDBAccess_ClientReadsCountGet ( pRDB, pszRootDirectoryName, pszEntryName );

        return 0;
        /*
        //Recherche l'entree...
        Retour = RDBFlagFindEntry ( pRDB, pszRootDirectoryName, pszEntryName, &OffsetEntry );
        if (Retour!=0) return -2;

        //Recuperation des informations
        Retour = RDBEntry_GetData ( pRDB, OffsetEntry, &RDBEntry, NULL );
        if (Retour!=0) return -4;

        //Verification des droits en mode superviseur        
        if ((RDBEntry.FLAGS_Supervisor!=0xFFFFFFFF)&&(RDBEntry.FLAGS_Supervisor!=((*pRDB)->SupervisorOwnerID))) return -4;

        if (RDBEntry.FLAGS_ReadsCount) return 1;
        else                           return 0;
        */
    }





/*
    //La gestion des flags fait sauter automatiquement tout mode R/W

    long    _RDBFlagGetEntry ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, TRDB_ENTRY * pRDBEntry )
    {
        unsigned long   OffsetEntry; 
        TRDB_ENTRY      RDBEntry;
        unsigned char   Identifiant;

        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;

        if (pszEntryName==NULL)
        {
            //Recuperation de l'entree
            OffsetEntry = _RDBFindEntryRootOffset ( pRDB, pszRootDirectoryName );
            if (OffsetEntry==0xFFFFFFFF) return -2;
            _RDBEntryGet ( pRDB, &RDBEntry, OffsetEntry );
        }
        else
        {
            //Recuperation de l'entree
            OffsetEntry = _RDBFindEntryRootToDataOffset ( pRDB, pszRootDirectoryName, pszEntryName );
            if (OffsetEntry==0xFFFFFFFF) return -2;
            _RDBEntryGet ( pRDB, &RDBEntry, OffsetEntry );
        }

        //if ( (*pRDB)->pDataBase[RDBEntry.OffsetContent] == RDB_ID_JUMPER ) return -3;
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent, &Identifiant, 1 );
        if ( Identifiant == RDB_ID_JUMPER ) return -3;
        memcpy ( pRDBEntry, &RDBEntry, sizeof(TRDB_ENTRY) );

        return 0;
    }

    long    RDBFlagSupervisorCapture ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //On verifie le contenu du flag
        if ((RDBFlag.ReadRightCount!=0)||(RDBFlag.SupervisorCurrent!=0)) return -2;

        //Nouvelle assignation
        RDBFlag.SupervisorCurrent = 1;
        RDBFlag.SupervisorID      = (*pRDB)->SupervisorID;
        //memcpy ( &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], &RDBFlag, sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_WRITE_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        return 0;
    }

    long    RDBFlagSupervisorRelease ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //On verifie le contenu du flag
        if (RDBFlag.SupervisorCurrent==1) return -2;

        //Nouvelle assignation
        RDBFlag.SupervisorCurrent = 0;
        //memcpy ( &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], &RDBFlag, sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_WRITE_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        return 0;
    }

    long    RDBFlagIncrRead ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //On verifie le contenu du flag
        if (RDBFlag.SupervisorCurrent!=0) return -2;

        //Nouvelle assignation
        RDBFlag.ReadRightCount+=1;
        //memcpy ( &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], &RDBFlag, sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_WRITE_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        return 0;
    }

    long    RDBFlagDecrRead ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //On verifie le contenu du flag
        if (RDBFlag.SupervisorCurrent!=0) return -2;

        //Nouvelle assignation
        if (RDBFlag.ReadRightCount>0) RDBFlag.ReadRightCount-=1;
        //memcpy ( &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], &RDBFlag, sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_WRITE_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        return 0;
    }

    //Valeur de retour
    //  0   =   La variable specifie est disponible en acces superviseur
    //  1   =   La variable n'est pas du tout disponible
    long    _RDBFlagIsSupervisorProtected ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //Si identifiant superviseur et la donnee identifiant superviseur ont la meme valeur, on est pas en superviseur externe
        if ((RDBFlag.SupervisorCurrent==1)&&(RDBFlag.SupervisorID==(*pRDB)->SupervisorID)) return 0;

        //Test le mode supervisor
        return RDBFlag.SupervisorCurrent;
    }

    long    RDBFlagIsSupervisorProtected ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        long Retour;
        RDBAccess_STARTEXCLUSIVE ( pRDB );
        Retour = _RDBFlagIsSupervisorProtected ( pRDB, pszRootDirectoryName, pszEntryName );
        RDBAccess_STOPEXCLUSIVE ( pRDB );
        return Retour;
    }


    //Valeur de retour
    //  0   =   La variable n'est pas encore en mode lecture
    //  oo  =   La variable est actuellement en mode lecture
    //  -1  =   Erreur
    //  -20 =   La variable est en mode superviseur, le mode lecture est impossible
    long    _RDBFlagIsRead ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        TRDB_ENTRY      RDBEntry;
        TRDB_FLAG       RDBFlag;
 
        //Teste si le pointeur est bon ?
        if (pRDB==NULL) return -1;
      
        //Recupere l'entree
        if (_RDBFlagGetEntry ( pRDB, pszRootDirectoryName, pszEntryName, &RDBEntry )!=0) return -2;

        //Recupere le flag
        //memcpy ( &RDBFlag, &(*pRDB)->pDataBase[RDBEntry.OffsetContent+1], sizeof(TRDB_FLAG) );
        RDBAccess ( pRDB, RDB_ACCESS_ID_READ_pDataBase, RDBEntry.OffsetContent+1, &RDBFlag, sizeof(TRDB_FLAG) );

        //Si identifiant superviseur et la donnee identifiant superviseur ont la meme valeur, on est pas en superviseur externe
        if ((RDBFlag.SupervisorCurrent==1)&&(RDBFlag.SupervisorID!=(*pRDB)->SupervisorID)) return -20;

        //Test le mode Read
        return RDBFlag.ReadRightCount;
    }

    long    RDBFlagIsRead ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName )
    {
        long Retour;
        RDBAccess_STARTEXCLUSIVE ( pRDB );
        Retour = _RDBFlagIsRead ( pRDB, pszRootDirectoryName, pszEntryName );
        RDBAccess_STOPEXCLUSIVE ( pRDB );
        return Retour;
    }


    long    RDBFlagWhileBlock ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, long (* RDBFlagGet) ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName ) )
    {
        long RetourMessage;
        long Retour;
        long Compteur;

        if ((RDBFlagGet==RDBFlagIsSupervisorProtected)||
            (RDBFlagGet==RDBFlagIsRead)) return -2;

        //5 essais !
        Compteur = 10;
        do {
            Retour = (*RDBFlagGet) ( pRDB, pszRootDirectoryName, pszEntryName );
            Compteur--;

            //Erreur dans les parametres (pRDB)
            if (Retour==-1) return -1;

            //Le retour est correct ?
            if (Retour==0) return 0;

            //Le retour est incorrect et le compteur est atteint ?
            if ((Compteur<=0)&&(Retour!=0))
            {
                RetourMessage = MessageBox ( GetFocus ( ), 
                                   "Attention, les donnees du serveur sont indisponibles.\nLe serveur est bloque ou un poste s'accapare les donnees.\n\nVoulez-vous reessayer ?", "Probleme d'acces aux donnees", 
                                   MB_RETRYCANCEL | MB_ICONERROR );

                if (RetourMessage==IDCANCEL) return -1;
                Compteur = 10;
            }

            //Attendre 20ms + (10-Compteur)*100 => 20, 120, 220, 320, 420...920ms (Total 4680ms)
            Sleep ( 20 + (10-Compteur)*100 );

        } while (1);

        return 0;
    }
*/
