/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


    #include "RDB.h"

        void _RDBMemoryStreamOpen              ( _TRDBMemoryStream * pMS, unsigned char * pIfExistSourceBuffer )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            pMS->BufferLength   = 0;
            pMS->OffsetRead     = 0;
            pMS->pBuffer        = pIfExistSourceBuffer; //NULL ou un buffer existant
        }

        void _RDBMemoryStreamClose             ( _TRDBMemoryStream * pMS )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            if (pMS->pBuffer) KERNEL_FREE ( pMS->pBuffer );
            pMS->BufferLength   = 0;
            pMS->OffsetRead     = 0;
            pMS->pBuffer        = NULL;
        }




        void _RDBMemoryStreamAdd_UCHAR        ( _TRDBMemoryStream * pMS, unsigned char Data )
        {
            unsigned long Size;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned char);
            pMS->pBuffer = (unsigned char *)KERNEL_REALLOC ( pMS->pBuffer, pMS->BufferLength + Size );

            //Ajoute les donnees
            *((unsigned char *)&pMS->pBuffer[pMS->BufferLength]) = Data;
            pMS->BufferLength += Size;
        }

        void _RDBMemoryStreamAdd_USHORT        ( _TRDBMemoryStream * pMS, unsigned short Data )
        {
            unsigned long Size;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned short);
            pMS->pBuffer = (unsigned char *)KERNEL_REALLOC ( pMS->pBuffer, pMS->BufferLength + Size );

            //Ajoute les donnees
            *((unsigned short *)&pMS->pBuffer[pMS->BufferLength]) = Data;
            pMS->BufferLength += Size;
        }

        void _RDBMemoryStreamAdd_ULONG        ( _TRDBMemoryStream * pMS, unsigned long Data )
        {
            unsigned long Size;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned long);
            pMS->pBuffer = (unsigned char *)KERNEL_REALLOC ( pMS->pBuffer, pMS->BufferLength + Size );

            //Ajoute les donnees
            *((unsigned long *)&pMS->pBuffer[pMS->BufferLength]) = Data;
            pMS->BufferLength += Size;
        }

        void _RDBMemoryStreamAdd_STRING        ( _TRDBMemoryStream * pMS, char * psz )
        {
            unsigned long Size;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Calcule la taille des donnees a ajouter
            Size = (unsigned long)strlen(psz)+1;

            //Ajoute la longueur des donnees
            //_MemoryStreamAdd_ULONG ( pMS, Size );

            //Reallocation
            pMS->pBuffer = (unsigned char *)KERNEL_REALLOC ( pMS->pBuffer, pMS->BufferLength + Size );

            //Ajoute les donnees
            memcpy ( &pMS->pBuffer[pMS->BufferLength], psz, Size );
            pMS->BufferLength += Size;
        }

        void _RDBMemoryStreamAdd_RAW           ( _TRDBMemoryStream * pMS, unsigned char * pData, unsigned long DataLength )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            //Ajoute la longueur des donnees
            _RDBMemoryStreamAdd_ULONG ( pMS, DataLength );

            //Reallocation
            pMS->pBuffer = (unsigned char *)KERNEL_REALLOC ( pMS->pBuffer, pMS->BufferLength + DataLength );

            //Ajoute les donnees
            memcpy ( &pMS->pBuffer[pMS->BufferLength], pData, DataLength );
            pMS->BufferLength += DataLength;
        }



        unsigned char   _RDBMemoryStreamGet_UCHAR2          ( _TRDBMemoryStream * pMS )
        {
            unsigned long Size;
            unsigned char *p;

            //Vrification du pointeur
            if (pMS==NULL) return 0;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned char);

            //Retourne la valeur et met  jour le tampon
            p = &pMS->pBuffer[pMS->OffsetRead];
            pMS->OffsetRead += Size;
            return *((unsigned char *)p);
        }

        void _RDBMemoryStreamGet_UCHAR          ( _TRDBMemoryStream * pMS, unsigned char * pData )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            *pData = _RDBMemoryStreamGet_UCHAR2 ( pMS );
        }




        unsigned short  _RDBMemoryStreamGet_USHORT2          ( _TRDBMemoryStream * pMS )
        {
            unsigned long Size;
            unsigned char *p;

            //Verification du pointeur
            if (pMS==NULL) return 0;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned short);

            //Retourne la valeur et met a jour le tampon
            p = &pMS->pBuffer[pMS->OffsetRead];
            pMS->OffsetRead += Size;
            return *((unsigned short *)p);
        }

        void _RDBMemoryStreamGet_USHORT          ( _TRDBMemoryStream * pMS, unsigned short * pData )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            *pData = _RDBMemoryStreamGet_USHORT2 ( pMS );
        }


        unsigned long   _RDBMemoryStreamGet_ULONG2          ( _TRDBMemoryStream * pMS )
        {
            unsigned long Size;
            unsigned char *p;

            //Verification du pointeur
            if (pMS==NULL) return 0;

            //Calcule la taille des donnees a ajouter
            Size = sizeof(unsigned long);

            //Retourne la valeur et met a jour le tampon
            p = &(pMS->pBuffer[pMS->OffsetRead]);
            pMS->OffsetRead += Size;
            return *((unsigned long *)p);
        }

        void _RDBMemoryStreamGet_ULONG          ( _TRDBMemoryStream * pMS, unsigned long * pData )
        {
            //Verification du pointeur
            if (pMS==NULL) return;

            *pData = _RDBMemoryStreamGet_ULONG2 ( pMS );
        }


        void            _RDBMemoryStreamGet_STRING         ( _TRDBMemoryStream * pMS, char * pszOut )
        {
            unsigned long Size;
                     char *p;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Recupration de la longueur des donnees
            //_MemoryStreamGet_ULONG ( pMS, &Size );

            //Pointeur sur la chaine
            p = (char *)&(pMS->pBuffer[pMS->OffsetRead]);        

            //Calcule la taille des donnees a ajouter
            Size = (unsigned long)strlen ( p ) + 1;

            //Retourne la valeur et met a jour le tampon
            strcpy ( pszOut, p );
            pMS->OffsetRead += Size;
        }

        void _RDBMemoryStreamGet_RAW           ( _TRDBMemoryStream * pMS, unsigned char ** pData, unsigned long *pDataLength )
        {
            unsigned long DataLength;

            //Verification du pointeur
            if (pMS==NULL) return;

            //Recuperation de la longueur des donnees
            _RDBMemoryStreamGet_ULONG ( pMS, &DataLength );
            if (pDataLength) *pDataLength = DataLength;

            //Recuperation des donnees elles-memes
            if (pData)
            {
                *pData = (unsigned char *)KERNEL_ALLOC ( DataLength );
                memcpy ( *pData, &pMS->pBuffer[pMS->OffsetRead], DataLength );
            }
            pMS->OffsetRead += DataLength;
        }

