/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
Gavroche Richier
gavroche.richier@jocatop.fr
===================================================================
*/

    #ifndef __SCI__
    #define __SCI__
    
    typedef struct {
        DWORD                   interface_dwState;          //0 = not connected
        DWORD                   interface_dwIdentifiant;
        BYTE                    interface_bFKey[256];       //Clef totalement aleatoire
        BYTE                    interface_bGKey[256];       //Clef totalement aleatoire de la connexion distante
        BYTE                    interface_bIKey[256];       //Clef generee avec l'ID
        BYTE                    interface_bPKey[256];       //Clef generee avec le password
        BYTE                    interface_bAKey[256];       //Clef d'authentification (FKey XOR PKey)
        //QWORD                   interface_qwTxRxKey[256];   //Clef de transmition/reception
        BYTE                    interface_bTxRxKeySHA512[64];   //Clef de transmition/reception (sha512)
        //BYTE                    interface_bTxRxKeyLong[2048];    //Clef de transmition/reception (longue)
        QWORD                   interface_qwRandomSeed;
        
        BYTE                    bAdminResetSHA512[64];
        long                    lAdminResetCount;           //Le nombre de demandes...
    } SCILINK;
    
    


    void ServerClientInterface_Init ( SCILINK * psciLink );

    //QWORD * ServerClientInterface_GetTxRxKey ( SCILINK * psciLink );
    BYTE * ServerClientInterface_GetAKey ( SCILINK * psciLink );
    BYTE * ServerClientInterface_GetFKey ( SCILINK * psciLink );

    void ServerClientInterface_SetFKey ( SCILINK * psciLink, BYTE * pbFKey );

    long ServerClientInterface_MakeFKey ( SCILINK * psciLink );
    long ServerClientInterface_MakeIKey ( SCILINK * psciLink, DWORD dwInterfaceID );
    long ServerClientInterface_MakePKey ( SCILINK * psciLink, unsigned char * pbPasswordSHA512 );
    long ServerClientInterface_MakeAKey ( SCILINK * psciLink );
    long ServerClientInterface_MakeGKey ( SCILINK * psciLink, unsigned char * pRemoteKey );
    long ServerClientInterface_MakeTxRxKey ( SCILINK * psciLink );
    
    
    DWORD ServerClientInterface_GetState ( SCILINK * psciLink );
    DWORD ServerClientInterface_GetIdentifiant ( SCILINK * psciLink );
    void ServerClientInterface_SetStateIdentifiant ( SCILINK * psciLink, DWORD dwState, DWORD dwIdentifiant );
    void ServerClientInterface_UpdateSeed ( SCILINK * psciLink, unsigned long lValue );
    void ServerClientInterface_GetRand ( SCILINK * psciLink, unsigned long * pulValue );

    void ServerClientInterface_Encrypt ( SCILINK * psciLink, unsigned char * pInBuffer, long lInLength, unsigned char ** pOutBuffer, long * plOutLength );
    long ServerClientInterface_Decrypt ( SCILINK * psciLink, unsigned char * pInBuffer, long lInLength, unsigned char ** pOutBuffer, long * plOutLength );
    
    //Convertion d'un HASH en texte... c bien pratique !
    long ServerClientInterface_ConvertHashToText ( char * pszPassword, unsigned char * pHash, long lHashByteCount );
    long ServerClientInterface_ConvertPasswordToTextSHA512 ( char * pszPasswordSHA512, char * pszPassword );
    
    #endif


    //********************************************************************************************************

    #ifndef DEF_SCI_STATE
    #define DEF_SCI_STATE

    #define JOCARESO_SCI_STATE_ACTIVE           0x0001
    #define JOCARESO_SCI_STATE_WATCHDOG         0x0002
    #define JOCARESO_SCI_STATE_WATCHDOG_ERR1    0x0004
    #define JOCARESO_SCI_STATE_WATCHDOG_ERR2    0x0008
    
    

    typedef struct {
        //char                    sz[256];
        //SOCKET                  Socket;
        DWORD                   dwSocket;
        DWORD                   dwPort;
        char                    szPeerName[256];
        char                    szIPName[64];
        //char                    szState[16];
        DWORD                   dwState;
        long                    lWatchdogTime;
        long                    lIdentifiant;
		long					bIdentified;			// Authentification successed
		DWORD					dwConnectionTimeStamp;	// Time stamp on the opening of the socket
        //long                    lIUserValue;
        SCILINK                 sciLink;
        
        long                    lAdminMode;     //0 = Usermode, 1 = admin
    } SCISTATE;
    
    

    

    #endif
