/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
Gavroche Richier
gavroche.richier@jocatop.fr
===================================================================
*/


    #include "jocareso.h"
    #include "RDBServer.h"
    #include "RDBServerClientInterface.h"
    #include "sha2.h"
    #include "key.h"
    #include "crypt.h"

    /*
    typedef struct {
        unsigned long   OwnerId;
        char            *pszRootDirectoryName;
        char            *pszEntryName;
        char            *pszBaseName;
    } FLAG_READ_TABLE;

    FLAG_READ_TABLE     *pTableFlagRead = NULL;
    unsigned long       TableFlagReadNb = 0;

    void FlagReadKill ( SRDB ** pRDB, unsigned long OwnerId )
    {
        unsigned long       i;
        FLAG_READ_TABLE     *pNewTableFlagRead;
        unsigned long       NewTableFlagReadNb;

        

        pNewTableFlagRead = (FLAG_READ_TABLE *) malloc ( TableFlagReadNb * sizeof(FLAG_READ_TABLE) );
        NewTableFlagReadNb = 0;
        for (i=0;i<TableFlagReadNb;i++)
        {
            if ( pTableFlagRead[i].OwnerId == OwnerId )
            {
                //On a trouve !
                RDBReadsCountSet ( pRDB, pTableFlagRead[i].pszRootDirectoryName, pTableFlagRead[i].pszEntryName, 0 );
                free ( pTableFlagRead[i].pszRootDirectoryName );
                free ( pTableFlagRead[i].pszEntryName );
                free ( pTableFlagRead[i].pszBaseName );
            }
            else
            {
                memcpy ( &pNewTableFlagRead[NewTableFlagReadNb], &pTableFlagRead[i], sizeof(FLAG_READ_TABLE) );
                NewTableFlagReadNb++;
            }
        }
        free ( pTableFlagRead );
        pTableFlagRead      = pNewTableFlagRead;
        TableFlagReadNb     = NewTableFlagReadNb;
        
    }     

    void FlagReadUpdate ( SRDB ** pRDB, char * pszRootDirectoryName, char * pszEntryName, BOOL Mode )
    {
        unsigned long i;

        

        //Mode StartRead
        if (Mode)
        {
            //Reallocation
            pTableFlagRead = (FLAG_READ_TABLE *) realloc ( pTableFlagRead, (TableFlagReadNb+1) * sizeof(FLAG_READ_TABLE) );

            //Allocation des variables
            pTableFlagRead[TableFlagReadNb].pszRootDirectoryName = (char *) malloc ( strlen ( pszRootDirectoryName ) + 1 );
            pTableFlagRead[TableFlagReadNb].pszEntryName         = (char *) malloc ( strlen ( pszEntryName ) + 1 );
            pTableFlagRead[TableFlagReadNb].pszBaseName          = (char *) malloc ( strlen ( (*pRDB)->Header.szRDBName ) + 1 );

            //Stockage des donnees
            pTableFlagRead[TableFlagReadNb].OwnerId = (*pRDB)->SupervisorOwnerID;
            strcpy ( pTableFlagRead[TableFlagReadNb].pszRootDirectoryName, pszRootDirectoryName );
            strcpy ( pTableFlagRead[TableFlagReadNb].pszEntryName, pszEntryName );
            strcpy ( pTableFlagRead[TableFlagReadNb].pszBaseName, (*pRDB)->Header.szRDBName );

            //Mise a jour du compteur
            TableFlagReadNb++;
        }
        else
        {
            //Recherche l'entree correspondante
            for (i=0;i<TableFlagReadNb;i++)
            {
                if ( ( strcmp ( pTableFlagRead[i].pszRootDirectoryName, pszRootDirectoryName ) == 0 ) &&
                     ( strcmp ( pTableFlagRead[i].pszEntryName, pszEntryName ) == 0 ) &&
                     ( strcmp ( pTableFlagRead[i].pszBaseName, (*pRDB)->Header.szRDBName ) == 0 ) &&
                     ( pTableFlagRead[i].OwnerId == (*pRDB)->SupervisorOwnerID ) )
                {
                    //On a trouve !
                    free ( pTableFlagRead[i].pszRootDirectoryName );
                    free ( pTableFlagRead[i].pszEntryName );
                    free ( pTableFlagRead[i].pszBaseName );

                    //On deplace
                    if ((TableFlagReadNb-(i+1))>0)
                        memcpy ( &pTableFlagRead[i], &pTableFlagRead[i+1], (TableFlagReadNb-(i+1)) * sizeof(FLAG_READ_TABLE) );

                    //Reallocation
                    pTableFlagRead = (FLAG_READ_TABLE *) realloc ( pTableFlagRead, (TableFlagReadNb-1) * sizeof(FLAG_READ_TABLE) );

                    //Mise a jour du compteur
                    TableFlagReadNb--;


                    return;
                }
            }
        }
        
    }
    */


    long ServerMessage ( NETWORKDATALINK * pNDLClient, SCISTATE * psciState, SRDB ** pRDBBase, unsigned long NbMaxBases, unsigned long * pElapsedTime )
    {
        long                Retour;
        unsigned char       *pInData;
        unsigned long       InLength;
        unsigned char       IdTrame;
        DWORD               dwTimeStart;

        //Temps de depart
        dwTimeStart = TickGetCount2 ( );
        pInData     = NULL;
        InLength    = 0;

        //On teste si on vient de recevoir les donnees
        Retour = NDLReceiveData ( pNDLClient, &IdTrame, &pInData, &InLength );
        if (Retour) return -1;


        return ServerMessageManage ( pNDLClient, psciState, pRDBBase, NbMaxBases, pElapsedTime, IdTrame, pInData, InLength, dwTimeStart );
    }

    long lOnSupervisorAsk = 0;
    long lOnSupervisorOk = 0;
    long lOffSupervisorAsk = 0;
    long lOffSupervisorOk = 0;
    long lOnReadAsk = 0;
    long lOnReadOk = 0;
    long lOffReadAsk = 0;
    long lOffReadOk = 0;

    long lTotalSupervisor = 0;
    long lTotalReadCount = 0;


unsigned char ServerMessageManage_SecuredUser ( 
    NETWORKDATALINK * pNDLClient, 
    DWORD dwIdTrameSecure, 
    BYTE *pmsSecureStream, 
    DWORD dwSecureStreamLen, 
    SRDB ** pRDBBase, 
    unsigned long NbMaxBases,
    BYTE ** pbOutData,
    unsigned long * pdwOutLength,
	SCISTATE * psciState );



    /*
        Gestion des messages

        On utilise "lUserData" de pNDLClient !
            => 0  Demande de passage en mode Superviseur
            => 1  Acceptation de passage en mode Superviseur
            => 2  Demande d'augmentation du mode Read
            => 3  Acceptation 


    */

    long ServerMessageManage ( NETWORKDATALINK * pNDLClient, SCISTATE * psciState, 
                               SRDB ** pRDBBase, unsigned long NbMaxBases, unsigned long * pElapsedTime,
                               unsigned char IdTrame, unsigned char *pInData, unsigned long InLength, DWORD dwTimeStart )
    {
        long                Retour;
        DWORD               dwTimeEnd;
        unsigned char       *pOutData,  *pData;
        unsigned long       OutLength;//,  DataLength;
        unsigned char       OutMalloc;
        //unsigned long       SizeOfOneElement;
        //unsigned long       CountOfElements;

        SRDB                **pRDB;
        _TRDBMemoryStream   MS;
        //char                szRDBName[64];
        //char                szRootDirectoryName[2048];
        //char                szDirectoryName[256];
        //char                szFileName[256];
        //char                szDataName[256];
        //char                szEntryName[256];
        //SRDB_LIST           *pList;
        //unsigned long       NbList; //, Index;//, i;
        //unsigned char       Mode;
        //long                bFlagReadOnly;
        //long                bChangeFlag;
        //char szText[1024];

        //Par defaut, pas de donnees de retour
        pData       =   NULL;
        pOutData    =   NULL;
        OutLength   =   0;
        Retour      =   0;
        OutMalloc   =   FALSE;
        pRDB        =   NULL;
        
        

        //COM_Printf ( "ServerMessageManage : TrameID 0x%02x => %d octets", IdTrame, InLength );

        switch (IdTrame)
        {
            case RDB_ACCESS_CLIENT_INTERFACE_GETKEY:
                if (!ServerClientInterface_GetState(&(psciState->sciLink)))
                {
                    DWORD dwInterfaceID;
                    long lIndexPassword, lIndex, lPasswordDisabled;
                    unsigned char * pbPasswordSHA512;
                    //unsigned char pbPasswordSHA512Test[64];
                    
                    lIndexPassword = -1;
                    lPasswordDisabled = 0;

                    _RDBMemoryStreamOpen ( &MS, pInData );
                    _RDBMemoryStreamGet_ULONG ( &MS, &dwInterfaceID );
                    _RDBMemoryStreamGet_ULONG ( &MS, (unsigned long *)&lIndexPassword );
                    
                    //Recuperation du mot de passe
                    CriticalSectionEnter ( &GlobalData.csConfigAccess );
                    if ((lIndexPassword>=0)&&(lIndexPassword<64))
                    {
                        psciState->lAdminMode = 0;
                        //Le mot de passe est actif !
                        if (ConfigDataEx.TableUserPassword[lIndexPassword].lFlag&1)
                        {
                            pbPasswordSHA512 = ConfigDataEx.TableUserPassword[lIndexPassword].bPasswordSHA512;
                            lPasswordDisabled = 1;
                        }
                        else                        
                            pbPasswordSHA512 = NULL;
                    }
                    else
                    {
                        psciState->lAdminMode = 1;
                        pbPasswordSHA512 = ConfigDataEx.bPasswordAdminSHA512;                        
                        lPasswordDisabled = 0;
                        for (lIndex=0;lIndex<64;lIndex++)
                        {
                            if (ConfigDataEx.bPasswordAdminSHA512[lIndex]==0) lPasswordDisabled+=1;
                        }
                        if (lPasswordDisabled==64)
                        {
                            sha512 ( "admin", 5, ConfigDataEx.bPasswordAdminSHA512 );
                        }
                    }                    
                    
                    //sha512 ( "user1", 5, pbPasswordSHA512Test );
                    //pbPasswordSHA512 = pbPasswordSHA512Test;
                    
                    
                    //On ne peut pas acceder a un utilisateur sans mot de passe
                    if ( ((lPasswordDisabled==0)&&(psciState->lAdminMode==0)) || (!pbPasswordSHA512) )
                    {
                        IdTrame = ID_RDBAccessNetwork_Refuse;
                    }
                    else
                    {
                        /*
                        ** Generation de la valeur aleatoire (FKey)
                        */
                        ServerClientInterface_MakeFKey ( &(psciState->sciLink) );
                        
                        //ServerClientInterface_ConvertHashToText ( szText, psciState->sciLink.interface_bFKey, 32 );
                        //COM_Printf ( "FKey\n%s\n\n", szText );
                    
                        /*
                        ** Generation de la clef du mot de passe (PKey)
                        */
                        ServerClientInterface_MakePKey ( &(psciState->sciLink), pbPasswordSHA512 );
                        
                        //ServerClientInterface_ConvertHashToText ( szText, psciState->sciLink.interface_bPKey, 32 );
                        //COM_Printf ( "PKey\n%s\n\n", szText );
                        
                        /*
                        ** Generation de AKey = ( FKey ^ PKey )
                        */
                        ServerClientInterface_MakeAKey ( &(psciState->sciLink) );
                        
                        //ServerClientInterface_ConvertHashToText ( szText, psciState->sciLink.interface_bAKey, 32 );
                        //COM_Printf ( "AKey\n%s\n\n", szText );
                        
                        _RDBMemoryStreamOpen ( &MS, NULL );
                        _RDBMemoryStreamAdd_RAW ( &MS, ServerClientInterface_GetAKey(&(psciState->sciLink)), 256 );

                        pOutData    = MS.pBuffer;
                        OutLength   = MS.BufferLength;

                        IdTrame = ID_RDBAccessNetwork_Accept;
                    }
                    
                    CriticalSectionLeave ( &GlobalData.csConfigAccess );
                }
                else IdTrame = ID_RDBAccessNetwork_Refuse;
                break;

            case RDB_ACCESS_CLIENT_INTERFACE_GETAUTH:
                Retour = -1;
                if (!ServerClientInterface_GetState( &(psciState->sciLink) ))
                {
                    BYTE *pbKeyB;
                    DWORD dwLenKeyB;

                    pbKeyB = NULL;
                    _RDBMemoryStreamOpen ( &MS, pInData );
                    _RDBMemoryStreamGet_RAW ( &MS, &pbKeyB, &dwLenKeyB );

                    if (dwLenKeyB==256)
                    {
                        /*
                        ** On a recu la BKey, on va creer la GKey
                        */
                        ServerClientInterface_MakeGKey ( &(psciState->sciLink), pbKeyB );

                        //ServerClientInterface_ConvertHashToText ( szText, psciState->sciLink.interface_bGKey, 32 );
                        //COM_Printf ( "GKey\n%s\n\n", szText );
                        
                        /*
                        ** On peut maintenant creer la TxRxKey
                        */
                        ServerClientInterface_MakeTxRxKey ( &(psciState->sciLink) );
                        
                        //ServerClientInterface_ConvertHashToText ( szText, psciState->sciLink.interface_bTxRxKeySHA512, 64 );
                        //COM_Printf ( "TxRxKey\n%s\n\n", szText );
                        
                        /*
                        ** La connexion est etablie...
                        ** Attention, elle n'est pas encore certifier... Il faut attendre la trame de test !
                        */
                        ServerClientInterface_SetStateIdentifiant ( &(psciState->sciLink), 1, pNDLClient->Identifiant );
                        Retour = 0;
                        
                        
                        /*
                        ServerClientInterface_MakeAKey ( &(psciState->sciLink) );

                        if (memcmp(ServerClientInterface_GetAKey( &(psciState->sciLink) ),pbKeyB,256)==0)
                        {
                            if (!ServerClientInterface_GetState(&(psciState->sciLink)))
                            {
                                ServerClientInterface_SetStateIdentifiant ( &(psciState->sciLink), 1, pNDLClient->Identifiant );
                                ServerClientInterface_MakeTxRxKey ( &(psciState->sciLink) );
                                Retour = 0;
                            }
                        }
                        */
                    }
                    if (pbKeyB) KERNEL_FREE ( pbKeyB );
                }                    
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case RDB_ACCESS_CLIENT_INTERFACE_SENDADMINMESSAGE:
                if ( (ServerClientInterface_GetState(&(psciState->sciLink))) &&
                     (pNDLClient->Identifiant==ServerClientInterface_GetIdentifiant(&(psciState->sciLink))) )
                {
                    DWORD dwParamA;
                    DWORD dwParamB;
                    DWORD dwFlags;
                    DWORD dwStreamDataLen_A;
                    DWORD dwStreamDataLen_B;
                    DWORD dwStreamDataLen_C;
                    DWORD dwStreamDataLen_D;
                    BYTE *pStreamData_A;
                    BYTE *pStreamData_B;
                    BYTE *pStreamData_C;
                    BYTE *pStreamData_D;
                    char szStream_A[1024];
                    char szStream_B[1024];
                    char szStream_C[1024];
                    char szStream_D[1024];
                    
                    szStream_A[0] = 0;
                    szStream_B[0] = 0;
                    szStream_C[0] = 0;
                    szStream_D[0] = 0;
                    
                    //Decryptage et decodage de la trame
                    _RDBMemoryStreamOpen ( &MS, NULL );                    

                    if (ServerClientInterface_Decrypt (
                        &(psciState->sciLink),
                        pInData,
                        InLength,
                        &MS.pBuffer,
                        (long *)(&MS.BufferLength) ))
                    {
                        IdTrame = ID_RDBAccessNetwork_Refuse;
                        break;
                    }
                        
                    
                        
                    _RDBMemoryStreamGet_ULONG ( &MS, &dwParamA );
                    _RDBMemoryStreamGet_ULONG ( &MS, &dwParamB );
                    _RDBMemoryStreamGet_ULONG ( &MS, &dwFlags );

                    if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_A)
                        _RDBMemoryStreamGet_STRING ( &MS, szStream_A );
                        
                    if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_B)
                        _RDBMemoryStreamGet_STRING ( &MS, szStream_B );

                    if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_C)
                        _RDBMemoryStreamGet_STRING ( &MS, szStream_C );

                    if (dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_STRING_D)
                        _RDBMemoryStreamGet_STRING ( &MS, szStream_D );

                    if (!(dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_A)) pStreamData_A = NULL;
                    else _RDBMemoryStreamGet_RAW ( &MS, &pStreamData_A, &dwStreamDataLen_A );

                    if (!(dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_B)) pStreamData_B = NULL;
                    else _RDBMemoryStreamGet_RAW ( &MS, &pStreamData_B, &dwStreamDataLen_B );
                    
                    if (!(dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_C)) pStreamData_C = NULL;
                    else _RDBMemoryStreamGet_RAW ( &MS, &pStreamData_C, &dwStreamDataLen_C );

                    if (!(dwFlags&RDB_ACCESS_CLIENT_INTERFACE_SAM_FLAGS_RAW_D)) pStreamData_D = NULL;
                    else _RDBMemoryStreamGet_RAW ( &MS, &pStreamData_D, &dwStreamDataLen_D );
                        

                    _RDBMemoryStreamClose ( &MS );
                    
                    if (dwParamA&0xFFFF)
                    {
                        
                        if (psciState->lAdminMode==0)
                        {
                            //En mode user, on ne peut pas attaquer les commandes admin !
                            IdTrame = ID_RDBAccessNetwork_Refuse;
                        }
                        else
                        {                       
                            //En mode admin, on peut attaquer les commandes admin
                            switch (dwParamA&0xFFFF)
                            {
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_GetStats: //Recuperation des stats
                                    {
                                        long lClientCount;
                                        SCISTATE * pscisClient;
                                        long i;
                                        
                                        lClientCount = -1;
                                        
                                        //if (GlobalData.pscisClient)
                                        if (GlobalData.lSCISClientCount)
                                        {
                                            lClientCount = GlobalData.lSCISClientCount;
                                            pscisClient = (SCISTATE *)KERNEL_ALLOC ( sizeof(SCISTATE) * lClientCount );
                                            memcpy ( pscisClient, GlobalData.pscisClientTable, sizeof(SCISTATE) * lClientCount );
                                        }
                                        else pscisClient = NULL;
                                        
                                        if (pscisClient)
                                        {
                                        
                                            _RDBMemoryStreamOpen ( &MS, NULL );
                                            _RDBMemoryStreamAdd_ULONG ( &MS, lClientCount );
                                            
                                            for (i=0;i<lClientCount;i++)
                                            {
                                                _RDBMemoryStreamAdd_ULONG ( &MS, pscisClient[i].dwSocket );
                                                _RDBMemoryStreamAdd_ULONG ( &MS, pscisClient[i].dwPort );
                                                _RDBMemoryStreamAdd_ULONG ( &MS, pscisClient[i].dwState );
                                                _RDBMemoryStreamAdd_ULONG ( &MS, (unsigned long)pscisClient[i].lWatchdogTime );
                                                _RDBMemoryStreamAdd_ULONG ( &MS, (unsigned long)pscisClient[i].lIdentifiant );
                                                _RDBMemoryStreamAdd_STRING ( &MS, pscisClient[i].szPeerName );
                                                _RDBMemoryStreamAdd_STRING ( &MS, pscisClient[i].szIPName );
                                            }
                                            
                                            KERNEL_FREE ( pscisClient );
                                            IdTrame     = ID_RDBAccessNetwork_Accept;
                                            
                                            ServerClientInterface_Encrypt (
                                                &(psciState->sciLink),
                                                MS.pBuffer,
                                                MS.BufferLength,
                                                &pOutData,
                                                (long *)&OutLength );
                                            
                                            _RDBMemoryStreamClose ( &MS );
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                        
                                    }
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_KillSession:
                                    //COM_Printf ( "ETA:1" );
                                    IdTrame = ID_RDBAccessNetwork_Refuse;
                                    if (dwParamB!=ServerClientInterface_GetIdentifiant(&(psciState->sciLink)))
                                    {
                                        long i;

                                        //Recherche le client
                                        for (i=0;i<GlobalData.lNbClients;i++)
                                        {
                                            //COM_Printf ( "ETA:n(%d)",i );
                                            if (GlobalData.pClientEntry[i].NDLClient.Identifiant==dwParamB)
                                            {

                                                ServerKillSession ( 
                                                    &(GlobalData.pClientEntry[i].NDLClient), 
                                                    pRDBBase, 
                                                    NbMaxBases );


                                                i = GlobalData.lNbClients+1;

                                                IdTrame = ID_RDBAccessNetwork_Accept;
                                            }
                                        }
                                        
                                    }
                                    break;

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBGetFileList:

                                    if (GlobalData.lNbClients>1)
                                        IdTrame = ID_RDBAccessNetwork_Refuse;
                                    else
                                    {
                                        SRDB_HEADER * pEntryData;
                                        long lEntryCount;
                                        long i;

                                        ListBaseClose ( );

                                        lEntryCount = 0;
                                        RDBFindFileList(&pEntryData,&lEntryCount);

                                        _RDBMemoryStreamOpen ( &MS, NULL );
                                        _RDBMemoryStreamAdd_ULONG ( &MS, lEntryCount );
                                        for (i=0;i<lEntryCount;i++)
                                        {
                                            _RDBMemoryStreamAdd_ULONG ( &MS, pEntryData[i].size );
                                            _RDBMemoryStreamAdd_STRING ( &MS, pEntryData[i].szRDBName );
                                        }

                                        KERNEL_FREE ( pEntryData );

                                        ServerClientInterface_Encrypt (
                                            &(psciState->sciLink),
                                            MS.pBuffer,
                                            MS.BufferLength,
                                            &pOutData,
                                            (long *)&OutLength );

                                        _RDBMemoryStreamClose ( &MS );

                                        IdTrame = ID_RDBAccessNetwork_Accept;
                                    }

                                    break;

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBLoadFile:
                                    IdTrame = ID_RDBAccessNetwork_Refuse;
                                    /*

                                    if (GlobalData.lNbClients==1)
                                    {
                                        long lFileSize;
                                        unsigned char * pFileData;

                                        ListBaseClose ( );

                                        if (!RDBLoadAsRaw(szStream_A,&pFileData,&lFileSize))
                                        {
                                            ServerClientInterface_Encrypt (
                                                &(psciState->sciLink),
                                                pFileData,
                                                lFileSize,
                                                &pOutData,
                                                (long *)&OutLength );

                                            KERNEL_FREE ( pFileData );
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                    }
                                    */
                                    break;

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBSaveFile:
                                    IdTrame = ID_RDBAccessNetwork_Refuse;
                                    /*
                                    if (GlobalData.lNbClients==1)
                                    {
                                        ListBaseClose ( );

                                        if (!RDBSaveFromRaw(szStream_A,pStreamData_A,dwStreamDataLen_A))
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                    }
                                    */
                                    break;

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBSaveFilePacket:
                                    IdTrame = ID_RDBAccessNetwork_Refuse;

                                    if (GlobalData.lNbClients==1)
                                    {
                                        ListBaseClose ( );
                                        /*
                                            dwParamA = Type de trame (dj gr)
                                            dwParamB = Offset en octets des donnes  lire/crire
                                            szStream_A = Nom du fichier (dj gr)
                                            pStreamData_A = pointeur sur le bloc  lire/crire
                                            dwStreamDataLen_A = Taille du bloc  lire/crire
                                        */
                                        if (!RDBSaveFromRawPacket(szStream_A,dwParamB,pStreamData_A,dwStreamDataLen_A))
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                    }

                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_RDBLoadFilePacket:
                                    IdTrame = ID_RDBAccessNetwork_Refuse;

                                    if (GlobalData.lNbClients==1)
                                    {
                                        long lLenFile;
                                        long lBlockLen;
                                        unsigned char *pBlockData;
                                        
                                        ListBaseClose ( );
                                        /*
                                            dwParamA = Type de trame (dj gr)
                                            dwParamB = Offset en octets des donnes  lire/crire
                                            szStream_A = Nom du fichier (dj gr)
                                        */
                                        pBlockData = (unsigned char *)KERNEL_ALLOC ( 262144 );
                                        if (!RDBLoadAsRawPacket(szStream_A,&lLenFile,dwParamB,262144,pBlockData,&lBlockLen))
                                        {
                                            _RDBMemoryStreamOpen ( &MS, NULL );
                                            _RDBMemoryStreamAdd_ULONG ( &MS, lLenFile );
                                            _RDBMemoryStreamAdd_RAW ( &MS, pBlockData, lBlockLen );

                                            ServerClientInterface_Encrypt (
                                                &(psciState->sciLink),
                                                MS.pBuffer,
                                                MS.BufferLength,
                                                &pOutData,
                                                (long *)&OutLength );
                                                
                                                
                                            _RDBMemoryStreamClose ( &MS );
                                            
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        KERNEL_FREE ( pBlockData );
                                    }
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_SetAdminPassword:
                                    if ((dwStreamDataLen_A==128)&&(CommandData.iDisableRemoteAdminPasswordChange==0))
                                    {
                                        long lValueZero;
                                        long i;
                                        
                                        CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                        
                                        lValueZero = 1;
                                        for (i=0;i<64;i++)
                                        {
                                            if (ConfigDataEx.bPasswordAdminSHA512[i]) lValueZero = 0;
                                        }
                                        
                                        if ((memcmp(ConfigDataEx.bPasswordAdminSHA512,pStreamData_A,64)==0)||(lValueZero))
                                        {                                        
                                            memcpy ( ConfigDataEx.bPasswordAdminSHA512, pStreamData_A+64, 64 );
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                        
                                        CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                    }
                                    else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserPassword:
                                    {
                                        DWORD dwIndexPassword;                                        
                                        dwIndexPassword = (dwParamA>>16)&0xFFFF;
                                        
                                        if ( (dwStreamDataLen_A==64) &&
                                            (dwIndexPassword>=0) &&
                                            (dwIndexPassword<64) )
                                        {
                                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                            
                                            memcpy ( 
                                                ConfigDataEx.TableUserPassword[dwIndexPassword].bPasswordSHA512, 
                                                pStreamData_A, 
                                                64 );
                                                
                                            //ConfigDataEx.TableUserPassword[dwIndexPassword].lFlag = 0;
                                                
                                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                            
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    }
                                    break;                                    

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserFlag:
                                    {
                                        DWORD dwIndexPassword;                                        
                                        dwIndexPassword = (dwParamA>>16)&0xFFFF;
                                        if ((dwIndexPassword>=0) &&
                                            (dwIndexPassword<64) )
                                        {
                                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                            ConfigDataEx.TableUserPassword[dwIndexPassword].lFlag = dwParamB;
                                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    }
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_SetUserDescription:
                                    {
                                        DWORD dwIndexPassword;                                        
                                        dwIndexPassword = (dwParamA>>16)&0xFFFF;
                                        
                                        if ((strlen(szStream_A)>0) &&
                                            (dwIndexPassword>=0) &&
                                            (dwIndexPassword<64) )
                                        {
                                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                            
                                            strcpy ( 
                                                ConfigDataEx.TableUserPassword[dwIndexPassword].szDescription,
                                                szStream_A );
                                                
                                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                            
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    }
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_GetUserInfo:
                                    {
                                        DWORD dwIndexPassword;                                        
                                        dwIndexPassword = (dwParamA>>16)&0xFFFF;
                                        if ((dwIndexPassword>=0) &&
                                            (dwIndexPassword<64) )
                                        {
                                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                            _RDBMemoryStreamOpen ( &MS, NULL );
                                            _RDBMemoryStreamAdd_ULONG ( &MS, ConfigDataEx.TableUserPassword[dwIndexPassword].lFlag );
                                            _RDBMemoryStreamAdd_STRING ( &MS, ConfigDataEx.TableUserPassword[dwIndexPassword].szDescription );
                                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                            
                                            ServerClientInterface_Encrypt (
                                                &(psciState->sciLink),
                                                MS.pBuffer,
                                                MS.BufferLength,
                                                &pOutData,
                                                (long *)&OutLength );

                                            _RDBMemoryStreamClose ( &MS );
                                            
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    }
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_KillUser:
                                    {
                                        DWORD dwIndexPassword;                                        
                                        dwIndexPassword = (dwParamA>>16)&0xFFFF;
                                        if ((dwIndexPassword>=0) &&
                                            (dwIndexPassword<64) )
                                        {
                                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                                            memset ( &(ConfigDataEx.TableUserPassword[dwIndexPassword]), 0, sizeof(PASSWORDID) );
                                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                                            IdTrame = ID_RDBAccessNetwork_Accept;
                                        }
                                        else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    }
                                    break;

                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_SoftUpdate:
                                    if (CommandData.iDisableRemoteUpdate)
                                    {
                                        IdTrame = ID_RDBAccessNetwork_Refuse;
                                        break;
                                    }
                                
                                    if ( (strlen(szStream_A)>0) &&
                                         (dwStreamDataLen_A>0) )
                                    {
                                        long lError;
                                        
                                        //C'est complique de faire un auto update
                                        lError = jocareso_autoupdate ( 
                                            pStreamData_A, dwStreamDataLen_A, szStream_A, //Le nouveau fichier a ecrire
                                            pStreamData_B, szStream_B );                  //Le script
                                        
                                        _RDBMemoryStreamOpen ( &MS, NULL );
                                        _RDBMemoryStreamAdd_ULONG ( &MS, lError );
                                            
                                        ServerClientInterface_Encrypt (
                                            &(psciState->sciLink),
                                            MS.pBuffer,
                                            MS.BufferLength,
                                            &pOutData,
                                            (long *)&OutLength );

                                        _RDBMemoryStreamClose ( &MS );
                                        
                                        IdTrame = ID_RDBAccessNetwork_Accept;
                                    }
                                    else IdTrame = ID_RDBAccessNetwork_Refuse;
                                    break;
                                    
                                case RDB_ACCESS_CLIENT_INTERFACE_SAM_GetVersion:
                                    {
                                        _RDBMemoryStreamOpen ( &MS, NULL );
                                        _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_NAME );
                                        _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_TYPE );
                                        
                                        _RDBMemoryStreamAdd_ULONG ( &MS, JOCARESO_PROTOCOL_RELEASE );
                                        _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_GEN );
                                        _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_MAJOR );
                                        _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_MINOR );
                                        
                                        _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_UPDATE_FILEOS_LETTER );
                                        
                                        _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_VERSION_TEXTINFO );
                                        
                                        _RDBMemoryStreamAdd_STRING ( &MS, SYS_GetCurrentPath ( ) );
                                        _RDBMemoryStreamAdd_STRING ( &MS, SYS_GetHomePath ( ) );
                                        _RDBMemoryStreamAdd_STRING ( &MS, SYS_GetInstallPath ( ) );
                                        _RDBMemoryStreamAdd_STRING ( &MS, SYS_GetExecRunApp ( ) );
                                        
                                        _RDBMemoryStreamAdd_UCHAR ( &MS, (unsigned char)SYS_RunSimpleModeGet ( ) );
                                        
                                        
                                        _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerComputerName );
                                        _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerHostName ); 
                                        _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerIP );
                                                                      
                                   //$(OutDir)Debug/jocareso-win32.exe       
                                        
#ifdef _WIN32
                                        _RDBMemoryStreamAdd_STRING ( &MS, "-" );
                                        _RDBMemoryStreamAdd_STRING ( &MS, "-" );
#else
                                        _RDBMemoryStreamAdd_STRING ( &MS, LINUX_PATHEXE );
                                        _RDBMemoryStreamAdd_STRING ( &MS, SYSTEM_PATHROOT );
#endif

                                        ServerClientInterface_Encrypt (
                                            &(psciState->sciLink),
                                            MS.pBuffer,
                                            MS.BufferLength,
                                            &pOutData,
                                            (long *)&OutLength );

                                        _RDBMemoryStreamClose ( &MS );
                                    }
                                    IdTrame = ID_RDBAccessNetwork_Accept;
                                    break;

                                default:
                                    IdTrame = ID_RDBAccessNetwork_Refuse;
                                    break;
                                    
                                case 0:
                                    //Le param vaut 0, c'est juste un essai de transmission
                                    IdTrame = ID_RDBAccessNetwork_Accept;
                                    break;
                            }
                        }
                    }
                    else
                    {
                        //si dwParam&0xFFFF vaut 0, c'est juste un essai de transmission
                        IdTrame = ID_RDBAccessNetwork_Accept;
                    }
                        
                    if (pStreamData_A) KERNEL_FREE ( pStreamData_A );
                    if (pStreamData_B) KERNEL_FREE ( pStreamData_B );
                    if (pStreamData_C) KERNEL_FREE ( pStreamData_C );
                    if (pStreamData_D) KERNEL_FREE ( pStreamData_D );
                }
                else
                {
                    IdTrame = ID_RDBAccessNetwork_Refuse;
                }
                
                break;
                
            case RDB_ACCESS_CLIENT_CONNECT:
                IdTrame = ID_RDBAccessNetwork_Refuse;
                break;

            case RDB_ACCESS_CLIENT_CONNECTEX:
                _RDBMemoryStreamOpen ( &MS, NULL );
                _RDBMemoryStreamAdd_ULONG  ( &MS, pNDLClient->Identifiant );
                _RDBMemoryStreamAdd_ULONG  ( &MS, JOCARESO_PROTOCOL_RELEASE ); //On envoi la version du protocole en cours !
                pOutData    = MS.pBuffer;
                OutLength   = MS.BufferLength;
                IdTrame |= RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                pNDLClient->ClientConnected = 1;
                break;
                       
            case RDB_ACCESS_CLIENT_DECONNECT:
                IdTrame |= RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                pNDLClient->ClientConnected = 0;
                break;

            case RDB_ACCESS_CLIENT_WATCHDOG:
                //IdTrame |= RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                IdTrame = 0;
                break;
                
            case RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP1:
                if (CommandData.iDisableRemoteAdminPasswordReinit)
                {
                    IdTrame = ID_RDBAccessNetwork_Refuse;
                    break;
                }
                
                //On demande un paquet de 1024 octets totalement alatoire
                //On en fait 10000 sha-512 successifs
                //On envoit ce SHA-512 et on le mmorise en attendant le prochain paquet !
                
                if (psciState->sciLink.lAdminResetCount!=0)
                {
                    //On a deja demande un reset, on force la connection a se cloturer !
                    IdTrame = RDB_ACCESS_CLIENT_DECONNECT | RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                    pNDLClient->ClientConnected = 0;
                }
                else
                {
                    unsigned char bDataSource[1024], bDataRandom[1024];
                    long lIndex;
                    
                    psciState->sciLink.lAdminResetCount++;
                    
                    memset ( bDataSource, 0, 1024 );
                    *((unsigned long *)(&bDataSource[0])) = TickGetCount2 ( );                    
                    Crypt64_DataXORKey ( bDataSource, 1024, (unsigned char *)pNDLClient, sizeof(NETWORKDATALINK) );
                    Crypt64_DataXORKey ( bDataSource, 1024, (unsigned char *)psciState, sizeof(SCISTATE) );
                    KeyCreateHashValue ( bDataRandom, 1024, bDataSource, 1024 );
                    
                    sha512 ( bDataRandom, 1024, psciState->sciLink.bAdminResetSHA512 );
                    
                    for (lIndex=0;lIndex<2000;lIndex++)
                    {
                        memcpy ( bDataRandom, psciState->sciLink.bAdminResetSHA512, 64 );
                        sha512 ( bDataRandom, 64, psciState->sciLink.bAdminResetSHA512 );
                    }
                    
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_RAW  ( &MS, psciState->sciLink.bAdminResetSHA512, 64 );
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    
                    IdTrame = ID_RDBAccessNetwork_Accept;
                }
                
                break;
                
            case RDB_ACCESS_CLIENT_INTERFACE_RESETADMINPASSWORD_STEP2:
                if (CommandData.iDisableRemoteAdminPasswordReinit)
                {
                    IdTrame = ID_RDBAccessNetwork_Refuse;
                    break;
                }
            
                //On reoit un SHA-512
                //On fait un sha-512
                if (psciState->sciLink.lAdminResetCount!=1)
                {
                    //On a deja demande un reset, on force la connection a se cloturer !
                    IdTrame = RDB_ACCESS_CLIENT_DECONNECT | RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                    pNDLClient->ClientConnected = 0;
                }
                else
                {
                    unsigned char /*bSHA512_a[64],*/ bSHA512_aprime[64];
                    unsigned char bSHA512_b[64], bSHA512_bprime[64];
                    long lError;
                    long lIndex;
                    long lDataGetLength;
                    unsigned char * pbDataGet;
                    
                    lError = 1;

                    _RDBMemoryStreamOpen ( &MS, pInData );
                    _RDBMemoryStreamGet_RAW ( &MS, &pbDataGet, &lDataGetLength );
                    
                    if (lDataGetLength==64)
                    {
                        memcpy ( bSHA512_b, pbDataGet, 64 );
                        lError = 0;
                    }
                    
                    KERNEL_FREE (pbDataGet);
                    
                    if (!lError)
                    {
                        //Calcul de a'
                        memcpy ( bSHA512_aprime, psciState->sciLink.bAdminResetSHA512, 64 );
                        for (lIndex=0;lIndex<10000;lIndex++)
                        {
                            //memcpy ( bSHA512_a, bSHA512_aprime, 64 );
                            //sha512 ( bSHA512_a, 64, bSHA512_aprime );
                            sha512 ( bSHA512_aprime, 64, bSHA512_aprime );
                        }
                        
                        //Calcul de b'
                        memcpy ( bSHA512_bprime, bSHA512_b, 64 );
                        for (lIndex=0;lIndex<1000;lIndex++)
                        {
                            //memcpy ( bSHA512_b, bSHA512_bprime, 64 );
                            //sha512 ( bSHA512_b, 64, bSHA512_bprime );
                            sha512 ( bSHA512_bprime, 64, bSHA512_bprime );
                        }
                        
                        //a' == b'
                        if (!memcmp(bSHA512_aprime,bSHA512_bprime,64))
                        {
                            lError = 0;
                            CriticalSectionEnter ( &GlobalData.csConfigAccess );
                            memset ( ConfigDataEx.bPasswordAdminSHA512, 0, 64 );
                            CriticalSectionLeave ( &GlobalData.csConfigAccess );
                        }
                        else lError = -1;
                    }
                    
                    if (lError)
                        IdTrame = RDB_ACCESS_CLIENT_DECONNECT | RDB_ACCESS_SERVER_ACQ_BACK_MASK;
                    else
                        IdTrame = ID_RDBAccessNetwork_Accept;
                        
                    pNDLClient->ClientConnected = 0;
                }
                break;
            
                

            /*
            **  Communication en mode securisee
            */
            case RDB_ACCESS_CLIENT_INTERFACE_SECURECMD:
                if ( (ServerClientInterface_GetState(&(psciState->sciLink))) &&
                     (pNDLClient->Identifiant==ServerClientInterface_GetIdentifiant(&(psciState->sciLink))) )
                {
                    DWORD               dwIdTrameSecure;
                    BYTE                *pSecureStream;
                    DWORD               dwSecureStreamLen;
                    
                    //Decryptage et decodage de la trame
                    _RDBMemoryStreamOpen ( &MS, NULL );                    
                    if (ServerClientInterface_Decrypt (
                        &(psciState->sciLink),
                        pInData,
                        InLength,
                        &MS.pBuffer,
                        (long *)(&MS.BufferLength) ))
                    {
                        IdTrame = ID_RDBAccessNetwork_Refuse;
                        break;
                    }

                    pSecureStream = NULL;                        
                    _RDBMemoryStreamGet_ULONG ( &MS, &dwIdTrameSecure );
                    _RDBMemoryStreamGet_RAW ( &MS, &pSecureStream, &dwSecureStreamLen );
                    _RDBMemoryStreamClose ( &MS );
                    
                    IdTrame = ServerMessageManage_SecuredUser ( 
                        pNDLClient, 
                        dwIdTrameSecure, 
                        pSecureStream, 
                        dwSecureStreamLen,
                        pRDBBase, 
                        NbMaxBases,
                        &MS.pBuffer,
                        &MS.BufferLength,
						psciState);
                        
                        
                    if (pSecureStream)    
                        KERNEL_FREE ( pSecureStream );

                    OutLength = 0;                    
                    pOutData = NULL;
                    
                    if (MS.BufferLength)
                    {
                        ServerClientInterface_Encrypt (
                            &(psciState->sciLink),
                            MS.pBuffer,
                            MS.BufferLength,
                            &pOutData,
                            (long *)&OutLength );

                        _RDBMemoryStreamClose ( &MS );
                    }
                }
                else IdTrame = ID_RDBAccessNetwork_Refuse;
                break;
            /*
            case RDB_ACCESS_CLIENT_TransmitName:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szDataName );
                strcpy ( pNDLClient->szPeerName, szDataName );
                IdTrame = ID_RDBAccessNetwork_Accept;
                break;


            case ID_RDBAccessNetwork_MakeDirectory:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDirectoryName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBMakeDirectory ( pRDB, szRootDirectoryName, szDirectoryName );
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_KillDirectory:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDirectoryName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBKillDirectory ( pRDB, szRootDirectoryName, szDirectoryName );
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_DirectoryContentList:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBDirectoryContentList ( pRDB, szRootDirectoryName, &pList, &NbList );

                //Si le retour est juste, on rempli...
                if (!Retour)
                {
                    if (NbList)
                    {
                        _RDBMemoryStreamOpen ( &MS, NULL );
                        _RDBMemoryStreamAdd_ULONG ( &MS, NbList );
                        for (Index=0;Index<NbList;Index++)
                        {
                            _RDBMemoryStreamAdd_STRING ( &MS, pList[Index].szName );
                            _RDBMemoryStreamAdd_UCHAR  ( &MS, pList[Index].Identifiant );
                        }
                        pOutData    = MS.pBuffer;
                        OutLength   = MS.BufferLength;
                        KERNEL_FREE ( pList );
                    }

                }
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_MakeFile:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szFileName );
                _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBMakeFile ( pRDB, szRootDirectoryName, szFileName, pData, DataLength );
                KERNEL_FREE (pData);
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_KillFile:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szFileName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBKillFile ( pRDB, szRootDirectoryName, szFileName );
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_ReadFile:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szFileName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBReadFile ( pRDB, szRootDirectoryName, szFileName, &pData, &DataLength );
                if (!Retour)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_RAW ( &MS, pData, DataLength );
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    KERNEL_FREE ( pData );
                }
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_MakeData:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDataName );
                _RDBMemoryStreamGet_ULONG  ( &MS, &SizeOfOneElement );
                _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
                CountOfElements = DataLength / SizeOfOneElement;
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBMakeData ( pRDB, szRootDirectoryName, szDataName, pData, SizeOfOneElement, CountOfElements );
                KERNEL_FREE (pData);
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_KillData:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDataName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBKillData ( pRDB, szRootDirectoryName, szDataName );
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_ReadData:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDataName );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBReadData ( pRDB, szRootDirectoryName, szDataName, &pData, &SizeOfOneElement, &CountOfElements );
                if (!Retour)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_ULONG  ( &MS, SizeOfOneElement );
                    _RDBMemoryStreamAdd_RAW    ( &MS, pData, SizeOfOneElement * CountOfElements );
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    KERNEL_FREE ( pData );
                }
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_WriteData:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szDataName );
                _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBWriteData ( pRDB, szRootDirectoryName, szDataName, pData, DataLength );
                KERNEL_FREE (pData);
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;

            case ID_RDBAccessNetwork_SupervisorSet:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
                _RDBMemoryStreamGet_UCHAR  ( &MS, &Mode );
                pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour = RDBSupervisorSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
                
                //Rights Security Enforcement : Fixe le droit dans la RightsEntryList
                if (!Retour) RDBServerRightsSetSupervisor ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, (Mode)?(1):(0) );

                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                if (Mode)
                {
                    lOnSupervisorAsk++;
                    if (!Retour) lOnSupervisorOk++;
                }
                else
                {
                    lOffSupervisorAsk++;
                    if (!Retour) lOffSupervisorOk++;
                }
                break;

            case ID_RDBAccessNetwork_SupervisorGet:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
                pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour  = RDBSupervisorGet ( pRDB, szRootDirectoryName, szEntryName );
                if (Retour>=0)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_UCHAR  ( &MS, (unsigned char)Retour );
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    Retour      = 0;
                }
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;


            case ID_RDBAccessNetwork_ReadsCountSet:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
                _RDBMemoryStreamGet_UCHAR  ( &MS, &Mode );
                pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );

                //Rights Security Enforcement : Gestion des droits ReadOnly dans la liste RightsEntry
                bChangeFlag = 0;
                if (!RDBServerRightsGetReadOnly ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, &bFlagReadOnly ))
                {
                    long bMode;
                    bMode = (Mode)?(1):(0);
                    if (bMode!=bFlagReadOnly) bChangeFlag = 1;
                }
                else bChangeFlag = 1;

                if (bChangeFlag)
                {
                    Retour  = RDBReadsCountSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
                    if (!Retour) RDBServerRightsSetReadOnly ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, (Mode)?(1):(0) );
                }
                else Retour = 0;

                //Retour  = RDBReadsCountSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
                //if (Retour) FlagReadUpdate ( pRDB, szRootDirectoryName, szEntryName, Mode );
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                if (Mode)
                {

                    lOnReadAsk++;
                    if (!Retour) lOnReadOk++;
                }
                else
                {
                    lOffReadAsk++;
                    if (!Retour) lOffReadOk++;
                }

                break;

            case ID_RDBAccessNetwork_ReadsCountGet:
                _RDBMemoryStreamOpen ( &MS, pInData );
                _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
                _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
                _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
                pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
                Retour  = RDBReadsCountGet ( pRDB, szRootDirectoryName, szEntryName );
                if (Retour>=0)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_UCHAR  ( &MS, (unsigned char)Retour );
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    Retour      = 0;
                }
                IdTrame = (!Retour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
                break;
                */
            default:
                IdTrame = ID_RDBAccessNetwork_Refuse;
                break;
                
        }

        //Emission de la donnee de retour
        if (IdTrame) Retour = NDLSendData ( pNDLClient, IdTrame, pOutData, OutLength );
        else         Retour = 0;

        //Liberation de la memoire allouee
        KERNEL_FREE ( pInData  );
        KERNEL_FREE ( pOutData );

        //Liberation de la connexion avec la base
        if (pRDB) _RDBServerReleaseBase ( pRDB, pNDLClient );

        //Gestion du mode de deconnexion
        if ( (IdTrame&(~RDB_ACCESS_SERVER_ACQ_BACK_MASK)) == RDB_ACCESS_CLIENT_DECONNECT )
        {
            //Close interface access (if opened !)
            if ((ServerClientInterface_GetState(&(psciState->sciLink)))&&(pNDLClient->Identifiant==ServerClientInterface_GetIdentifiant(&(psciState->sciLink))))
            {
                ServerClientInterface_SetStateIdentifiant ( &(psciState->sciLink), 0, 0 );
            }

            ServerKillSession ( pNDLClient, pRDBBase, NbMaxBases );


            /*
            //Ici, il faut supprimer les droits que le client aurait oublie de faire sauter
            for (i=0;i<NbMaxBases;i++)
            {
                if (pRDBBase[i]!=NULL)
                {
                    FlagReadKill ( &pRDBBase[i], pNDLClient->Identifiant );   //Flag du mode Read
                    RDBEntry_KillSupervisor ( &pRDBBase[i], pNDLClient->Identifiant );
                }
            }

            NDLServerCloseClientConnection ( pNDLClient );
            pNDLClient->Socket = INVALID_SOCKET;
            */
        }

        //Temps de fin
        dwTimeEnd = TickGetCount2 ( );

        //Temps ecoule
        if (pElapsedTime) *pElapsedTime = ( dwTimeEnd - dwTimeStart );


        //Compte les etats
        /*
        lTotalSupervisor = 0;
        lTotalReadCount = 0;
        for (i=0;i<NbMaxBases;i++)
        {
            if (pRDBBase[i])
            {
                RDBEntry_QuerySupervisorFlags ( &pRDBBase[i], &lTotalSupervisor );
                RDBEntry_QueryReadCountFlags ( &pRDBBase[i],  &lTotalReadCount );
            }
        }
        */

        return Retour;
    }


    void ServerKillSession ( NETWORKDATALINK * pNDLClient, SRDB ** pRDBBase, unsigned long NbMaxBases )
    {
        //unsigned long i;

        //Ici, il faut supprimer les droits que le client aurait oublie de faire sauter
        //RDBServerRightsFreeFlags ( pNDLClient->Identifiant, pRDBBase, NbMaxBases );
        RDBServerRightsFree ( pNDLClient->Identifiant );
        /*
        for (i=0;i<NbMaxBases;i++)
        {
            if (pRDBBase[i]!=NULL)
            {

                FlagReadKill ( &pRDBBase[i], pNDLClient->Identifiant );   //Flag du mode Read
                RDBEntry_KillSupervisor ( &pRDBBase[i], pNDLClient->Identifiant );
            }
        }
        */
        NDLServerCloseClientConnection ( pNDLClient );
        pNDLClient->Socket = INVALID_SOCKET;
    }
                               

    SRDB ** _RDBServerGetBase ( char * pszBaseName, SRDB ** pRDBBase, long NbMaxBases, NETWORKDATALINK * pNDLClient )
    {
        long i;
        long NoFound;
        long Retour;

        //Recherche si la base est en memoire
        for (i=0,NoFound=-1;(i<NbMaxBases)&&(NoFound==-1);i++)
        {
            if (pRDBBase[i]!=NULL)
            {
                if (strucasecmp(pszBaseName,pRDBBase[i]->Header.szRDBName)==0) NoFound = i;
            }
        }

        //Si la base est deja en memoire on la renvoi
        if (NoFound!=-1) 
        {
            if (pNDLClient) pRDBBase[NoFound]->SupervisorOwnerID = pNDLClient->Identifiant;
            return &pRDBBase[NoFound];
        }

        //On recherche une base de libre
        for (i=0,NoFound=-1;(i<NbMaxBases)&&(NoFound==-1);i++)
        {
            if (pRDBBase[i]==NULL) NoFound = i;
        }

        //Aucune base de libre
        if (NoFound==-1) return NULL;

        //On charge une base (si possible)
        Retour = RDBLoad ( &pRDBBase[NoFound], pszBaseName );

        //La base a correctement ete chargee
        if (Retour==0)
        {
            if (pNDLClient) pRDBBase[NoFound]->SupervisorOwnerID = pNDLClient->Identifiant;
            return &pRDBBase[NoFound];
        }

        //La base n'existe pas, on la cree
        Retour = RDBCreate ( &pRDBBase[NoFound], pszBaseName );

        //La base n'a pas ete correctement creee
        if (Retour!=0) return NULL;

        //Retour final
        if (pNDLClient) pRDBBase[NoFound]->SupervisorOwnerID = pNDLClient->Identifiant;
        return &pRDBBase[NoFound];
    }

    void _RDBServerReleaseBase ( SRDB ** pRDBBase, NETWORKDATALINK * pNDLClient )
    {
        if (pNDLClient) (*pRDBBase)->SupervisorOwnerID = ENTRYFLAG_EMPTY;
    }


unsigned char ServerMessageManage_SecuredUser ( 
    NETWORKDATALINK * pNDLClient, 
    DWORD dwIdTrameSecure, 
    BYTE *pmsSecureStream, 
    DWORD dwSecureStreamLen, 
    SRDB ** pRDBBase, 
    unsigned long NbMaxBases,
    BYTE ** pbOutData,
    unsigned long * pdwOutLength,
	SCISTATE * psciState)
{
    char                szTmp[256];
    unsigned char       IdTrame;
    _TRDBMemoryStream   MS;
    BYTE                *pInData;
    char                szRDBName[64];
    char                szRootDirectoryName[2048];
    char                szDirectoryName[256];
    char                szFileName[256];
    char                szDataName[256];
    char                szEntryName[256];
    SRDB_LIST           *pList;
    SRDB_LISTEX         *pListEx;
    unsigned long       NbList, Index;//, i;
    unsigned char       Mode;
    //long                bFlagReadOnly;
    //long                bChangeFlag;
    long                lRetour;
    SRDB                **pRDB;
    unsigned long       dwSizeOfOneElement;
    unsigned long       dwCountOfElements;
    
    BYTE                *pData;
    long                DataLength;
    
    BYTE                *pOutData;
    long                OutLength;
    
    
    pInData     = pmsSecureStream;
    OutLength   = 0;
    pOutData    = NULL;
    IdTrame     = ID_RDBAccessNetwork_Refuse;
    
    switch (dwIdTrameSecure)
    {
        case RDB_ACCESS_CLIENT_GETVERSION:
            _RDBMemoryStreamOpen ( &MS, NULL );
            _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_NAME );
            _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_TYPE );
            
            _RDBMemoryStreamAdd_ULONG ( &MS, JOCARESO_PROTOCOL_RELEASE );
            _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_GEN );
            _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_MAJOR );
            _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_VERSION_MINOR );
            
            _RDBMemoryStreamAdd_UCHAR ( &MS, JOCARESO_UPDATE_FILEOS_LETTER );
            
            _RDBMemoryStreamAdd_STRING ( &MS, DAEMON_VERSION_TEXTINFO );            
            
            _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerComputerName );
            _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerHostName ); 
            _RDBMemoryStreamAdd_STRING ( &MS, GlobalData.szServerIP );

            pOutData    = MS.pBuffer;
            OutLength   = MS.BufferLength;
            
            IdTrame = ID_RDBAccessNetwork_Accept;
            break;
            
        case RDB_ACCESS_CLIENT_TransmitName:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szTmp );
            strcpy ( pNDLClient->szPeerName, szTmp );
            IdTrame = ID_RDBAccessNetwork_Accept;
            break;

        case ID_RDBAccessNetwork_MakeDirectory:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDirectoryName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBMakeDirectory ( pRDB, szRootDirectoryName, szDirectoryName );
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_KillDirectory:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDirectoryName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBKillDirectory ( pRDB, szRootDirectoryName, szDirectoryName );
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_DirectoryContentList:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBDirectoryContentList ( pRDB, szRootDirectoryName, &pList, &NbList );

            //Si le retour est juste, on rempli...
            if (!lRetour)
            {
                if (NbList)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_ULONG ( &MS, NbList );
                    for (Index=0;Index<NbList;Index++)
                    {
                        _RDBMemoryStreamAdd_STRING ( &MS, pList[Index].szName );
                        _RDBMemoryStreamAdd_UCHAR  ( &MS, pList[Index].Identifiant );
                    }
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    KERNEL_FREE ( pList );
                }

            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_DirectoryContentListEx:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBDirectoryContentListEx ( pRDB, szRootDirectoryName, &pListEx, &NbList );

            //Si le retour est juste, on rempli...
            if (!lRetour)
            {
                if (NbList)
                {
                    _RDBMemoryStreamOpen ( &MS, NULL );
                    _RDBMemoryStreamAdd_ULONG ( &MS, NbList );
                    for (Index=0;Index<NbList;Index++)
                    {
                        _RDBMemoryStreamAdd_STRING ( &MS, pListEx[Index].szName );
                        _RDBMemoryStreamAdd_UCHAR  ( &MS, pListEx[Index].Identifiant );
                        _RDBMemoryStreamAdd_ULONG  ( &MS, pListEx[Index].lCountOfElements );
                        _RDBMemoryStreamAdd_ULONG  ( &MS, pListEx[Index].lSizeOfOneElement );
                        _RDBMemoryStreamAdd_ULONG  ( &MS, pListEx[Index].lTotalSize );
                    }
                    pOutData    = MS.pBuffer;
                    OutLength   = MS.BufferLength;
                    KERNEL_FREE ( pListEx );
                }

            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_MakeFile:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szFileName );
            _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBMakeFile ( pRDB, szRootDirectoryName, szFileName, pData, DataLength );
            KERNEL_FREE (pData);
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_KillFile:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szFileName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBKillFile ( pRDB, szRootDirectoryName, szFileName );
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_ReadFile:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szFileName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBReadFile ( pRDB, szRootDirectoryName, szFileName, &pData, &DataLength );
            if (!lRetour)
            {
                _RDBMemoryStreamOpen ( &MS, NULL );
                _RDBMemoryStreamAdd_RAW ( &MS, pData, DataLength );
                pOutData    = MS.pBuffer;
                OutLength   = MS.BufferLength;
                KERNEL_FREE ( pData );
            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_MakeData:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDataName );
            _RDBMemoryStreamGet_ULONG  ( &MS, &dwSizeOfOneElement );
            _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
            dwCountOfElements = DataLength / dwSizeOfOneElement;
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBMakeData ( pRDB, szRootDirectoryName, szDataName, pData, dwSizeOfOneElement, dwCountOfElements );
            KERNEL_FREE (pData);
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_KillData:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDataName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBKillData ( pRDB, szRootDirectoryName, szDataName );
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_ReadData:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDataName );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBReadData ( pRDB, szRootDirectoryName, szDataName, &pData, &dwSizeOfOneElement, &dwCountOfElements );
            if (!lRetour)
            {
                _RDBMemoryStreamOpen ( &MS, NULL );
                _RDBMemoryStreamAdd_ULONG  ( &MS, dwSizeOfOneElement );
                _RDBMemoryStreamAdd_RAW    ( &MS, pData, dwSizeOfOneElement * dwCountOfElements );
                pOutData    = MS.pBuffer;
                OutLength   = MS.BufferLength;
                KERNEL_FREE ( pData );
            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_WriteData:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szDataName );
            _RDBMemoryStreamGet_RAW    ( &MS, &pData, &DataLength );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            lRetour = RDBWriteData ( pRDB, szRootDirectoryName, szDataName, pData, DataLength );
            KERNEL_FREE (pData);
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case ID_RDBAccessNetwork_SupervisorSet:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
            _RDBMemoryStreamGet_UCHAR  ( &MS, &Mode );
            pRDB = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            //lRetour = RDBSupervisorSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
                
            //Rights Security Enforcement : Fixe le droit dans la RightsEntryList
            //if (!lRetour) RDBServerRightsSetSupervisor ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, (Mode)?(1):(0) );
            
            //Rights Security Enforcement v2
            lRetour = RDBServerRightsSet (
                pRDB, 
                szRootDirectoryName, 
                szEntryName, 
                (Mode)?(RDBSERVER_RIGHTSET_SUPERVISOR_ENABLE):(RDBSERVER_RIGHTSET_SUPERVISOR_DISABLE),
                pNDLClient->Identifiant );

            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            if (Mode)
            {
                lOnSupervisorAsk++;
                if (!lRetour) lOnSupervisorOk++;
            }
            else
            {
                lOffSupervisorAsk++;
                if (!lRetour) lOffSupervisorOk++;
            }
            break;

        case ID_RDBAccessNetwork_SupervisorGet:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
            pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            //lRetour  = RDBSupervisorGet ( pRDB, szRootDirectoryName, szEntryName );
            lRetour = RDBServerRightsGet ( pRDB, szRootDirectoryName, szEntryName, RDBSERVER_RIGHTGET_SUPERVISOR, pNDLClient->Identifiant );
            if (lRetour>=0)
            {
                _RDBMemoryStreamOpen ( &MS, NULL );
                _RDBMemoryStreamAdd_UCHAR  ( &MS, (unsigned char)lRetour );
                pOutData    = MS.pBuffer;
                OutLength   = MS.BufferLength;
                lRetour      = 0;
            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;


        case ID_RDBAccessNetwork_ReadsCountSet:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
            _RDBMemoryStreamGet_UCHAR  ( &MS, &Mode );
            pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );

            //Rights Security Enforcement : Gestion des droits ReadOnly dans la liste RightsEntry
            /*
            bChangeFlag = 0;
            if (!RDBServerRightsGetReadOnly ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, &bFlagReadOnly ))
            {
                long bMode;
                bMode = (Mode)?(1):(0);
                if (bMode!=bFlagReadOnly) bChangeFlag = 1;
            }
            else bChangeFlag = 1;

            if (bChangeFlag)
            {
                lRetour  = RDBReadsCountSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
                if (!lRetour) RDBServerRightsSetReadOnly ( pNDLClient->Identifiant, szRDBName, szRootDirectoryName, szEntryName, (Mode)?(1):(0) );
            }
            else lRetour = 0;
            */
            
            //Rights Security Enforcement v2
            lRetour = RDBServerRightsSet (
                pRDB, 
                szRootDirectoryName, 
                szEntryName, 
                (Mode)?(RDBSERVER_RIGHTSET_READONLY_ENABLE):(RDBSERVER_RIGHTSET_READONLY_DISABLE),
                pNDLClient->Identifiant );

            //Retour  = RDBReadsCountSet ( pRDB, szRootDirectoryName, szEntryName, Mode );
            //if (Retour) FlagReadUpdate ( pRDB, szRootDirectoryName, szEntryName, Mode );
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            if (Mode)
            {

                lOnReadAsk++;
                if (!lRetour) lOnReadOk++;
            }
            else
            {
                lOffReadAsk++;
                if (!lRetour) lOffReadOk++;
            }

            break;

        case ID_RDBAccessNetwork_ReadsCountGet:
            _RDBMemoryStreamOpen ( &MS, pInData );
            _RDBMemoryStreamGet_STRING ( &MS, szRDBName );
            _RDBMemoryStreamGet_STRING ( &MS, szRootDirectoryName );
            _RDBMemoryStreamGet_STRING ( &MS, szEntryName );
            pRDB    = _RDBServerGetBase ( szRDBName, pRDBBase, NbMaxBases, pNDLClient );
            //lRetour  = RDBReadsCountGet ( pRDB, szRootDirectoryName, szEntryName );
            lRetour = RDBServerRightsGet ( pRDB, szRootDirectoryName, szEntryName, RDBSERVER_RIGHTGET_READONLY, pNDLClient->Identifiant );
            if (lRetour>=0)
            {
                _RDBMemoryStreamOpen ( &MS, NULL );
                _RDBMemoryStreamAdd_UCHAR  ( &MS, (unsigned char)lRetour );
                pOutData    = MS.pBuffer;
                OutLength   = MS.BufferLength;
                lRetour      = 0;
            }
            IdTrame = (!lRetour) ? ID_RDBAccessNetwork_Accept : ID_RDBAccessNetwork_Refuse;
            break;

        case 0:            
            IdTrame = ID_RDBAccessNetwork_Accept;
			psciState->bIdentified = 1;	// Authentification successed
            break;
            
        default:
            IdTrame = ID_RDBAccessNetwork_Refuse;
            break;
    }            
    
    *pbOutData      = pOutData;
    *pdwOutLength   = OutLength;
    
    return IdTrame;    
}
