/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#include "jocareso.h"
#include "sha2.h"

//  For Windows only (Visual C++ 2008)
//  Suppress all warnings about unsecured CRT functions
#ifdef _WIN32
#define _CRT_SECURE_NO_WARNINGS
#endif


#ifdef _WIN32
    #include <tchar.h>
    #include <conio.h>
    #include <direct.h>
    #include <io.h>
    
    #include <windows.h>
    #include <windowsx.h>
    #include <winuser.h>
/*    #include <tchar.h>
    #include <stdio.h>
    #include <string.h>
    #include <conio.h>
    #include <direct.h>
    #include <stdlib.h>
    #include <commctrl.h>
    #include <fcntl.h>
    #include <io.h>
    #include <time.h>
    #include <math.h>
    #include <commdlg.h>
    #include <malloc.h>*/
    #include <winbase.h>
    

    typedef WINSHELLAPI HINSTANCE (WINAPI  *ShellExecute_DLLProc) (HWND hwnd, LPCSTR lpOperation, LPCSTR lpFile, LPCSTR lpParameters, LPCSTR lpDirectory, INT nShowCmd);

    #define jocareso_chdir(x)    _chdir(x)
    #define jocareso_mkdir(x,r)  _mkdir(x)
#else
	#ifdef HAVE_CONFIG_H
	#include <config.h>
	#endif

	//#include <iostream>
	//#include <cstdlib>
	#include <pthread.h>
    #include <limits.h>
    #include <unistd.h>
    #include <errno.h>
    #include <sys/types.h>
    #include <sys/stat.h>   
    #include <spawn.h>

    #define jocareso_chdir(x)    chdir(x)
    #define jocareso_mkdir(x,r)  mkdir(x,r)

    /*
    ** Mode constants for spawn functions.
    */
    #ifndef _P_WAIT
    #define	_P_WAIT		0
    #define	_P_NOWAIT	1
    #define	_P_OVERLAY	2
    #define	_OLD_P_OVERLAY	_P_OVERLAY
    #define	_P_NOWAITO	3
    #define	_P_DETACH	4

    #ifndef	_NO_OLDNAMES
    #define	P_WAIT		_P_WAIT
    #define	P_NOWAIT	_P_NOWAIT
    #define	P_OVERLAY	_P_OVERLAY
    #define	OLD_P_OVERLAY	_OLD_P_OVERLAY
    #define	P_NOWAITO	_P_NOWAITO
    #define	P_DETACH	_P_DETACH
    #endif	/* Not _NO_OLDNAMES */
    #endif
    
#endif


//Le fichier a ecrire sous Linux
// LINUX_PATHEXE

//Le fichier a ecrire sous Windows
// GetModuleFileNameA ( NULL, szTmp, 1023 )

/*
char const sInitUpdateCommand[] = 
#ifdef _WIN32
//TargetFileName, SourceFileName, TargetFileName, jocareso-run-option
"ping localhost -w 1000 -n 60 >nul\r\n"
"copy %s %s\r\n"
"%s %s\r\n"
"\r\n";
#else
//SourceFileName, jocareso-run-option
"sudo ping localhost -i 1 -c 60 >null\n"
"sudo cp %s jocaresodaemon\n"
"sudo chmod +x jocaresodaemon\n"
"sudo ./jocaresodaemon %s\n"
"\n";
#endif

/*
#!/bin/bash
# touch "/usr/share/jocareso/jocareso.inst"
echo "Copie de jocareso"
sudo rm /usr/bin/jocareso/jocaresodaemon
sudo cp /usr/share/jocareso/jocareso-i386 /usr/bin/jocareso/jocaresodaemon
sudo chmod +x /usr/bin/jocareso/jocaresodaemon
echo "Installation de jocareso"
sudo chmod +x /usr/share/jocareso/jocareso-i386
sudo /usr/share/jocareso/jocareso-i386 -i -r/usr/bin -k
echo "Lancement de jocareso"
sudo chmod +x /usr/bin/jocareso/jocaresodaemon
sudo /etc/init.d/jocareso start
echo "Installation et lancement : Fin"
*/

static long lEnableAutoUpdate = 0;
static char szAutoUpdateRunCommand[1280];




long jocareso_autoupdate_final ( void )
{
    //if (!lEnableAutoUpdate)
    //    COM_Printf ( "exec = %s\n", szAutoUpdateRunCommand );
        
    if (!lEnableAutoUpdate)
    {
#ifdef _WIN32
        
        //typedef WINSHELLAPI BOOL      (WINAPI  *ShellExecuteEx_DLLProc) ( LPSHELLEXECUTEINFOA lpExecInfo );

        HMODULE                 hShell32DLL;
        ShellExecute_DLLProc    ShellExecute_Proc;                                          
        HINSTANCE               hInstance;
        unsigned long           *pl;

        //Charge la DLL
        hShell32DLL = LoadLibrary ( "Shell32.dll" );

        if (hShell32DLL)
        {
            //Rcupration de l'adresse de la routine            
            ShellExecute_Proc = (ShellExecute_DLLProc) GetProcAddress ( hShell32DLL, "ShellExecuteA" );

            //Excute la fonction
            hInstance = ShellExecute_Proc ( NULL, "open", szAutoUpdateRunCommand, NULL, NULL, SW_SHOW );

            //Ferme la DLL
            FreeLibrary ( hShell32DLL );
            
            pl = (unsigned long *)&hInstance;
            
            //COM_Printf ( "ret shell exec = %d\n", *pl );
            
            if (*pl>32) return 0;
            else        return -1;
        }
#else
        //char *argv[] = { "ls"
        //if (execvp(szAutoUpdateRunCommand,NULL)<0) return -1;
        //if (spawnl(_P_NOWAITO,szAutoUpdateRunCommand,szAutoUpdateRunCommand,NULL)==-1) return -1;
        
        //pid_t pid;
        //char *argv[] = { (char *) _PATH_BSHELL, (char *) "-c", (char *) "echo $$", NULL };
        //if (posix_spawn (&pid, _PATH_BSHELL, &a, NULL, argv, NULL) != 0)
        //    return -1;
        //#define	_PATH_BSHELL	"/bin/sh"
            
        //execl (szAutoUpdateRunCommand, szAutoUpdateRunCommand, "-c", "echo $$", NULL);
        
        //execl (szAutoUpdateRunCommand, szAutoUpdateRunCommand, NULL );
        
        posix_spawn_file_actions_t Actions;
        int fd[2];
        char * argv[2];
        pid_t pid;
        char szPath[1024];
        
        if (pipe(fd))
        {
            COM_Printf ( "Erreur : pipe" );
            return -1;
        }
        
        if (posix_spawn_file_actions_init(&Actions))
        {
            COM_Printf ( "Erreur : posix_spawn_file_actions_init" );
            return -1;
        }
        
        if (posix_spawn_file_actions_adddup2(&Actions,fd[1],STDOUT_FILENO))
        {
            COM_Printf ( "Erreur : posix_spawn_file_actions_adddup2" );
            return -1;
        }

        if (posix_spawn_file_actions_addclose(&Actions,fd[1]))
        {
            COM_Printf ( "Erreur : posix_spawn_file_actions_addclose" );
            return -1;
        }
        
        //strcpy ( szPath, szAutoUpdateRunCommand );
        //strkeeppath ( szPath );
        
        
        argv[0] = szAutoUpdateRunCommand;
        argv[1] = NULL;
        
        if (posix_spawn (&pid, argv[0], &Actions, NULL, argv, NULL) != 0)
            return -1;
            
        posix_spawn_file_actions_destroy ( &Actions );


  



        
#endif        
    }
    
    return 0;
}

/*
long jocareso_autoupdate_old ( char * pszStream, BYTE * pbFile, DWORD dwFileSize )
{
    FILE *pFile;
    char szPathName[1024];
    char szModdedPathName[1280];
    char szCommandPathName[1280];
    char * pszFileName;
    char szTemp[4096];
    char szTmp[256];
    unsigned char bHashSHA512[64];
    DWORD dwFileSizeReal;

    //On vrifie le fichier...
    dwFileSizeReal = dwFileSize - 65;
    if ((dwFileSizeReal>dwFileSize)||(dwFileSizeReal<10240))
        return JOCARESO_ERROR_UPDATE_INCORRECTFILESIZE;
    
    //Le SHA512 ?    
    sha512 ( pbFile, dwFileSize - 64, bHashSHA512 );
    if (memcmp(bHashSHA512,&(pbFile[dwFileSize-64]),64)!=0)
        return JOCARESO_ERROR_UPDATE_INCORRECTFILEHASH;
        
    //('W') pour Windows et ('L') pour Linux
    if (pbFile[dwFileSize-65]!=JOCARESO_UPDATE_FILEOS_LETTER)
        return JOCARESO_ERROR_UPDATE_INCORRECTFILEOS;
        
    //On recupere le nom du fichier...
#ifdef _WIN32    
    GetModuleFileNameA ( NULL, szPathName, 1023 );    
#else
    strcpy ( szPathName, LINUX_PATHEXE );
#endif
    pszFileName = strgetfilenameandextension ( szPathName );
        
    //On ecrit le fichier    
    sprintf ( szModdedPathName, "%s.update", pszFileName );
    remove ( szModdedPathName );
    pFile = fopen ( szModdedPathName, "wb" );
    if (pFile)
    {
        fwrite ( pbFile, dwFileSizeReal, 1, pFile );
        fclose ( pFile );
    }
    else return JOCARESO_ERROR_UPDATE_WRITEAPPLICATION;
    
    //Ecriture de la ligne de commande
#ifdef _WIN32    
    sprintf ( szCommandPathName, "%s.cmd", szModdedPathName );
#else
    sprintf ( szCommandPathName, "%s.bash", szModdedPathName );
#endif    
    if (SYS_RunSimpleModeGet())
        strcpy ( szTmp, "run" );
    else
        strcpy ( szTmp, "start" );
        
    COM_Printf ( "RunMode = %s\n", szTmp );
        
#ifdef _WIN32    
    sprintf ( szTemp, sInitUpdateCommand, 
        //TargetFileName, SourceFileName, TargetFileName, jocareso-run-option
        pszFileName, szModdedPathName, pszFileName, szTmp );
#else
    sprintf ( szTemp, sInitUpdateCommand,
        //SourceFileName, jocareso-run-option
        szModdedPathName, szTmp );
#endif
    remove ( szCommandPathName );
    pFile = fopen ( szCommandPathName, "wt" );
    if (pFile)
    {
        fprintf ( pFile, szTemp );
        fclose ( pFile );
#ifndef _WIN32
        chmod ( szCommandPathName, PERSMISSION_LINUXFILE ); //RWXR-XR-X
#endif
    }
    else return JOCARESO_ERROR_UPDATE_WRITECOMMAND;
    
    //La mise  jour est faite... On va demande la terminaison de notre jocareso... En mode bourrin !
    strcpy ( szAutoUpdateRunCommand, szCommandPathName );
    if (jocareso_autoupdate_final()==0)
    {
        lEnableAutoUpdate = 1;
        GlobalData.lExitApplication = 100;
    }
    else return JOCARESO_ERROR_UPDATE_STARTCOMMAND;    
    
    
    return 0;
}
*/


long jocareso_autoupdate ( 
    BYTE * pbFileData, DWORD dwFileSize, char * pszJocaresoUpdateFile, 
    char * pszScriptData, char * pszJocaresoScriptFile )
{
    FILE *pFile;
    //char szPathName[1024];
    //char szModdedPathName[1280];
    //char szCommandPathName[1280];
    //char * pszFileName;
    //char szTemp[4096];
    //char szTmp[256];
    unsigned char bHashSHA512[64];
    DWORD dwFileSizeReal;

    //On vrifie le fichier...
    dwFileSizeReal = dwFileSize - 65;
    if ((dwFileSizeReal>dwFileSize)||(dwFileSizeReal<10240))
        return JOCARESO_ERROR_UPDATE_INCORRECTFILESIZE;
    
    //Le SHA512 ?    
    sha512 ( pbFileData, dwFileSize - 64, bHashSHA512 );
    if (memcmp(bHashSHA512,&(pbFileData[dwFileSize-64]),64)!=0)
        return JOCARESO_ERROR_UPDATE_INCORRECTFILEHASH;
        
    //('W') pour Windows et ('L') pour Linux
    if (pbFileData[dwFileSize-65]!=JOCARESO_UPDATE_FILEOS_LETTER)
        return JOCARESO_ERROR_UPDATE_INCORRECTFILEOS;
        
    //Ecriture du fichier executable
    pFile = fopen ( pszJocaresoUpdateFile, "wb" );
    if (pFile)
    {
        fwrite ( pbFileData, dwFileSizeReal, 1, pFile );
        fclose ( pFile );
    }
    else return JOCARESO_ERROR_UPDATE_WRITEAPPLICATION;
    
    //Ecriture du fichier script
    pFile = fopen ( pszJocaresoScriptFile, "wt" );
    if (pFile)
    {
        fprintf ( pFile, pszScriptData );
        fclose ( pFile );
#ifndef _WIN32
        chmod ( pszJocaresoScriptFile, PERSMISSION_LINUXFILE ); //RWXR-XR-X
#endif
    }
    else return JOCARESO_ERROR_UPDATE_WRITECOMMAND;
    
    //La mise  jour est faite... On va demande la terminaison de notre jocareso... En mode bourrin !
    strcpy ( szAutoUpdateRunCommand, pszJocaresoScriptFile );
    if (jocareso_autoupdate_final()==0)
    {
        lEnableAutoUpdate = 1;
        GlobalData.lExitApplication = 100;
    }
    else return JOCARESO_ERROR_UPDATE_STARTCOMMAND;    
    
    
    return 0;
}
