/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#include "jocareso.h"

#define CONFIG_CTF "config.ctf"
#define CONFIGEX_CTF "configex.ctf"

void ConfigSetDefault ( void );
void ConfigSetDefaultEx ( void );
void ConfigLoad ( void );
void ConfigLoadEx ( void );
void ConfigSave ( void );
void ConfigSaveEx ( void );

void ConfigSetDefault ( void )
{
    memset ( &ConfigData, 0, sizeof(ConfigData) );
    ConfigData.lNbThreadServer  = 1;
    ConfigData.NetworkPort[0]   = 2000;
}

void ConfigSetDefaultEx ( void )
{
    memset ( &ConfigDataEx, 0, sizeof(ConfigDataEx) );
}

void ConfigLoad ( void )
{
    FILE            *pFile;
    DWORD           dwSize;
    fpos_t          fpPos;
    char            szPathFile[1024];
    
    CriticalSectionEnter ( &GlobalData.csConfigAccess );

    //Ouverture du fichier
    sprintf ( szPathFile, "%s/%s", SYS_GetInstallPath ( ), CONFIG_CTF );
    pFile = fopen ( szPathFile, "rb" );
    if (!pFile)
    {
        CriticalSectionLeave ( &GlobalData.csConfigAccess );
        return;
    }

    //Lecture de la taille
    fseek ( pFile, 0, SEEK_END );
    fgetpos ( pFile, &fpPos );    
#ifdef _WIN32    
    dwSize = (DWORD)(fpPos&0xFFFFFFFF);
#else
    dwSize = *((DWORD *)&fpPos);
#endif
    fseek ( pFile, 0, SEEK_SET );
    
    //Lecture des donnees
    if (dwSize==sizeof(ConfigData))
        fread ( &ConfigData, sizeof(ConfigData), 1, pFile );
    else
        ConfigSetDefault ( );

    //Fermeture      
    fclose ( pFile );
    
    CriticalSectionLeave ( &GlobalData.csConfigAccess );
    
    ConfigLoadEx ( );
}

void ConfigLoadEx ( void )
{
    FILE            *pFile;
    DWORD           dwSize;
    fpos_t          fpPos;
    char            szPathFile[1024];
    
    CriticalSectionEnter ( &GlobalData.csConfigAccess );

    //Ouverture du fichier
    sprintf ( szPathFile, "%s/%s", SYS_GetInstallPath ( ), CONFIGEX_CTF );
    pFile = fopen ( szPathFile, "rb" );
    if (!pFile)
    {
        CriticalSectionLeave ( &GlobalData.csConfigAccess );
        return;
    }

    //Lecture de la taille
    fseek ( pFile, 0, SEEK_END );
    fgetpos ( pFile, &fpPos );    
#ifdef _WIN32    
    dwSize = (DWORD)(fpPos&0xFFFFFFFF);
#else
    dwSize = *((DWORD *)&fpPos);
#endif
    fseek ( pFile, 0, SEEK_SET );
    
    //Lecture des donnees
    if (dwSize==sizeof(ConfigDataEx))
        fread ( &ConfigDataEx, sizeof(ConfigDataEx), 1, pFile );
    else
        ConfigSetDefaultEx ( );

    //Fermeture      
    fclose ( pFile );
    
    CriticalSectionLeave ( &GlobalData.csConfigAccess );
}

void ConfigSave ( void )
{
    FILE            *pFile;
    char            szPathFile[1024];
    
    CriticalSectionEnter ( &GlobalData.csConfigAccess );
    
    //Ouverture du fichier
    sprintf ( szPathFile, "%s/%s", SYS_GetInstallPath ( ), CONFIG_CTF );
    pFile = fopen ( szPathFile, "wb" );
    if (!pFile)
    { 
        CriticalSectionLeave ( &GlobalData.csConfigAccess );
        return;
    }

    //Ecriture des donnees
    fwrite ( &ConfigData, sizeof(ConfigData), 1, pFile );

    //Fermeture
    fclose ( pFile );
    
    CriticalSectionLeave ( &GlobalData.csConfigAccess );
    
    ConfigSaveEx ( );
}

void ConfigSaveEx ( void )
{
    FILE            *pFile;
    char            szPathFile[1024];
    
    CriticalSectionEnter ( &GlobalData.csConfigAccess );
    
    //Ouverture du fichier
    sprintf ( szPathFile, "%s/%s", SYS_GetInstallPath ( ), CONFIGEX_CTF );
    pFile = fopen ( szPathFile, "wb" );
    if (!pFile)
    {
        CriticalSectionLeave ( &GlobalData.csConfigAccess );
        return;
    }

    //Ecriture des donnees
    fwrite ( &ConfigDataEx, sizeof(ConfigDataEx), 1, pFile );

    //Fermeture
    fclose ( pFile );
    
    CriticalSectionLeave ( &GlobalData.csConfigAccess );
}
