/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/

#include "jocareso.h"

long copyFile(const char * pszDestination, const char * pszSource, long lForceCopy)
{
	FILE * pSource;
	FILE * pDestination;
	char * pBuffer;
	long lBlockSize;
	long lSizeReaded;
	long iReturnValue;

	if(!(pSource = fopen(pszSource, "rb")))
	{
		perror(NULL);
		return -1;
	}

	if (!lForceCopy)
	{
		if(pDestination = fopen(pszDestination, "rb"))
		{
			fclose ( pDestination );
			fclose ( pSource );
			return 1;
		}
	}

	pDestination = fopen(pszDestination, "wb");
	if(!pDestination)
	{
		fclose(pSource);
		perror(NULL);
		return -1;
	}

	lBlockSize = 262144;
	pBuffer = KERNEL_ALLOC(lBlockSize);

	while(lSizeReaded = fread(pBuffer, 1, lBlockSize, pSource))
		fwrite(pBuffer, 1, lSizeReaded, pDestination);

	KERNEL_FREE(pBuffer);

	fclose(pSource);
	fclose(pDestination);

	return 0;
}
