/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#include "jocareso.h"
#include "RDBServer.h"
#include "RDBServerClientInterface.h"

long ThreadMainProc ( void * pProcData )
{
    long                Retour,i;
    DWORD               dwTime;
    long                CompteurBase;
    long                RetStatus;
    time_t              ltimeCurrentTimer;
    long                lCountUsedPort;

    //_OSI_ThreadGetProcParams ( pProcData, ** );

    //Initialisation des sockets
    RetStatus = NDLOpen ();

    if (!RetStatus)
    {
        //Initialisation du serveur
        lCountUsedPort = 0;
        for (i=0;i<16;i++)
        {
            GlobalData.NDLServer[i].Socket = INVALID_SOCKET;
            GlobalData.lListenPortState[i] = 0;

            //On connecte uniquement les serveurs sur les ports specifies
            if (ConfigData.NetworkPort[i])
            {
                Retour = NDLServerOpenConnection ( &GlobalData.NDLServer[i], ConfigData.NetworkPort[i], NAGLE_PADDING_LENGTH );
                if (Retour==0)
                {
                    lCountUsedPort++;
                    GlobalData.lListenPortState[i] = 1;
                }
                else
                { 
                    GlobalData.lListenPortState[i] = -1;
                    COM_Printf ( "Ecoute Port TCP %d : Bloquee par un firewall ou deja utilisee par le systeme.", ConfigData.NetworkPort[i] );
                }
            }
        }
		GlobalData.ServerLaunched = (lCountUsedPort)?(1):(0);
		
        //Listen is possible on one or more port ?
        if (GlobalData.ServerLaunched==0)
        {
            strcpy ( GlobalData.szExitApplicationWhy, "Impossible d'ecouter le reseau : L'application est peut-etre deja lancee ou un firewall bloque le reseau ?" );
            GlobalData.lExitApplication = -1;
        }
            

        //ListBaseClose ( );

        //Initialise le temps a 1 minutes
        dwTime = TickGetCount2 ( ) + (1 * 60 * 1000);
        CompteurBase = 0;

        do {
            //SetThreadPriority ( ThreadIAL.Handle, THREAD_PRIORITY_LOWEST );
            SleepSet ( 100 );

            //Gestion de l'enregistrement automatique des bases
            if (TickGetCount2()>dwTime)
            {
                //EnterCriticalSection ( &GlobalData.CriticalSection );
                CriticalSectionEnter ( &GlobalData.CriticalSection );

                //Enregistrement automatique
                if (GlobalData.pRDBBase[CompteurBase]!=NULL)
                    RDBSave ( &GlobalData.pRDBBase[CompteurBase] );

                //LeaveCriticalSection ( &GlobalData.CriticalSection );
                CriticalSectionLeave ( &GlobalData.CriticalSection );

                CompteurBase++;
                if (CompteurBase>=GlobalData.RDBBaseNb)
                {
                    CompteurBase = 0;
                    dwTime = TickGetCount2 ( ) + (1 * 60 * 1000);
                }
            }

            //Gestion du Watchdog
            CriticalSectionEnter ( &GlobalData.CriticalSectionCurrentTime );
            time ( &GlobalData.ltimeCurrentTime );
            //ltimeCurrentTimer = GlobalData.ltimeCurrentTime - 240 - 30;
			ltimeCurrentTimer = GlobalData.ltimeCurrentTime - 30;
            CriticalSectionLeave ( &GlobalData.CriticalSectionCurrentTime );

            //EnterCriticalSection ( &GlobalData.CriticalSection );
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            for (i=0;i<GlobalData.lNbClients;i++)
            {
                //Le client utilise le watchdog ?
                if (GlobalData.pClientEntry[i].bClientUseWathdog)
                {
                    //Le client n'a plus envoye de message standard ou de message watchdog
                    if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog < ltimeCurrentTimer)
                    {
                        NETWORKDATALINK * pNDLClient;
                        SCILINK        * psciLink;

                        pNDLClient = &GlobalData.pClientEntry[i].NDLClient;
                        psciLink = &(GlobalData.pClientEntry[i].sciState.sciLink);

                        //Close interface access (if opened !)
                        if ((ServerClientInterface_GetState(psciLink))&&(pNDLClient->Identifiant==ServerClientInterface_GetIdentifiant(psciLink)))
                        {
                            ServerClientInterface_SetStateIdentifiant ( psciLink, 0, 0 );
                        }

                        //Suppression de la connexion avec le client
                        pNDLClient->ClientConnected = 0;

                        //Ici, il faut supprimer les droits que le client aurait oublie de faire sauter
                        ListBaseFreeClient ( pNDLClient->Identifiant );

                        //On ferme la socket
                        NDLServerCloseClientConnection ( pNDLClient );
                        pNDLClient->Socket = INVALID_SOCKET;

                        //On reorganise les sessions
                        if (GlobalData.lNbClients>1)
                            memcpy ( &GlobalData.pClientEntry[i], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

                        //Reallocation
                        GlobalData.pClientEntry     = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
                        GlobalData.lNbClients       -=1;
                        GlobalData.ClientUpdated    = 1;

                        //Recommence a cet item
                        i--;
                    }
                }
            }
            //LeaveCriticalSection ( &GlobalData.CriticalSection );
            CriticalSectionLeave ( &GlobalData.CriticalSection );
            

        //} while ( GlobalData.ThreadMain.ExitManagement==FALSE );
        } while (ThreadDoWhileAndWaitExit(pProcData));

        //Le serveur est a l'arret
        GlobalData.ServerLaunched = 0;

        //Fermeture des serveurs
        for (i=0;i<16;i++)
        {
            if (GlobalData.NDLServer[i].Socket!=INVALID_SOCKET)
                NDLServerCloseConnection ( &GlobalData.NDLServer[i] );
            GlobalData.NDLServer[i].Socket = INVALID_SOCKET;
        }

        //Fermeture de la WinSocket
        NDLClose ( );
    }

    //GlobalData.ThreadMain.ExitManagement=FALSE;
    return 0;
}

