/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
Gavroche Richier
gavroche.richier@jocatop.fr
===================================================================
*/

//#define _OLD_NOSELECT_CODE_


#include "jocareso.h"
#include "RDBServer.h"

void FillStatsMainProc ( void )
{
    SCISTATE    * pscisClient;
    long        lSCISClientCount;
    long        i;
    //char        szTmp[1024], szTmp0[64], szTmp1[64], szTmp2[64], szTmp3[64];
    time_t      ltimeCurrentTimer;

    //Allocation
    //if (GlobalData.pscisClient) KERNEL_FREE ( GlobalData.pscisClient );
    //GlobalData.pscisClient  = NULL;
    lSCISClientCount        = GlobalData.lNbClients;
    if (GlobalData.lNbClients>4096) GlobalData.lNbClients = 4096;
    if (GlobalData.lNbClients<0)    GlobalData.lNbClients = 0;

    if (!lSCISClientCount) return;

    pscisClient = (SCISTATE *) KERNEL_ALLOC ( sizeof(SCISTATE) * lSCISClientCount );
    

    CriticalSectionEnter ( &GlobalData.CriticalSectionCurrentTime );
    ltimeCurrentTimer = GlobalData.ltimeCurrentTime;
    CriticalSectionLeave ( &GlobalData.CriticalSectionCurrentTime );


    //Remplissage
    for (i=0;i<lSCISClientCount;i++)
    {
        //GlobalData.pClientEntry[i].NDLClient.TotalRXBytes += GlobalData.pClientEntry[i].NDLClient.RXBytes;
        //GlobalData.pClientEntry[i].NDLClient.TotalTXBytes += GlobalData.pClientEntry[i].NDLClient.TXBytes;

        //
        //ConvertByteToBestScale ( szTmp0, GlobalData.pClientEntry[i].NDLClient.TotalRXBytes );                    
        //ConvertByteToBestScale ( szTmp1, GlobalData.pClientEntry[i].NDLClient.TotalTXBytes );

        //ConvertByteToKBScale ( szTmp2, GlobalData.pClientEntry[i].NDLClient.RXBytes );        //Debit en KB
        //ConvertByteToKBScale ( szTmp3, GlobalData.pClientEntry[i].NDLClient.TXBytes );        //Debit en KB
        //strcat ( szTmp2, "/s" );
        //strcat ( szTmp3, "/s" );

        //sprintf ( szTmp0, "     " );

        pscisClient[i].dwSocket      = (DWORD)GlobalData.pClientEntry[i].NDLClient.Socket;
        pscisClient[i].dwPort        = GlobalData.pClientEntry[i].NDLClient.Port;
        pscisClient[i].lIdentifiant  = GlobalData.pClientEntry[i].NDLClient.Identifiant;
        pscisClient[i].lWatchdogTime = (long)(ltimeCurrentTimer-GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog);
        pscisClient[i].dwState       = 0;

        strcpy ( pscisClient[i].szIPName, GlobalData.pClientEntry[i].NDLClient.szPeerIP );
        strcpy ( pscisClient[i].szPeerName, GlobalData.pClientEntry[i].NDLClient.szPeerName );

        //Connexion active...
        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog>(ltimeCurrentTimer-2))
            pscisClient[i].dwState |= JOCARESO_SCI_STATE_ACTIVE;

        //Watchdog present
        if (GlobalData.pClientEntry[i].bClientUseWathdog)
            pscisClient[i].dwState |= JOCARESO_SCI_STATE_WATCHDOG;

        //Connexion fantome
        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog<(ltimeCurrentTimer - 10))
            pscisClient[i].dwState |= JOCARESO_SCI_STATE_WATCHDOG_ERR1;

        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog<(ltimeCurrentTimer - 30))
            pscisClient[i].dwState |= JOCARESO_SCI_STATE_WATCHDOG_ERR2;


        GlobalData.pClientEntry[i].NDLClient.RXBytes = 0;
        GlobalData.pClientEntry[i].NDLClient.TXBytes = 0;
    }
    
    memcpy ( GlobalData.pscisClientTable, pscisClient, sizeof(SCISTATE) * lSCISClientCount );
    
    KERNEL_FREE ( pscisClient );

    //GlobalData.pscisClient          = pscisClient;
    GlobalData.lSCISClientCount     = lSCISClientCount;

    //On est plus en section critique
    GlobalData.ClientUpdated = 0;


    //Liberation de la memoire
    //free ( pTChar );
}

long ThreadServerProc ( void * pProcData )
{
    long                Retour;
    long                NoClient;
    long                lIndex;
    NETWORKDATALINK     NDLClient;
    SCISTATE            sciState;

    unsigned char       IdTrame;
    unsigned char       *pInData;
    unsigned long       InLength;


    long                bActiveWaitMode;

    DWORD               dwTime, dwTimeStart;
    DWORD               dwTimeProcessed, dwTimeStats;
    long                lScrutationEnhancement = 0;
    DWORD               lTimeDelay;
    
    NDLSELECTDATA       ndlSelectData;
    long                lCountServerSelect;
    long                lSelectReturn;
    

    //Initialise les variables
    NoClient        = 0;       
    lTimeDelay      = 100;
    dwTimeProcessed = TickGetCount2 () + 20;
    dwTimeStats     = TickGetCount2 () + 200;
    do {
        bActiveWaitMode = 0;
        
        //On verifie que le serveur est disponible
        if (GlobalData.ServerLaunched==1)
        {
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            lCountServerSelect = 0;
            if (GlobalData.lNbClients)
            {
                for (lIndex=0;lIndex<GlobalData.lNbClients;lIndex++)
                {
                    if (GlobalData.pClientEntry[lIndex].NDLClient.Socket!=INVALID_SOCKET)
                    {
                        if (lCountServerSelect==0)
                            NDLServerSelectDataCreate ( &ndlSelectData );
                            
				        NDLServerSelectDataAdd ( &ndlSelectData, &GlobalData.pClientEntry[lIndex].NDLClient );
				        lCountServerSelect++;
				    }
				    else
				    {
                        //On reorganise les sessions
                        if (GlobalData.lNbClients>1)
                            memcpy ( &GlobalData.pClientEntry[lIndex], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

                        //Reallocation
                        GlobalData.pClientEntry       = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
                        GlobalData.lNbClients        -= 1;
                        GlobalData.ClientUpdated      = 1;
                        lIndex                       -= 1;
				    }
				}
		    }
		    CriticalSectionLeave ( &GlobalData.CriticalSection );
		    
	        if (lCountServerSelect)
	            lSelectReturn = NDLServerSelectDataExecute ( &ndlSelectData, NULL, &ndlSelectData, 50 );
	        else
	        {
	            SleepSet ( 50 );
	            lSelectReturn = 0;
	        }
	            
	        if (lCountServerSelect)
	            NDLServerSelectDataDelete ( &ndlSelectData );
		    
            if (lSelectReturn>0)
            {
                //Recuperation des parametres des clients
                CriticalSectionEnter ( &GlobalData.CriticalSection );
                
                for (lIndex=0;lIndex<GlobalData.lNbClients;lIndex++)
                {
                    NoClient = lIndex;
                    memcpy ( &NDLClient, &GlobalData.pClientEntry[NoClient].NDLClient, sizeof(NETWORKDATALINK) );
                    memcpy ( &sciState, &GlobalData.pClientEntry[NoClient].sciState, sizeof(SCISTATE) );

                    if (NDLClient.Socket!=INVALID_SOCKET)
                    {
                        dwTimeStart = TickGetCount2 ( );
                        pInData     = NULL;
                        InLength    = 0;
                        Retour = NDLReceiveData ( &NDLClient, &IdTrame, &pInData, &InLength );
                        if (Retour==0)
                        {
                            Retour = ServerMessageManage ( &NDLClient, &sciState, GlobalData.pRDBBase, GlobalData.RDBBaseNb, &dwTime, IdTrame, pInData, InLength, dwTimeStart );
                            memcpy ( &GlobalData.pClientEntry[NoClient].NDLClient, &NDLClient, sizeof(NETWORKDATALINK) );
                            memcpy ( &GlobalData.pClientEntry[NoClient].sciState, &sciState, sizeof(SCISTATE) );

                            //Activation du watchdog
                            if (IdTrame==RDB_ACCESS_CLIENT_WATCHDOG)
                                GlobalData.pClientEntry[NoClient].bClientUseWathdog = 1;

                            //Mise a jour du dernier acces
                            CriticalSectionEnter ( &GlobalData.CriticalSectionCurrentTime );
                            GlobalData.pClientEntry[NoClient].ltimeLastAccessTimeWatchDog = GlobalData.ltimeCurrentTime;
                            CriticalSectionLeave ( &GlobalData.CriticalSectionCurrentTime );


                        }
					    // More than 10 secondes without succesfull authentification
					    else if(!sciState.bIdentified && (TickGetCount2() - sciState.dwConnectionTimeStamp > 10000))
					    {
						    //On reorganise les sessions
						    if (GlobalData.lNbClients>1)
							    memcpy ( &GlobalData.pClientEntry[NoClient], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

						    //Reallocation
						    GlobalData.pClientEntry       = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
						    GlobalData.lNbClients        -= 1;
						    GlobalData.ClientUpdated      = 1;
					    }
                    }
                }

                CriticalSectionLeave ( &GlobalData.CriticalSection );
            }
        }
        else SleepSet ( 50 );
        
        //Gestion des stats toutes les 100ms
        if (dwTimeStats<TickGetCount2())
        {
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            FillStatsMainProc ( );
            CriticalSectionLeave ( &GlobalData.CriticalSection );
            dwTimeStats = TickGetCount2() + 100;
        }

    } while (ThreadDoWhileAndWaitExit(pProcData));

    return 0;
}

long ThreadServerProc_Old ( void * pProcData )
{
    long                Retour;
    long                NoClient;
    NETWORKDATALINK     NDLClient;
    SCISTATE            sciState;

    unsigned char       IdTrame;
    unsigned char       *pInData;
    unsigned long       InLength;


    long                bActiveWaitMode;

    DWORD               dwTime, dwTimeStart;
    DWORD               dwTimeProcessed, dwTimeStats;
    long                lScrutationEnhancement = 0;
    DWORD               lTimeDelay;
    
    //Initialise les variables
    NoClient        = 0;       
    lTimeDelay      = 100;
    dwTimeProcessed = TickGetCount2 () + 20;
    dwTimeStats     = TickGetCount2 () + 200;
    do {
        bActiveWaitMode = 0;
        
        //On verifie que le serveur est disponible
        if (GlobalData.ServerLaunched==1)
        {
            //Recuperation des parametres des clients
            //EnterCriticalSection ( &GlobalData.CriticalSection );
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            if (GlobalData.lNbClients)
            {
                NoClient = (NoClient+1)%GlobalData.lNbClients;
                memcpy ( &NDLClient, &GlobalData.pClientEntry[NoClient].NDLClient, sizeof(NETWORKDATALINK) );
                memcpy ( &sciState, &GlobalData.pClientEntry[NoClient].sciState, sizeof(SCISTATE) );

                if (NDLClient.Socket==INVALID_SOCKET)
                {
                    //On reorganise les sessions
                    if (GlobalData.lNbClients>1)
                        memcpy ( &GlobalData.pClientEntry[NoClient], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

                    //Reallocation
                    GlobalData.pClientEntry       = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
                    GlobalData.lNbClients        -= 1;
                    GlobalData.ClientUpdated      = 1;
                }
                else
                {
                    dwTimeStart = TickGetCount2 ( );
                    pInData     = NULL;
                    InLength    = 0;
                    Retour = NDLReceiveData ( &NDLClient, &IdTrame, &pInData, &InLength );
                    if (Retour==0)
                    {
                        Retour = ServerMessageManage ( &NDLClient, &sciState, GlobalData.pRDBBase, GlobalData.RDBBaseNb, &dwTime, IdTrame, pInData, InLength, dwTimeStart );
                        memcpy ( &GlobalData.pClientEntry[NoClient].NDLClient, &NDLClient, sizeof(NETWORKDATALINK) );
                        memcpy ( &GlobalData.pClientEntry[NoClient].sciState, &sciState, sizeof(SCISTATE) );

                        //Activation du watchdog
                        if (IdTrame==RDB_ACCESS_CLIENT_WATCHDOG)
                            GlobalData.pClientEntry[NoClient].bClientUseWathdog = 1;

                        //Mise a jour du dernier acces
                        CriticalSectionEnter ( &GlobalData.CriticalSectionCurrentTime );
                        GlobalData.pClientEntry[NoClient].ltimeLastAccessTimeWatchDog = GlobalData.ltimeCurrentTime;
                        CriticalSectionLeave ( &GlobalData.CriticalSectionCurrentTime );

                        //Si la session vient d'etre detruite, on reorganise le tout
                        if (NDLClient.Socket==INVALID_SOCKET)
                        {
                            //On reorganise les sessions
                            if (GlobalData.lNbClients>1)
                                memcpy ( &GlobalData.pClientEntry[NoClient], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

                            //Reallocation
                            GlobalData.pClientEntry       = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
                            GlobalData.lNbClients        -= 1;
                            GlobalData.ClientUpdated      = 1;
                        }
#ifdef _OLD_NOSELECT_CODE_                        
                        else
                        {
                            //La session est en plein travail, on va ameliorer la scrutation
                            lScrutationEnhancement+=10;
                            if (lScrutationEnhancement>100) lScrutationEnhancement = 100;
                        }
#endif
                        //FillStatsMainProc ( );
                    }
					// More than 10 secondes without succesfull authentification
					else if(!sciState.bIdentified && (TickGetCount2() - sciState.dwConnectionTimeStamp > 10000))
					{
						//On reorganise les sessions
						if (GlobalData.lNbClients>1)
							memcpy ( &GlobalData.pClientEntry[NoClient], &GlobalData.pClientEntry[GlobalData.lNbClients-1], sizeof(CLIENTENTRY) );

						//Reallocation
						GlobalData.pClientEntry       = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients-1) * sizeof(CLIENTENTRY) );
						GlobalData.lNbClients        -= 1;
						GlobalData.ClientUpdated      = 1;
					}
                }
#ifdef _OLD_NOSELECT_CODE_
                if (dwTimeProcessed < TickGetCount2() )
                {
                    bActiveWaitMode = 1;
                    //lUpdateStats = (lUpdateStats+1)%10;
                    //if (!lUpdateStats) FillStatsMainProc ( );

                    //Gestion du temps d'occupation du CPU                
                    if (lScrutationEnhancement>100) lScrutationEnhancement = 100;
                    lTimeDelay = 101 - lScrutationEnhancement;
                    lScrutationEnhancement -= 2;
                    if (GlobalData.lNbClients)
                    {
                        if (lScrutationEnhancement<60) lScrutationEnhancement = 60;
                    }
                    else
                    {
                        if (lScrutationEnhancement<0) lScrutationEnhancement = 0;
                    }
                }
#endif                
            }
            
#ifdef _OLD_NOSELECT_CODE_            
            else
            {
                bActiveWaitMode = 1;
                //lUpdateStats = (lUpdateStats+1)%5;
                //if (!lUpdateStats) FillStatsMainProc ( );
                lTimeDelay = 100;
            }
#endif
            //LeaveCriticalSection ( &GlobalData.CriticalSection );
            CriticalSectionLeave ( &GlobalData.CriticalSection );
        }
        
#ifdef _OLD_NOSELECT_CODE_        
        else SleepSet ( 50 );
        
        //if (!NoClient)
        
        if (bActiveWaitMode)
        {
            if (lTimeDelay<2) lTimeDelay = 2;
            SleepSet ( lTimeDelay );
            dwTimeProcessed = TickGetCount2 () + 10; //10ms de travail
        }
#endif
        //Gestion des stats toutes les 100ms
        if (dwTimeStats<TickGetCount2())
        {
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            FillStatsMainProc ( );
            CriticalSectionLeave ( &GlobalData.CriticalSection );
            dwTimeStats = TickGetCount2() + 100;
        }

    } while (ThreadDoWhileAndWaitExit(pProcData));

    return 0;
}



        /*
            La liste
                ID Socket       9x
                Port            7x
                Etat            7x
                Client (IP)     ...


                L'tat...

                    A = Actif
                    W = Watchdog prsent
                    f = Fantme plus de 30 secondes
                    F = Fantme plus de 240 secondes

        */

/*
void ConvertByteToBestScale ( char * szTxt, __int64 Value );
void ConvertByteToKBScale ( char * szTxt, __int64 Value );


//Rcupration des paramtres des sessions ouvertes
void FillStatsMainProc ( void )
{
    TCHARSOCK   * pTChar;
    long        NbTChars;
    long        i;
    char        szTmp[1024], szTmp0[64], szTmp1[64], szTmp2[64], szTmp3[64];
    time_t      ltimeCurrentTimer;

    //Allocation
    free ( GlobalData.pTSChar );
    NbTChars = GlobalData.lNbClients;
    pTChar = (TCHARSOCK *) malloc ( sizeof(TCHARSOCK) * NbTChars );

    _OSI_EnterCriticalSection ( &GlobalData.osiCriticalSectionCurrentTime );
    ltimeCurrentTimer = GlobalData.ltimeCurrentTime;
    _OSI_LeaveCriticalSection ( &GlobalData.osiCriticalSectionCurrentTime );


    //Remplissage
    for (i=0;i<GlobalData.lNbClients;i++)
    {
        GlobalData.pClientEntry[i].NDLClient.TotalRXBytes += GlobalData.pClientEntry[i].NDLClient.RXBytes;
        GlobalData.pClientEntry[i].NDLClient.TotalTXBytes += GlobalData.pClientEntry[i].NDLClient.TXBytes;

        //
        ConvertByteToBestScale ( szTmp0, GlobalData.pClientEntry[i].NDLClient.TotalRXBytes );                    
        ConvertByteToBestScale ( szTmp1, GlobalData.pClientEntry[i].NDLClient.TotalTXBytes );

        ConvertByteToKBScale ( szTmp2, GlobalData.pClientEntry[i].NDLClient.RXBytes );        //Dbit en KB
        ConvertByteToKBScale ( szTmp3, GlobalData.pClientEntry[i].NDLClient.TXBytes );        //Dbit en KB
        strcat ( szTmp2, "/s" );
        strcat ( szTmp3, "/s" );

        sprintf ( szTmp0, "     " );

        //Connexion active...
        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog>(ltimeCurrentTimer-2)) szTmp0[1] = 'A';

        //Watchdog prsent
        if (GlobalData.pClientEntry[i].bClientUseWathdog) szTmp0[2] = 'W';

        //Connexion fantme
        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog<(ltimeCurrentTimer- 30)) szTmp0[3] = 'f';
        if (GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog<(ltimeCurrentTimer-240)) szTmp0[3] = 'F';

        //Nombre de secondes coules depuis le dernier accs



        sprintf ( szTmp, "0x%08d  % 5d   %s   %s (%s)[0x%08x-%d]",
                         GlobalData.pClientEntry[i].NDLClient.Socket,
                         GlobalData.pClientEntry[i].NDLClient.Port,
                         szTmp0,
                         GlobalData.pClientEntry[i].NDLClient.szPeerName,
                         GlobalData.pClientEntry[i].NDLClient.szPeerIP,
                         GlobalData.pClientEntry[i].NDLClient.Identifiant,
                         ltimeCurrentTimer-GlobalData.pClientEntry[i].ltimeLastAccessTimeWatchDog );

        strcpy ( pTChar[i].sz, szTmp );
        pTChar[i].Socket = GlobalData.pClientEntry[i].NDLClient.Socket;

        GlobalData.pClientEntry[i].NDLClient.RXBytes = 0;
        GlobalData.pClientEntry[i].NDLClient.TXBytes = 0;

    }

    GlobalData.pTSChar      = pTChar;
    GlobalData.NbTSChars    = NbTChars;

    //On est plus en section critique
    GlobalData.ClientUpdated = 0;


    //Libration de la mmoire
    //free ( pTChar );
}
*/
