/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#include "jocareso.h"
#include "RDBServer.h"

unsigned long ulCompteurIdentifiant = 0;

/*

    Recuperation d'un nouvel et unique identifiant !!!

*/
unsigned long GetNewIdentifiant ( void )
{
    unsigned long ulNewIdentifiant;
    long i;
    long bFound;

    do {
        ulNewIdentifiant                = ulCompteurIdentifiant + ((rand()&0x7FFF)<<16);
        ulCompteurIdentifiant           = (ulCompteurIdentifiant+1)&0xFFFF;

        bFound = 0;
        for (i=0;i<GlobalData.lNbClients;i++)
        {
            if (GlobalData.pClientEntry[i].NDLClient.Identifiant==ulNewIdentifiant)
            {
                i = GlobalData.lNbClients;
                bFound = 1;
            }
        }
    } while (bFound);

    return ulNewIdentifiant;
}

long ThreadWaitForConnectionProc ( void * pProcData )
{
    DWORD               WFCTimer;
    NETWORKDATALINK     NDLClient;
    long                Retour;
    long                NoServer;
    NDLSELECTDATA       ndlSelectData;
    long                lCountServerSelect;
    long                lSelectReturn;


    //Initialise les variables
    WFCTimer = TickGetCount2 ( );
    do {
        
        //On recherche une nouvelle session toute les 200ms (16 sessions de serveur par 200ms)
        if ( (GlobalData.ServerLaunched==1) && (TickGetCount2()>(WFCTimer+200)) )
        {


            // ##################################################################
            // Wait for a new event on incoming server-side socket
            
            CriticalSectionEnter ( &GlobalData.CriticalSection );
            
            NDLServerSelectDataCreate ( &ndlSelectData );
            lCountServerSelect = 0;

			for (NoServer=0;NoServer<16;NoServer++)
			{
				if (GlobalData.NDLServer[NoServer].Socket!=INVALID_SOCKET)
				{
				    NDLServerSelectDataAdd ( &ndlSelectData, &GlobalData.NDLServer[NoServer] );
				    lCountServerSelect++;
				}
	        }
	        
	        CriticalSectionLeave ( &GlobalData.CriticalSection );
	        
	        if (lCountServerSelect)
			{
	            lSelectReturn = NDLServerSelectDataExecute ( &ndlSelectData, NULL, NULL, 40 );
			}
	        else
	        {
	            SleepSet ( 40 );
	            lSelectReturn = 0;
	        }
	        
	        NDLServerSelectDataDelete ( &ndlSelectData );
	        
	        
            if (lSelectReturn>0)
            {
                // ##################################################################
                // We have a new event on one or more server-side socket
            
                CriticalSectionEnter ( &GlobalData.CriticalSection );

			    for (NoServer=0;NoServer<16;NoServer++)
			    {
				    //Recherche une nouvelle connection
				    memset ( &NDLClient, 0, sizeof(NETWORKDATALINK) );

				    if (GlobalData.NDLServer[NoServer].Socket!=INVALID_SOCKET)
				    {
					    Retour = NDLServerWaitForConnection ( &GlobalData.NDLServer[NoServer], &NDLClient );

					    if ( Retour == 0 )   //Une nouvelle connexion a ete trouvee
					    {
						    //Allocation des donnees du client
						    GlobalData.pClientEntry     = (CLIENTENTRY *) KERNEL_REALLOC ( GlobalData.pClientEntry, (GlobalData.lNbClients+1) * sizeof(CLIENTENTRY) );
						    memset ( &GlobalData.pClientEntry[GlobalData.lNbClients], 0, sizeof(CLIENTENTRY) );

						    NDLClient.Port              = GlobalData.NDLServer[NoServer].Port;
						    NDLClient.Identifiant       = GetNewIdentifiant ( );
						    memcpy ( &GlobalData.pClientEntry[GlobalData.lNbClients].NDLClient, &NDLClient, sizeof(NETWORKDATALINK) );                    
						    GlobalData.lNbClients      += 1;
						    GlobalData.ClientUpdated    = 1;
    	                    
						    //Initialisation du SCI
						    ServerClientInterface_Init ( &(GlobalData.pClientEntry[GlobalData.lNbClients-1].sciState.sciLink) );
						    GlobalData.pClientEntry[GlobalData.lNbClients-1].sciState.dwConnectionTimeStamp = TickGetCount2();
					    }
				    }
			    }
			    
			    CriticalSectionLeave ( &GlobalData.CriticalSection );
			}

            WFCTimer            = TickGetCount2();
        }
        SleepSet ( 10 );
    } while (ThreadDoWhileAndWaitExit(pProcData));

    return 0;
}

