/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


//  Pour Windows uniquement (Visual C++ 2008)
//  On supprime tous les warnings en utilisant les fonctions CRT non securisees.
#ifdef _WIN32
#define _CRT_SECURE_NO_WARNINGS
#endif


#ifdef _WIN32
#include <windows.h>
#endif

#include "jocareso.h"

long VerifyReadWriteModify ( void )
{
    char    szFile[1024], szTmp[1024];
    FILE    * pFile;
#ifdef _WIN32    
    HANDLE  hFile;
#endif
    long    lWritten1, lRead1;
    long    lWritten2, lRead2;
    DWORD   dwLenght;
    
    
    sprintf ( szFile, "%s/temp.tmp", SYS_GetInstallPath ( ) );
    
/*
#ifdef _WIN32
    strcpy ( szFile, "temp.tmp" );
#else
    strcpy ( szFile, "./temp.tmp" );
#endif
*/

    //Test d'ecriture C ANSI
    pFile = fopen ( szFile, "wb" );
    if (pFile)
    {
        lWritten1 = (long) fwrite ( szTmp, 1024, 1, pFile );
        fclose ( pFile );
    }
    else lWritten1 = 0;

    //Test de lecture C ANSI
    pFile = fopen ( szFile, "rb" );
    if (pFile)
    {
        lRead1 = (long) fread ( szTmp, 1024, 1, pFile );
        fclose ( pFile );
    }
    else lRead1 = 0;

#ifdef _WIN32
    //Test d'ecriture Windows
    hFile = CreateFile ( szFile,
                         GENERIC_WRITE,              //Mode d'ecriture
                         0,                       //Pas de partage en lecture
                         0,                       //Pas d'attribut de securite
                         CREATE_ALWAYS,              //Ouvre le fichier si il existe
                         FILE_ATTRIBUTE_NORMAL,      //Pas d'attribut de fichier
                         0 );                     //Pas de fichier temp.
    if (hFile!=INVALID_HANDLE_VALUE)
    {
        WriteFile ( hFile, szTmp, 1024, &dwLenght, NULL );
        CloseHandle ( hFile );
        lWritten2 = (dwLenght==1024)?(1):(0);
    }
    else lWritten2 = 0;
#else
    lWritten2 = 1;
#endif


#ifdef _WIN32
    //Test de lecture Windows    
    hFile = CreateFile ( szFile, 
                         GENERIC_READ,       //Mode lecture
                         FILE_SHARE_READ,    //Partage en lecture
                         0,               //Pas d'attribut de securite
                         OPEN_EXISTING,      //Ouvre le fichier si il existe
                         0,               //Pas d'attribut de fichier
                         0 );             //Pas de fichier temp.
    if (hFile!=INVALID_HANDLE_VALUE)
    {
        ReadFile ( hFile, szTmp, 1024, &dwLenght, NULL );
        CloseHandle ( hFile );
        lRead2 = (dwLenght==1024)?(1):(0);
    }
    else lRead2 = 0;
#else
    lRead2 = 1;
#endif

    remove ( szFile );
    
    if ((lRead1)&&(lRead2)&&(lWritten1)&&(lWritten2)) return 0;
    else return -1;
}
