/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/

//  For Windows only (Visual C++ 2008)
//  Suppress all warnings about unsecured CRT functions
#ifdef _WIN32
#define _CRT_SECURE_NO_WARNINGS
#endif


#ifdef _WIN32
    #include <tchar.h>
    #include <conio.h>
    #include <direct.h>
    #include <io.h>

    #define jocareso_chdir(x)    _chdir(x)
    #define jocareso_mkdir(x,r)  _mkdir(x)
#else
	#ifdef HAVE_CONFIG_H
	#include <config.h>
	#endif

	//#include <iostream>
	//#include <cstdlib>
    #include <errno.h>
    #include <sys/types.h>
    #include <sys/stat.h>   
    #include <unistd.h>

    #define jocareso_chdir(x)    chdir(x)
    #define jocareso_mkdir(x,r)  mkdir(x,r)
#endif




#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>


#include "jocareso.h"

#ifndef _WIN32


long _LinuxDaemon_GetStopEvent ( void )
{

    return 0;
}


long _LinuxDaemon_DoApplicationStop ( void )
{
    long lPID;
    if (SYS_SingleInstanceGetPID(&lPID))
    {
        //printf ( "Error-DoAppStop-SysGetPID" );
        COM_Printf ( "Error: Can't find daemon. Already terminated ?" );
        return -1;
    }
    else
    {
        if (kill ( lPID, SIGQUIT ))
        {
            //printf ( "Error-DoAppStop-SIGQUIT" );
            return -1;
        }
    }
    return 0;
}

/*char const szInitDaemon[] =     
"#! /bin/bash\n"
"#! /bin/sh\n"
"PATH=/bin:/usr/bin:/sbin:/usr/sbin:"SYSTEM_PATHROOT""DAEMON_NAME"\n"

//Nom du demon
"name="DAEMON_EXENAME"\n"

//Emplacement absolu du binaire
"binpath="LINUX_PATHEXE"\n"

//Force le daemon a etre executable
"if ! test -x $binpath; then\n"
"chmod +x $binpath\n"
"fi\n"

//Test si le demon est executable
"if ! test -x $binpath; then\n"
"echo \"############### jocareso ERROR ######################\"\n"
"echo \"Unable to run '$binpath'\nExecute permission is required !\"\n"
"exit 0\n"
"fi\n"

//Les cases...
"case \"$1\" in\n"
"start)\n"
"$name %s\n"
";;\n"
"stop)\n"
"$name stop\n"
";;\n"
"restart)\n"
"$0 stop\n"
"sleep 1\n"
"$0 start\n"
";;\n"
"*)\n"
"echo \"Usage: $0 start|stop|restart\" >&2\n"
"exit 1\n"
";;\n"
"esac\n"
"exit 0\n";




/*
"# jocareso\n"
"exepath="LINUX_PATHEXE"\n"
"prog="DAEMON_EXENAME"\n"
"start() {\n"
"echo -n $\"Starting $prog:\"\n"
"$exepath %s\n"
"}\n"
"stop () {\n"
"echo -n $\"Stopping $prog:\"\n"
"killproc $exepath\n"
"}\n"
"case \"$1\" in\n"
"  start)\n"
"    start\n"
"    ;;\n"
"  stop)\n"
"    stop\n"
"    ;;\n"
"esac\n"
"\n"
"exit 0\n";
*/



/*long _LinuxDaemon_DoApplicationInstall ( char * szParams )
{
    FILE *pFile,  *pFileSource;
    char szBuffer[1024];
    char szPathApp[512], szId[256];
    long lSize, lReadSize;
    long lError;
    
    lError = 0;
                
    //Emplacement de l'application
    sprintf ( szId, "/proc/%d/exe", getpid());
    memset ( szPathApp, 0, 512 );
    readlink ( szId, szPathApp, 511 );
                
    //Copie de l'application dans le systeme de linux
   /* if (strcmp(szPathApp,LINUX_PATHEXE))
    {    
        pFileSource = fopen ( szPathApp, "rb" );
        if (pFileSource)
            pFile = fopen ( LINUX_PATHEXE, "wb" );
        else
            pFile = NULL;
                    
        if ((pFileSource)&&(pFile))
        {                
            fseek ( pFileSource, 0, SEEK_END );
            lSize = ftell ( pFileSource );
            fseek ( pFileSource, 0, SEEK_SET );
            
            do {
                lReadSize = lSize;
                if (lReadSize>1024) lReadSize = 1024;
                lSize -= lReadSize;                    
                fread ( szBuffer, lReadSize, 1, pFileSource );
                fwrite ( szBuffer, lReadSize, 1, pFile );
            } while (lSize);
        }
        else
        {
            COM_Printf ( (char *)"Error : Can't copy daemon to (%s).", SYSTEM_PATHROOT );
            lError = -1;
        }
        if (pFile)
        {
            fclose ( pFile );
            chmod ( LINUX_PATHEXE, PERSMISSION_LINUXFILE ); //RWXR-XR-X
        }
        if (pFileSource) fclose ( pFileSource );
        
    }* /
    
    //Generation du fichier BASH
    //pFile = fopen ( "/etc/rc.local", "+" );
    //if (!pFile) 
    pFile = fopen ( LINUX_INITD, "wt" );
    if (pFile)
    {
        //fprintf ( pFile, "jr:3:once:/usr/bin/"DAEMON_NAME );
        //if (strlen(szParams)) sprintf ( szId, "\"%s\"", szParams );
        if (strlen(szParams)) sprintf ( szId, "%s", szParams );
        else szId[0] = 0;
        sprintf ( szBuffer, szInitDaemon, szId ); 
        fprintf ( pFile, szBuffer );
        fclose ( pFile );
        
        chmod ( LINUX_INITD, PERSMISSION_LINUXFILE ); //RWXR-XR-X
        
    }
    else
    {
        COM_Printf ( (char *)"Error : Can't create '%s' and install application.", LINUX_INITD );
        lError = -1;
    }
    
    //Ajout du dameon au demarrage et à l'arrêt du systeme
    // "update-rc.d mydaemon start 30 2 3 4 5 . stop 10 0 1 6"
    //if (execl( "/usr/bin/sudo", "update-rc.d", DAEMON_NAME, "start", "30", "2", "3", "4", "5", ".", "stop", "10", "0", "1", "6", ".", NULL ))
    if (CommandData.iSuperUser) szBuffer[0] = 0;
    else strcpy ( szBuffer, "sudo " );
    //strcat ( szBuffer, "update-rc.d "DAEMON_NAME" start 30 2 3 4 5 . stop 10 0 1 6 ." );
    strcat ( szBuffer, "update-rc.d "DAEMON_NAME" defaults 20" );

    if (system(szBuffer))
    {
        COM_Printf ( (char *)"Error : Can't add a link to the system using 'update-rc.d' command." );
        lError = -1;
    }
    else COM_Printf ( (char *)"Daemon-link added successfully... restart your system.");

    return lError;
}*/


/*long _LinuxDaemon_DoApplicationUninstall ( void )
{
    long lReturn;
    char szBuffer[128];
    
    lReturn = 0;
        
    // Suppression du dameon : "update-rc.d mydaemon remove"
    if (CommandData.iSuperUser) szBuffer[0] = 0;
    else strcpy ( szBuffer, "sudo " );
    strcat ( szBuffer, "update-rc.d -f "DAEMON_NAME" remove" );
    if (system(szBuffer))
    {
        COM_Printf ( (char *)"Error : Can't remove a link from the system using 'update-rc.d' command." );
        lReturn = -1;

    }
    else COM_Printf ( (char *)"Daemon-link removed successfully.");
        
    COM_Printf ( (char *)"Remove : "LINUX_INITD );
    if (remove ( LINUX_INITD ))
    {
        if (errno!=ENOENT)
        {   
            COM_Printf ( (char *)" - ErrorNo : %d", errno );
            lReturn = -1;
        }
    }
        
    COM_Printf ( (char *)"Remove : "LINUX_PATHEXE );
    if (remove ( LINUX_PATHEXE ))
    {
        if (errno!=ENOENT)
        {   
            COM_Printf ( (char *)" - ErrorNo : %d", errno );
            lReturn = -1;
        }
    }    
    
    return lReturn;
}*/


#endif
