//=============================== RIJNDAEL.H   ===============================

#ifndef H__RIJNDAEL
#define H__RIJNDAEL

typedef unsigned long u32;
typedef unsigned char u8;

/**
 * Set the rk buffer to a brand new round key for encryption
 */
void SetupEncrypt(u32 *rk, const u8 key[32]);

/**
 * Set the rk buffer to a brand new round key for decryption
 */
void SetupDecrypt(u32 *rk, const u8 key[32]);

/**
 * Encrypt the szPlaintext buffer of iTextLength length in szCiphertxt, using ulRoundKey
 * (initialized by SetupEncrypt function)
 */
void Encrypt(u8 * szPlaintext, u8 * szCiphertxt, u32 * ulRoundKey, u32 iTextLength);

/**
 * Decrypt the szCiphertxt buffer of iTextLength length in szUnciphertxt, using ulRoundKey
 * (initialized by SetupDecrypt function)
 */
void Decrypt(u8 * szCiphertxt, u8 * szUnciphertxt, u32 * ulRoundKey, u32 iTextLength);

#endif
