/*
===================================================================
Copyright (C) 2009-2010 Editions JOCATOP / Christophe Gossa
 
This file is part of Jocareso.

Jocareso is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Jocareso is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jocareso.  If not, see http://www.gnu.org/licenses/


Editions JOCATOP
Route de Saint Saturnin
84310 MORIERES
FRANCE

Christophe Gossa
christophe.gossa@jocatop.fr
===================================================================
*/


#ifndef _WCHAR_T_DEFINED
typedef unsigned short wchar_t;
#define _WCHAR_T_DEFINED
#endif

void strkeeppath ( char * pszIO );


//Coupure des le premier caractere non ascii : 0...31
void strcutonlyascii ( char * psz );

//Coupure des le premier caractere non present dans la liste
void strcutonlylistchar ( char * psz, char * pszListChar );

//Suppression d'une chaine dans une autre
void strsupprstr ( char * pszIO, char * pszPattern );

//Suppression d'un caractere dans une chaine
void strsupprchar ( char * pszIO, char cChar );

//Suppression d'une liste de caracteres d'une chaine
void strsupprlistchar ( char * pszIO, char * pszListChar );

//Conservation d'une liste de caracteres d'une chaine
void strkeeplistchar ( char * pszIO, char * pszListChar );
    
//Passage en majuscule en detruisant les accents
char * strucase ( char * psz );
void strucasefast ( char * psz ); //Idem a strucase

//Remplacement d'une chaine par une autre
void strreplace ( char * pszIO, char * pszPattern, char * pszReplacement );

void strireplace ( char * pszIO, char * pszPattern, char * pszReplacement );

void strcreplace ( char * psz, char cOriginal, char cReplace );

long strucasecmp ( const char * pszSource, const char * pszTarget );

//Supprime tous les caracteres a droite identiques
void strsupprallright ( char * psz, char cChar );

//Renvoie la chaine en supprimant tous les caracteres a gauche
char * strsupprallleft ( char * psz, char cChar );

//Recuperation de l'extension d'un fichier d'une chaine (avec le point. Ex : "MonFichier.txt" => ".txt")
char * strgetfileextension ( char * pszSource );

//Recuperation du nom et de l'extension d'un fichier d'une chaine (avec le point. Ex : "C:\Mod\Ess\MonFichier.txt" => "MonFichier.txt")
char * strgetfilenameandextension ( char * pszSource );

//Recherche de donnees...
void * memmem ( void * pBuffer, void * pPattern, long lBufferLength, long lPatternLength );

//Conversion ASCII => WideChar
void str2wc ( wchar_t * pwcTarget, char * pszSource );

//idem a strstr mais sans le respect des accents
char * stristr ( char * pszString1, char * pszString2 );

//idem a strchr mais sans le respect des accents
char * strichr ( char * pszString, int cChar );

//La fonction isalpha
int strisalpha ( int iChar );

//The name is... use -1 or NULL for the second parameter
void strautopathcompletition ( char * pszPath, char cDefaultSeparator );

//Si ce n'est pas Windows, on renvoi stricmp vers strcasecmp...    
#ifndef _WIN32
    #define stricmp(a,b) strcasecmp(a,b)
#endif
